

#define MAXBUF (MAXSUB+2)

typedef enum Scaling {SC_EXACT,SC_ROUND,SC_OFF,SC_AXIS} Scaling;

typedef struct plotstruct{
   double last_xmin, last_xmax, last_ymin, last_ymax;
   double xmin, xmax, ymin, ymax, rmax;
   double xstart, xstep, ystart, ystep;
   int errorbars, autoaxis;
   enum Scaling scaling;   
   int zoomed;   
   int xtics, ytics;
   int selected[MAXBUF];
   char wdescript[80];
   char title[80];
   char xlabel[24], xformat[16];
   char ylabel[24], y2label[24], yformat[16];
}plotstruct;

plotstruct *get_plotconfig();

