      subroutine efg
      include 'comglb.for'      
      include 'compar.for'
      include 'comfrm.for'
      integer       i_array,icarr,irarr
      real          r_array,out,uveca,uvecb,uvecn,uveco,
     &              uvec,uvecv,uvec1,uvec2,uvec3,phipo,thepo,
     &              hi,dj,dum
      complex hc,dj1,dj2,d21
      character*132 helpar,queryar,chin,chcom,ch132,cp132,querytype,
     &              ext*16,chdf*80,ch1*1,ebi*2,ch2*2,c_array*4,
     &              form*7
      parameter (icarr=mc_scrd-2*maxcom*33-4*maxcom-5*33-22,
     &           irarr=mr_scrd-32-36-21-121-56-1)
      common/scrd/ i_array(mi_scrd),
     &             out(32),uveca(3,3),uvecb(3,3),uvecn(3,3),uveco(3,3),
     &             uvec(3),uvecv(3),phipo(3),thepo(3),
     &             uvec1(3),uvec2(3),uvec3(3),dj(-5:5,-5:5),hc,hi,
     &             dum,dj1(-1:1,-1:1),dj2(-1:1,-1:1),d21(-1:1,-1:1),
     &             r_array(irarr),
     &             helpar(maxcom),queryar(maxcom),ext(maxcom),       ! charact
     &             chin,chcom,ch132,cp132,querytype,
     &             chdf,ebi(3),ch2,c_array(icarr)

      logical b_term
      
      ia=0
      b_term=.false.
      ncl=npl
      do k=1,3
       do j=1,3
        uvecb(k,j)=0.0
       end do
      end do
      ebi(1)='ex'
      ebi(2)='ey'
      ebi(3)='ez'

      pi=4.0*atan(1.0)
      rad=pi/180.0

      lq=2
      lk=lq
      do k=1,lq
       ext(k)=' '
      end do
      chdf='eta'
      chdf(80:80)='#' 
      helpar(1)='effi/read/para/efgeuler'
      helpar(2)='effi/read/term/efgeuler'
      queryar(1)=
     & 'EFG,eta,phi,theta,psi from parameters (pi,...,pi+4)'
      queryar(2)='eta,phi,theta,psi from terminal'
      chin='input'
      call query(lq,lk,chin,chdf)
      if(lq.eq.0) return
      if(lq.eq.1) goto 10

      b_term=.true.
      querytype=' asymmetry parameter eta of the EFG eta='
      form='f9.4'
      chcom='effi/efg/etasign'
      value=0.0
      call askvalue(querytype,form,value,chcom,ncl,nrd,nwr)
      eta=value
      
 5     lq=2
       lk=lq
       do k=1,lq
        ext(k)=' '
       end do
       chdf='Euler'
       chdf(80:80)='#'
       helpar(1)='effi/read/efg/euler'
       helpar(2)='effi/read/efg/unitvectors'
       queryar(1)='Euler angles of the EFG-tensor'
       queryar(2)='unit vectors of the PAS of the EFG'
       chin='Euler angle/unitvectors'
       call query(lq,lk,chin,chdf)
       if(lq.eq.0) return
       if(lq.eq.2) goto 20

c      Euler angles        
       querytype=' Three Euler angles (alpha,beta,gamma):'
       chcom='effi/read/euler_angles'
       ch132='0,0,0'
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
       ch1=ch132(1:1)
       if(ch1.eq.'*'.or.ch1.eq.'q') return
       call trlch(80,ch132,nn,out)
       if(nn.ne.3) goto 5
       goto 15

 10    continue
       querytype=' parameter number of EFG pi='
       form='i3'
       chcom='effi/efg/eta/parnumber'
       value=0.0
       call askvalue(querytype,form,value,chcom,ncl,nrd,nwr)
       ia=value
       if(ia.eq.0.or.ia.gt.mp-3) then
        write(nwr,'(a)')'parameter number of eta out of range'
        goto 5
       end if        
       efgo=p(ia) 
       eta=p(ia+1)
       out(1)=p(ia+2)
       out(2)=p(ia+3)
       out(3)=p(ia+4)
       phiII=2.0*efgo/sqrt(1+eta**2/3)

       write(nwr,'(2(a,f9.4),a,3(f8.2,a1),/)')' EFG=',efgo,' eta=',eta,
     &         '     Euler angles =(',out(1),',',out(2),',',out(3),')'

       querytype='eta,phi,theta,psi are correct '
       ch1='y'
       chcom='effi/read/vector/transf'
       call yesno(querytype,ch1,chcom,npl,nrd,nwr)
      if(ch1.eq.'*'.or.ch1.eq.'q') return
      if(ch1.eq.'n') goto 10
       

 15    continue
       alpha=out(1)*rad
       beta=out(2)*rad
       gamma=out(3)*rad
       c2=cos(beta/2)**2
       s2=1.0-c2
       cp=cos(alpha+gamma)
       sp=sin(alpha+gamma)
       cm=cos(alpha-gamma)
       sm=sin(alpha-gamma)

       uvecb(1,1)= c2*cp-s2*cm
       uvecb(1,2)= c2*sp-s2*sm
       uvecb(1,3)=-sin(beta)*cos(gamma)

       uvecb(2,1)=-c2*sp-s2*sm
       uvecb(2,2)= c2*cp+s2*cm
       uvecb(2,3)= sin(beta)*sin(gamma)

       uvecb(3,1)= sin(beta)*cos(alpha)
       uvecb(3,2)= sin(beta)*sin(alpha)
       uvecb(3,3)= cos(beta)
c----------------------------------------------------------------
        call dewigner(1,beta,dj)
        do m=-1,1
         do n=-1,1
          fn=float(n)*gamma
          fm=float(m)*alpha
          d21(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
        end do

       uvecb(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
       uvecb(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
       uvecb(1,3)=-1./sqrt(2.)*real(d21(0,1)-d21(0,-1))

       uvecb(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
       uvecb(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
       uvecb(2,3)=-1./sqrt(2.)*aimag(d21(0,1)+d21(0,-1))

       uvecb(3,1)=-1./sqrt(2.)*real(d21(1,0)-d21(-1,0))
       uvecb(3,2)=1./sqrt(2.)*aimag(d21(1,0)+d21(-1,0))
       uvecb(3,3)=real(d21(0,0))

c----------------------------
       do k=1,3
        thepo(k)=arcos(uvecb(k,3))/rad
        h=1.0-uvecb(k,3)**2
        if(h.le.0.0) then
         phipo(k)=0.0
        else
         h=sqrt(h)
         phipo(k)=arcos(uvecb(k,1)/h)
         if(uvecb(k,2).lt.0) phipo(k)=2.0*pi-phipo(k)
        end if
        phipo(k)=phipo(k)/rad
       end do
       write(nwr,'(/,a)') 
     &    '     unit vectors  and polar angles of system SE in S'
      do k=1,3
       write(nwr,'(6x,a2,a,3(f8.3,a),2(f8.2,a1))')ebi(k),'=(',
     & uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')    ('
     &                                    ,thepo(k),',',phipo(k),')'
      end do
       
       
       goto 100             

c      unit vectors
 20    lp=2
       lj=lp
       do k=1,lp
        ext(k)=' '
       end do
       chdf='unit'
       chdf(80:80)='#'
       helpar(1)='effi/read/unitvector/numbers'
       helpar(2)='effi/read/unitvector/angle'
       queryar(1)='unit vectors:(*,y,z),(x,*,z) or (x,y,*)'
       queryar(2)='unit vectors: beta,phi'
       chin='unit vectors representation'
       call query(lp,lj,chin,chdf)
       if(lp.eq.0) return

       if(lp.eq.1) then
         querytype='one pair of unit vectors:'
         chcom='effi/read/unitvectors/format13'
         ch132='ex=(1,0,*) ez=(*,0,1)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
       else if(lp.eq.2) then
         querytype='one pair of unit vectors:'
         chcom='effi/read/unitvectors/format23'
         ch132='ex=(90,0) ez=(0,0)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
       end if

c      evaluation of ch132
       if(lp.eq.1) then
c       ch132='eax=(1,0,*) eaz=(*,0,1)'
        ibx=index(ch132,'ex')
        iby=index(ch132,'ey')
        ibz=index(ch132,'ez')

        i3=0
        if(ibx.gt.0) then
         ibc=index(ch132(ibx:),')')
         cp132=ch132(ibx+4:ibx+ibc-2)
c         write(6,'(a,a)')'vector ex=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uvecb(1,k)=uvec(k)
         end do
         i3=i3+1
        end if ! ibx

        if(iby.gt.0) then
         ibc=index(ch132(iby:),')')
         cp132=ch132(iby+4:iby+ibc-2)
c         write(6,'(a,a)')'vector ey=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uvecb(2,k)=uvec(k)
         end do
         i3=i3+1
        end if ! iby

        if(ibz.gt.0) then
         ibc=index(ch132(ibz:),')')
         cp132=ch132(ibz+4:ibz+ibc-2)
c         write(6,'(a,a)')'vector ez=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uvecb(3,k)=uvec(k)
         end do
         i3=i3+1
        end if ! ibz

        if(i3.lt.3.and.i3.gt.0) then
         if(i3.eq.1) then
          write(nwr,'(a)') 'at least two unit vectors eb neeeded'
          goto 20
         end if
         if(ibx.gt.0.and.iby.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(1,k)
           uvec2(k)=uvecb(2,k)
          end do
c         write(6,'(a,3f15.2)')'uvec1=',(uvec1(j),j=1,3)
c         write(6,'(a,3f15.2)')'uvec2=',(uvec2(j),j=1,3)
          call crospr(uvec1,uvec2,uvec3)
c         write(6,'(a,3f15.2)')'uvec3=',(uvec3(j),j=1,3)
          call crospr(uvec3,uvec1,uvec2)

          do k=1,3
           uvecb(3,k)=uvec3(k)
           uvecb(2,k)=uvec2(k)
          end do
         end if
         if(ibx.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(3,k)
           uvec2(k)=uvecb(1,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(2,k)=uvec3(k)
           uvecb(1,k)=uvec2(k)
          end do
         end if

         if(iby.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(2,k)
           uvec2(k)=uvecb(3,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(1,k)=uvec3(k)
           uvecb(3,k)=uvec2(k)
          end do
         end if
        end if

c        do k=1,3
c         write(6,'(3f15.2)')(uvecb(k,j),j=1,3)
c        end do

       else if(lp.eq.2) then
c        ch132='ex=(90,0) ez=(0,0)' 
c        write(6,'(a,a)')'angle ',ch132(:60)
         ibx=index(ch132,'ex')
         iby=index(ch132,'ey')
         ibz=index(ch132,'ez')

        i3=0
        if(ibx.gt.0) then
         ibc=index(ch132(ibx:),')')
         cp132=ch132(ibx+4:ibx+ibc-2)
c         write(6,'(a,a)')'angle ex=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uvecb(1,1)=st*cos(out(2)*rad)
         uvecb(1,2)=st*sin(out(2)*rad)
         uvecb(1,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! ibx

        if(iby.gt.0) then
         ibc=index(ch132(iby:),')')
         cp132=ch132(iby+4:iby+ibc-2)
c         write(6,'(a,a)')'angle ey=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uvecb(2,1)=st*cos(out(2)*rad)
         uvecb(2,2)=st*sin(out(2)*rad)
         uvecb(2,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! iby

        if(ibz.gt.0) then
         ibc=index(ch132(ibz:),')')
         cp132=ch132(ibz+4:ibz+ibc-2)
c         write(6,'(a,a)')'angle ez=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uvecb(3,1)=st*cos(out(2)*rad)
         uvecb(3,2)=st*sin(out(2)*rad)
         uvecb(3,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! ibz

c        write(6,'(a)')'uvecb(k,j),j=1,3)'
c        do k=1,3
c         write(6,'(3f15.2)')(uvecb(k,j),j=1,3)
c        end do

        if(i3.lt.3.and.i3.gt.0) then
         if(i3.eq.1) then
          write(nwr,'(a)') 'at least two unit vectors eb neeeded'
          goto 20
         end if
         if(ibx.gt.0.and.iby.gt.0) then

          do k=1,3
           uvec1(k)=uvecb(1,k)
           uvec2(k)=uvecb(2,k)
          end do

          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)

          do k=1,3
           uvecb(3,k)=uvec3(k)
           uvecb(2,k)=uvec2(k)
          end do
         end if
         if(ibx.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(3,k)
           uvec2(k)=uvecb(1,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(2,k)=uvec3(k)
           uvecb(1,k)=uvec2(k)
          end do
         end if
         if(iby.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(2,k)
           uvec2(k)=uvecb(3,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(1,k)=uvec3(k)
           uvecb(3,k)=uvec2(k)
          end do
         end if
        end if

       end if     ! lp
c      write(6,'(a)')'uvecb(k,j),j=1,3)'
c      do k=1,3
c       write(6,'(3f15.2)')(uvecb(k,j),j=1,3)
c      end do

 100   continue
       do k=1,3
        do i=1,3
         uveco(i,k)=uvecb(i,k)
        end do
       end do

c      cases of eta of the EFG
       iefg=1
       if(eta.lt.0.0) then

        if(eta.ge.-1) then
         do k=1,3
          uvecb(1,k)=uveco(2,k)
         end do
         do k=1,3
          uvecb(2,k)=uveco(1,k)
         end do
         do k=1,3
          uvecb(3,k)=-uveco(3,k)
         end do
         etan=-eta
        else if(eta.lt.-1.0.and.eta.gt.-3.) then
         do k=1,3
          uvecb(1,k)=uveco(2,k)
         end do
         do k=1,3
          uvecb(2,k)=uveco(3,k)
         end do
         do k=1,3
          uvecb(3,k)=uveco(1,k)
         end do
         etan=(3+eta)/(1-eta)
         iefg=-1 
        else if(eta.lt.-3.) then
         do k=1,3
          uvecb(1,k)=uveco(3,k)
         end do
         do k=1,3
          uvecb(2,k)=uveco(2,k)
         end do
         do k=1,3
          uvecb(3,k)=-uveco(1,k)
         end do
         etan=-(3+eta)/(1-eta)
         iefg=-1
        end if
       else if(eta.gt.1) then
        if(eta.gt.3.0)then
         do k=1,3
          uvecb(1,k)=uveco(3,k)
         end do
         do k=1,3
          uvecb(3,k)=uveco(2,k)
         end do
         do k=1,3
          uvecb(2,k)=uveco(1,k)
         end do
         etan=(-3+eta)/(1+eta)
         iefg=-1

        else if(eta.lt.3.0) then
         do k=1,3
          uvecb(1,k)=uveco(1,k)
         end do
         do k=1,3
          uvecb(2,k)=-uveco(3,k)
         end do
         do k=1,3
          uvecb(3,k)=uveco(2,k)
         end do
         etan=(3-eta)/(1+eta)
         iefg=-1

        end if
       else
        etan=eta
       end if

      do k=1,3
       do j=1,3
        uveca(k,j)=0.0
       end do
      end do
      uveca(1,1)=1.0
      uveca(2,2)=1.0
      uveca(3,3)=1.0

c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma
       h=0.0
       do k=1,3
        h=h+uveca(3,k)*uvecb(3,k)
       end do
       beta=arcos(h)
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(1,k)
        end do
        alpha=arcos(h)
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(2,k)
        end do
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(1,k)
         end do
         gamma=0.0
         alpha=arcos(-h)
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(2,k)
         end do
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(3,k)
         end do
         alpha=arcos(h/st)
         h=0.0
         do k=1,3
          h=h+uveca(2,k)*uvecb(3,k)
         end do
         if(h.lt.0.0) alpha=2.0*pi-alpha

         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(1,k)
         end do
         gamma=arcos(-h/st)
         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(2,k)
         end do
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0

       c2=cos(beta/2)**2
       s2=1.0-c2
       cp=cos(alpha+gamma)
       sp=sin(alpha+gamma)
       cm=cos(alpha-gamma)
       sm=sin(alpha-gamma)

       uvecn(1,1)= c2*cp-s2*cm
       uvecn(1,2)= c2*sp-s2*sm
       uvecn(1,3)=-sin(beta)*cos(gamma)

       uvecn(2,1)=-c2*sp-s2*sm
       uvecn(2,2)= c2*cp+s2*cm
       uvecn(2,3)= sin(beta)*sin(gamma)

       uvecn(3,1)= sin(beta)*cos(alpha)
       uvecn(3,2)= sin(beta)*sin(alpha)
       uvecn(3,3)= cos(beta)

       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad
       if(b_term) then 
        if(iefg.eq.-1) then 
         write(nwr,'(//,a,f9.4,a,3(f8.2,a1))')'EFG -> -EFG  eta=',
     &        etan,'     Euler angles =(',alpha,',',beta,',',gamma,')'
        else
         write(nwr,'(//,a,f9.4,a,3(f8.2,a1))')'             eta=',
     &        etan,'     Euler angles =(',alpha,',',beta,',',gamma,')'
        end if
       else
        write(nwr,'(//,2(a,f9.4),a,3(f8.2,a1))')' EFG=',iefg*efgo,
     &  ' eta=',etan,'     Euler angles =(',alpha,',',beta,',',gamma,')'
       end if
       do k=1,3
        thepo(k)=arcos(uvecn(k,3))/rad
        h=1.0-uvecn(k,3)**2
        if(h.le.0.0) then
         phipo(k)=0.0
        else
         h=sqrt(h)
         phipo(k)=arcos(uvecn(k,1)/h)
         if(uvecn(k,2).lt.0) phipo(k)=2.0*pi-phipo(k)
        end if
        phipo(k)=phipo(k)/rad
       end do
       write(nwr,'(/,a)') 
     &    ' new unit vectors  and polar angles of system SE in S'
      do k=1,3
       write(nwr,'(6x,a2,a,3(f8.3,a),2(f8.2,a1))')ebi(k),'=(',
     & uvecn(k,1),',',uvecn(k,2),',',uvecn(k,3),')    ('
     &                                    ,thepo(k),',',phipo(k),')'
      end do

      if(ia.gt.0) then
       p(ia)=float(iefg)*efgo
       p(ia+1)=etan
       p(ia+2)=alpha
       p(ia+3)=beta
       p(ia+4)=gamma
      end if

      write(nwr,'(/)')
      querytype='transformation of a vector to the new system '
      ch1='n'
      chcom='effi/read/vector/transf'
      call yesno(querytype,ch1,chcom,npl,nrd,nwr)
      if(ch1.eq.'*'.or.ch1.eq.'q') return
      if(ch1.eq.'n') goto 200

      lq=2
      lk=lq
      do k=1,lq
       ext(k)=' '
      end do
      chdf='pol'
      chdf(80:80)='#'
      helpar(1)='effi/read/para/vector'
      helpar(2)='effi/read/term/vector'
      queryar(1)=
     & 'polar angle theta,phi of a vector H from parameters (pi,pi+1)'
      queryar(2)='polar angle theta,phi from terminal'
      chin='input'
      call query(lq,lk,chin,chdf)
      if(lq.eq.0) return
      if(lq.eq.2) goto 110

 105  querytype='parameter number of polarangle theta pi='
      form='i3'
      chcom='effi/vector/theta/parnumber'
      value=0.0
      call askvalue(querytype,form,value,chcom,ncl,nrd,nwr)
      ia=value
      if(ia.eq.0.or.ia.gt.mp-1) then
       write(nwr,'(a)')'parameter number of theta out of range'
       goto 105
      end if   

      out(1)=p(ia)
      out(2)=p(ia+1)     

       write(nwr,'(/,a)') 
     &    '     vector H, polar angles in  system SE'
       write(nwr,'(6x,a,2(f8.2,a1),/)') 'e_H=(',
     &                                    out(1),',',out(2),')'

      querytype='theta,phi of vector H are correct '
      ch1='y'
      chcom='effi/read/vector/transf'
      call yesno(querytype,ch1,chcom,npl,nrd,nwr)
      if(ch1.eq.'*'.or.ch1.eq.'q') return
      if(ch1.eq.'n') goto 105
       
      goto 120
       
 110  continue

      querytype='polar angle theta,phi of a vector H:'
      chcom='effi/read/vector/polar'
      ch132='0,0'
      call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
      ch1=ch132(1:1)
      if(ch1.eq.'*'.or.ch1.eq.'q') return

      call trlch(30,ch132,nn,out)

 120  continue

      st=sin(out(1)*rad)
      uvec(1)=st*cos(out(2)*rad)
      uvec(2)=st*sin(out(2)*rad)
      uvec(3)=cos(out(1)*rad)
       
c      do k=1,3
c       h=0.0
c       do j=1,3
c        h=h+uvec(j)*uveco(j,k)
c       end do
c       uvec1(k)=h
c      end do
c      write(6,'(a,3f8.2,a1)')'vector in Sc: (',uvec1,')'

c      do k=1,3
c       h=0.0
c       do j=1,3
c        h=h+uvec1(j)*uvecn(k,j)
c       end do
c       uvecv(k)=h
c      end do
c      write(6,'(a,3f8.2,a1)')'vector in SE: (',uvecv,')'

      do i=1,3
       h=0.0
       do j=1,3
        do k=1,3
         h=h+uvec(j)*uveco(j,k)*uvecn(i,k)
        end do
       end do
       uvecv(i)=h
      end do

c     polar angle from coordinates      
      thepo(1)=arcos(uvecv(3))/rad
      h=1.0-uvecv(3)**2
      if(h.le.0.0) then
       phipo(1)=0.0
      else
       h=sqrt(h)
       phipo(1)=arcos(uvecv(1)/h)
       if(uvecv(2).lt.0.0) phipo(1)=2.0*pi-phipo(1)
      end if
      phipo(1)=phipo(1)/rad

       write(nwr,'(/,a)') 
     &    ' new vector H, polar angles in  system SE'
       write(nwr,'(6x,a,2(f8.2,a1))') 'e_H=(',
     &                                    thepo(1),',',phipo(1),')'

      if(ia.gt.0)then
       p(ia)=thepo(1)
       p(ia+1)=phipo(1)
      end if
 200  continue
      if(ia.gt.0) call calpl('test')
      return
      end

