c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              last version september 2004
      
      subroutine fr_neutron(cmch,iss,info)
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      
      integer     iss,info,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorRM,nstorTHyy,istorTH,idum
      character*4 cmch,c1_prp,c2_prp,c3_prp,cfill,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorRM,nstorTHyy,idum(5),
     &              istorTH,cfill(23)

      real          acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp
      common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp(icstrf-9)
      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp(ivstrf-10)
      logical       b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,b_v_shift,b_dumvsp
      common/bvstrf/b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &              b_v_shift,b_dumvsp(ivstrf-10)
      
      
      integer nchansp,k1,k2,i
c*****************************************************************************
c
      if(cmch.eq.'thna') then
       theoryname= 'Neutron source'
       thfrcase(1)='Neutron rocking curve(11)'
       thfrcase(2)='Neutron offspecular (smooth)(21)'
       thfrcase(3)='Neutron offspecular (roughness)(22)'
       thfrcase(4)=' '
       return
      end if              
c*****************************************************************************

      nchansp=channels  ! number of experimental data
      
      if(cmch.eq.'arr0') then      
        nstorTH=0
c       nstorFR    is now added inside EFFI
c       the pointer information (nstorFR numbers, strings)
c       about the theory ist stored in array_fr. The absolute address of the 
c       set is added by effi entering the set for the first time.
c       The 8 interger numbers (here) nstorTH,nstorRM,nstorTHyy,idum(5)
c       appear to be chaned by effi calling commands like pl,te,ft,...
c       (8 is the maximum number of pointers which can be precalculated 
c        setting up the theory)
        do i=1,5
         idum(i)=0
        end do       
c       The dummies idum will have the value of the absolute address of the set

        istorTH=int(v_ch/4.)*2              

c       2*istorTH is the number of theoretical values (real)
c       to be stored in array_fr (complex) at nstorTH+1,nstorTH+2, ... 
c       8*istorTH is the number of Rmatrix values (complex)
c       to be stored in array_fr (complex) at nstorRM+1, ... 

        nstorRM=nstorTH+istorTH             
        nstorTHyy=nstorRM+8*istorTH
c       nchansp/2 is number of theoretical values (real) calculated at the
c       experimental channel points to be stored n array_fr (complex)
c       at nstorTHyy+1, ...

        ifrsto=istorTH+8*istorTH+nchansp/2
c       ifrsto is the total number of complex values requested by the 
c       frame of the theory with the subroutines: 
c       fr_neutronrock,neutronglobal,plotneutron,neutronrock   

c      write(6,'(a,4i5)')'nstorTH,nstorRM,nstorTHyy=',
c     &                   nstorTH,nstorRM,nstorTHyy
       return
      else if(cmch.eq.'arri') then 
       ifrsto=0
       return   
      else if(cmch.eq.'extr') then
       ifrsto=0
       return
      end if
      
c      write(6,'(a,4i5)')'nstorTH,nstorRM,nstorTHyy=',
c     &                   nstorTH,nstorRM,nstorTHyy

c*****************************************************************************
      
      if(cmch.eq.'test') then
       k1=2
      else if(cmch.eq.'dfdp') then
       k1=3
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=4
      else if(cmch.eq.'plex') then
       k1=5
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=6
      end if
      
      goto (100,200,300,400,500,600),k1
c**********************************************************************
 100  continue
c     k1 > 0 input unit (file is opened in main program)
      i=int(scale)
      if(i.le.1) data_str='y,dy'
      if(i.ge.2) data_str='y,dy,x'
      return
c************************************************************************
c     'test': theory function is calculated ...
      
  200 continue
      k1=1
      call neutronglobal(k1,info)
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2

      call neutronglobal(k1,info)
      return
c****************************************************************************
c     subs, subt
  400 continue
      info=1
      infotext(1)='effi/structure/neutron/subspectra' 
      infotext(2)='subspectra command has no meaning'
      infotext(3)=' '
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,'          subtraction of subspectra'
      print *,'      has no meaning in the time domain'
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       k2=1  ! 0: only 1 plot and return, 1: interactive plot
       call xmosplo(k1,k2)

       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
      if(cmch.eq.'dmod') then
       call plotneutron(cmch)
      else  ! cmch='plot'
       if(b_theory) then
        k1=1
        call neutronglobal(k1,info)
       end if
       call plotneutron(cmch)
      end if
      
c**************************************************************************
      return
      end
      
      
      
      subroutine neutronglobal(n1,info)
c *****************************************************************
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none      
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for'
      
      
      integer     n1,info,idumst,ndumst,idum,
     &            nstorTH,nstorRM,nstorTHyy,istorTH
      character*4 cfill,frthname*64
      parameter(idumst=6+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/ndumst(idumst),frthname(2),
     &              nstorTH,nstorRM,nstorTHyy,idum(5),istorTH,cfill(23)

      real          acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp
      common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp(icstrf-9)
      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp(ivstrf-10)
      logical       b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,b_v_shift,b_dumvsp
      common/bvstrf/b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &              b_v_shift,b_dumvsp(ivstrf-10)
      
      
      logical b_total,b_residual
      integer idumscrt,idumsc,ib_df,kana,idfsum
      real    thyy,theoy,dfdp,ddpk,dfdpk,dather,ukk,dpudp,yth
      common/atos/thyy(maxn),theoy(maxn)
      parameter(idumscrt=maxscrt-5*maxn-5-maxn*maxpf-2*maxpf)
      common/scrt/dfdp(maxn),ddpk,ib_df,kana,
     &            dfdpk(maxn,maxpf),dather(maxn),idfsum(maxpf),
     &            ukk(maxpf),dpudp,
     &            yth(-maxn:2*maxn),idumsc(idumscrt)


      real x_exp,x_the,aintensityy,dx_the,dx_exp,xb_the,xb_exp,
     &     ff,hi
      common/ascale/  x_exp(maxn),x_the(maxn)
      character chcm*4
      integer nexp,nexp2,nthe,nthe2,mscale,invers,jshift,k1,j,k,i,ji

c      aintensityy=aintensity-background*channels
      aintensityy=aintensity

c      integral 0-inf is normalized to 1
      nexp=channels
      nexp2=nexp/2
      nthe=istorTH*2
      nthe2=istorTH
      
c      aintensityy=aintensityy/channels*istorTH
      mscale=scale
      dx_the=abs(v_end-v_beg)/(v_ch-1.0)
      dx_exp=abs(v_end-v_beg)/(channels-1.0)
      xb_the=v_beg+v_shift
      xb_exp=v_beg
      invers=0
      if(dx_the.lt.0) then
       invers=nexp+1
       dx_the=-dx_the
      end if
c     warning** xb_exp is not correct if x-data are read from file
c     it is correct after calling x_scale()
      jshift=abs(xb_the/dx_the)+1
      chcm='expe'

      if(ifrcase.eq.11) call neutronrock(b_total)
      if(ifrcase.eq.21) call neutronoffspecular(b_total)
      if(ifrcase.eq.22) call neutronOffspecRough(b_total)

c      write(6,'(a,L5,4i6)') 'neutronrock b_total=', b_total
      k1=n1
      goto (100,200,300),k1
      
      
 100  continue
c     calculation of thyy
     
      if(b_total.or.b_aintensity.or.b_background)then
       do j =1,nthe2
        yth(j)=real(array_fr(nstorTH+j))
        yth(j+nthe2)=aimag(array_fr(nstorTH+j))
       end do

       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do

       call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                    nthe,dx_the,xb_the,chcm)
c       write(6,'(8g12.5)') (x_exp(i),i=1,nexp,4)      

       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
        thyy(j)=ff*aintensityy+background
       end do
       do j=1,nexp2
        array_fr(nstorTHyy+j)=cmplx(thyy(j),thyy(nexp2+j))
       end do
      else
       do j=1,nexp2
         thyy(j)=real(array_fr(nstorTHyy+j))
         thyy(nexp2+j)=aimag(array_fr(nstorTHyy+j))
       end do
      end if
      b_theory=.true.
      return
      
 200  continue
      ib_df=0

c     variable background
      if(b_background) then
       b_residual=b_total.or.b_aintensity
       if(.not.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      nexp2=nexp/2
      do j=1,nexp2
       thyy(j)=real(array_fr(nstorTHyy+j))
       thyy(j+nexp2)=aimag(array_fr(nstorTHyy+j))
      end do
c     variable aintensity
      if(b_aintensity) then
       b_residual=b_total.or.b_background
       if(.not.b_residual) then
c       write(6,'(a)')  '   derivative of aintensity ------------'
        do j=1,nexp
         dfdp(j)=(thyy(j)-background)/aintensityy
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      
      call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)

      kana=0
      b_residual=b_total.or.b_aintensity.or.b_background
      if(.not.b_residual) then
       do j =1,nthe2
        yth(j)=real(array_fr(nstorTH+j))
        yth(j+nthe2)=aimag(array_fr(nstorTH+j))
       end do
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k)=yth(nthe)
       end do
       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
        dfdp(j)=(ff*aintensityy+background-thyy(j))/ddpk
       end do   ! j=1,nexp
       ib_df=1
       goto 250
      end if
      
      kana=0
      if(ifrcase.eq.11) call neutronrock(b_total)
      if(ifrcase.eq.21) call neutronoffspecular(b_total)
      if(ifrcase.eq.22) call neutronOffspecRough(b_total)
     
      do j =1,nthe2
       yth(j)=real(array_fr(nstorTH+j))
       yth(j+nthe2)=aimag(array_fr(nstorTH+j))
      end do

      do k=0,jshift
       yth(-k)=yth(1)
       yth(nthe+k)=yth(nthe)
      end do
     
      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
       dfdp(j)=(ff*aintensityy-thyy(j)+background)/ddpk
      end do   ! j=1,nexp
      ib_df=1
 250  continue
      return
      
 300  continue
c     calculation of thyy , not refreshing pl(j) by calpl
      if(.not.b_theory) goto 310 

      if(ifrcase.eq.11) call neutronrock(b_total)
      if(ifrcase.eq.21) call neutronoffspecular(b_total)
      if(ifrcase.eq.22) call neutronOffspecRough(b_total)
       call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                    nthe,dx_the,xb_the,chcm)

       do j =1,nthe2
        yth(j)=real(array_fr(nstorTH+j))
        yth(j+nthe2)=aimag(array_fr(nstorTH+j))
       end do

       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      
      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
       thyy(j)=ff*aintensityy+background
      end do
      do j=1,nthe
       ji=abs(invers-j)
       theoy(j)=yth(j)*aintensityy+background
      end do
      
 310  return
      end
      


      subroutine plotneutron(cmch)
      implicit none      
      include 'comglb.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'      

      integer     idumst,ndumst,istorTH
      character*4 cfill,cmch
      parameter(idumst=46+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/ndumst(idumst),istorTH,cfill(23)

c v_plotstr.h defines the extern structure: 
c#define MAXSP 16
c#define MAXSUB 8
c#define MAXN   1024
c#define MAXSUBN (MAXSUB*MAXN)
c#define MAXPLOT (MAXSUB+6)
c#define MDBPLFT (MAXN*36)
c#define IDUMPLOT (MDBPLFT*2-12*MAXN-MAXSUBN-MAXN-5*MAXPLOT-70)

c extern struct plot{
c      double xd[MAXN],yd[MAXN],yderr[MAXN],yres[MAXN],
c             xt[MAXN],yt[MAXN];
c      float  plotsub[MAXSUBN];
c      int    idat[MAXN],npntplot[MAXPLOT],nchanplot[MAXPLOT],n_subspectra;
c      char   namechan[4][MAXPLOT],kform[8][MAXPLOT],axisformat[16][3],
c             axes[24][3],title[132];
c      int    idumpl[IDUMPLOT];
c } plot;

      real*8 plotx,ploty,ploterry,plotres,plotxx,plotyy
      real plotsub
      integer      iplotx,npntplot,nchanplot,n_subspectra,maxsubn,
     &             idumplot,idumpl
      character    namechan*4,kform*8, axisformat*16,axesname*24,
     &             title*132,
     &             abscissa*24,ordinata*24
      parameter    (maxsubn=maxsub*maxn,
     &           idumplot=MDBPLFT*2-12*maxn-maxsubn-maxn-5*maxplot-70)
      common /plot/ plotx(maxn),ploty(maxn),ploterry(maxn),
     &              plotres(maxn),plotxx(maxn),plotyy(maxn),
     &              plotsub(maxsubn),
     &              iplotx(maxn),
     &              npntplot(maxplot),nchanplot(maxplot),n_subspectra,
     &              namechan(maxplot),kform(maxplot),axisformat(3),
     &              axesname(3),title,idumpl(idumplot)

      real          acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              ch_v,v_beg,v_end,dumcsp
      common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              ch_v,v_beg,v_end,dumcsp(icstrf-9)
      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs(ivstrf-10)
      
      integer     idumscrt
      real thyy,theoy,datx,errx,sym,subspectrum,daty,erry,dumsc
      common/atos/thyy(maxn),theoy(maxn)      
      parameter (idumscrt=maxscrt-5*maxn-maxn*maxsub)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),dumsc(idumscrt)

      logical b_1256,b_3478
      character chcm*4      
      integer mscale,nexp,nthe,ii,i,k,j,ns,nyy,ny,idcha,nresidue
      real x_exp,x_the,dx_exp,xb_exp,dx_the,xb_the,h,x_multiplier
      common/ascale/  x_exp(maxn),x_the(maxn)        
      dimension idcha(maxn)

      if(cmch.eq.'dmod') then
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='erry'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)='*'
      
       display_mode(1)='q-scale (th at x data =txd)'
       display_mode(2)='q-scale, residual aintensity (tdx)'
       display_mode(3)='channel scale, aintensity (tdx)'
       display_mode(4)='channel scale,residual aintensity (tdx)'
       display_mode(5)='q-scale (th all x =tx) '
       display_mode(6)='q-scale, residual aintensity (tx) '
       display_mode(7)='channel scale, aintensity (tx) '
       display_mode(8)='channel scale,residual aintensity (tx) '
       return
      end if
      
      b_1256=.false.
      b_3478=.false.
      if(ndisplay_mode.gt.8) ndisplay_mode=8
      goto(1,2,3,4,1,2,3,4), ndisplay_mode
c      display_mode(1)='q scale, log(count)'
 1    continue
      b_1256=.true.
      abscissa='Q[10^-2A^-1] .........'
      axisformat(1)='%6.2f '
      ordinata='log(count) '
      axisformat(2)='%6.2f '
      goto 5
c     display_mode(2)='q-scale, residual aintensity'
 2    continue
      b_1256=.true.
      abscissa='Q[10-2A-1] .........'
      axisformat(1)='%6.2f '
      ordinata='log(intensity) '
      axisformat(2)='%6.2f '
      goto 5
c     display_mode(3)='channel scale'
 3    b_3478=.true.
      abscissa='channel '
      ordinata='intensity '
      axisformat(1)='%6.0f '
      axisformat(2)='%8.0f '
      goto 5
c     display_mode(4)='-channel scale, residual aintensity'
 4    b_3478=.true.
      abscissa='channel '
      ordinata='intensity '
      axisformat(1)='%6.0f '
      axisformat(2)='%8.0f '
 5    continue
      

      if(b_1256) then
       kform(1)='f7.2'
       kform(2)='f8.4'
       kform(3)='f8.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
      end if
      if(b_3478) then
       kform(1)='f6.0'
       kform(2)='f10.0'
       kform(3)='f8.1'
       kform(4)='f8.1'
       kform(5)='f6.0'
       kform(6)='f10.0'
       kform(7)='f10.0'
      end if
      kform(8)='*'
      

      nexp=channels
      n_subspectra=n_subset

      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

      if(b_data) then
       do i=1,nexp
        daty(i)=data(mypt+i)
       end do
       do i=1,nexp
        erry(i)=data(mdypt+i)
       end do
      else
       do i=1,nexp
        b_datfit(i)=.true.
       end do
      end if
      
      nresidue=0
      do ii=1,maxplot
       nchanplot(ii)=0
      end do
      do ii=1,6
       npntplot(ii)=(ii-1)*maxn
      end do

c     if(b_theory) then
c      write(6,'(8g14.4)') (thyy(j),j=1,nexp,8)
c     else
c      write(6,'(8g15.4)') (daty(j),j=1,16)
c     end if
      mscale=scale
      if(ifrcase.eq.11) then
       x_multiplier=100.    
      else if(ifrcase.gt.20)then
       if(mscale.eq.1)then
        x_multiplier=1.    
       else
        x_multiplier=1000. 
       end if
      end if
      nthe=istorTH*2

      dx_the=abs(v_end-v_beg)/(ch_v-1.0)
      dx_exp=abs(v_end-v_beg)/(channels-1.0)
      xb_the=v_beg+v_shift
      xb_exp=v_beg

      do i=1,nexp
       iplotx(i)=0
      end do
      
      nyy=0
      ny=0
      if(b_1256) then
       chcm='thex'
       call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)

       if(b_data) then
        do ii=1,nexp
         if(b_datfit(ii)) then
          ny=ny+1
          iplotx(ny)=1
          plotx(ny)=dble(x_exp(ii)*x_multiplier) 
          h=abs(daty(ii))
          if(h.lt.0.1) then
           ploty(ny)=0.d0
           ploterry(ny)=1.d0
          else
           ploty(ny)=dble(alog(h))
           ploterry(ny)=dble(1./erry(ii))
          end if
         end if
        end do
        if(b_theory.and.(ndisplay_mode.eq.2.or.ndisplay_mode.eq.6)) then
         nresidue=1
         ns=0
         do ii=1,nexp
          if(b_datfit(ii)) then
           ns=ns+1
           plotres(ns)=dble(daty(ii)-thyy(ii))
          end if
         end do
        end if
       end if ! b_data

       if(b_theory) then
        if(ndisplay_mode.le.2) then
         nyy=nexp
         do ii=1,nexp
          plotxx(ii)=dble(x_exp(ii)*x_multiplier) 
          plotyy(ii)=dble(alog(abs(thyy(ii)+0.1)))
         end do
        else 
         nyy=nthe
         do ii=1,nthe
          plotxx(ii)=dble(x_the(ii)*x_multiplier) 
          plotyy(ii)=dble(alog(abs(theoy(ii)+0.1)))
         end do
        end if
        if(n_subset.gt.0) then
         do j=1,n_subset
          ns=(j-1)*nyy
          npntplot(6+j)=6*maxn+ns
          nchanplot(6+j)=nyy
          do ii=1,nyy
           ns=ns+1
           plotsub(ns)=alog(abs(subspectrum(ii,j)+0.1))
          end do
         end do
        end if
       end if  ! b_theory
      end if ! log scale
      
      
      if(b_3478) then
       chcm='thec'
       call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)
       if(b_data) then
        do ii=1,nexp
         if(b_datfit(ii)) then
          ny=ny+1
          iplotx(ny)=1
          plotx(ny)=dble(ii)
          ploty(ny)=dble(daty(ii))
          ploterry(ny)=dble(erry(ii))
         end if
        end do
        if(b_theory.and.(ndisplay_mode.eq.4.or.ndisplay_mode.eq.8))then
         nresidue=1
         ns=0
         do ii=1,nexp
          if(b_datfit(ii)) then
           ns=ns+1
           plotres(ns)=dble(daty(ii)-thyy(ii))
          end if
         end do
        end if
       end if ! b_data

       if(b_theory) then
        if(ndisplay_mode.le.4) then
         nyy=0
         do ii=1,nexp
          if(b_datfit(ii)) then
           nyy=nyy+1
           idcha(nyy)=ii
           plotxx(nyy)=dble(x_exp(ii))
           plotyy(nyy)=dble(thyy(ii))
          end if
         end do
        else
         k=1
         ii=1
         do while(.not.b_datfit(ii).and.ii.lt.nexp)         
           do while(x_the(k).lt.x_exp(ii))
            k=k+1
           end do
           ii=ii+1
         end do
c         write(6,'(a,i4)')' plot ii_max=',k
         nyy=0
         do ii=k,nthe            
           nyy=nyy+1        
           idcha(nyy)=ii
           plotxx(nyy)=dble(x_the(ii))
           plotyy(nyy)=dble(theoy(ii))
         end do
c         write(6,'(a,i4)')' plot nyy=',nyy
        end if
        if(n_subset.gt.0) then
         do j=1,n_subset
          ns=(j-1)*nyy
          npntplot(6+j)=6*maxn+ns
          nchanplot(6+j)=nyy
          do i=1,nyy  
            ii=idcha(i)         
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
          end do
         end do
        end if
       end if  ! b_theory
      end if ! counts

      if(b_data) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
      end if
      if(nresidue.eq.1) nchanplot(4)=ny
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
      end if
c      write(6,'(a,5i8)') 'nchanplot(ii)=',(nchanplot(ii),ii=1,6)
c      write(6,'(a,3i8)') 'plotx  nyy=',nyy
c      write(6,'(8g12.4)') (plotxx(ii),ii=1,nyy,8)
c      write(6,'(a,3i8)') 'plotyy  nyy=',nyy
c      write(6,'(8g12.4)') (ploty(ii),ii=1,nyy,8)
c      write(6,'(a,3i8)') 'ploterry ny=',ny
c      write(6,'(8g12.4)') (ploterry(ii),ii=1,ny,8)
      
      return
      end
      
