      subroutine frstr_neutron(l_nfrtheo,lstruct1,lstruct2,
     &                                   cmch,property)
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      integer l_nfrtheo,lstruct1,lstruct2
      character*132 ch132,property,cmch*4,chth*8
      integer igo,k,jm,jmb,jh,jc,jcb,l
       
      chth='fr'//property(1:6)
      
      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_nfrtheo=',l_nfrtheo,
     & ' subr= frstr_neutronrock  nameth_as=',nameth_as(:40)
      
      if(cmch.eq.'name') then
       l_nfrtheo=1        
c####################################################
       property='Neutron spectrum' 
       ntheory(1)  ='Neutron source'
c####################################################
       return
      end if

 
      chth='fr'//property(1:6)
      nstruct=' '

      igo=lstruct1+1
      if(igo.gt.2) igo=2
      goto(100,200) igo
c------------------------------------------------------------------------
 100  continue
c     common/acstrf/acsp,
c                   dwba,channels,scale,unit_sclB,unit_sclN,
c                   ch_v,v_beg,v_end,theta1,lambda
c                   v=q        for neutronrock
c                   v=theta2   for neutronoffspecular,neutronOffspecRoughness

      
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
      
c------------------------------------------------------------------------      

c      common/avsptrf/avsp,aintensity,background,
c                     Pxsi_b,Peta_b,Pzeta_b,
c     &               Pxsi_a,Peta_a,Pzeta_a,

c                     q_shift,q_min,phi_z            rock
c                     theta2_shift,fr_offspec,xi     off-spec
c                     theta2_shift,fr_offspec,xi,Ao  off-spec(roughness)

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c                    1        0         012345
      strtm(jm+1,1)='intensity                 1 1'
      strtm(jm+1,2)='total intensity of reflected neutrons'
      strth(jh+1,1)='intensity                 1.00e+6  0.0 0.0 1.0e4'
      strth(jh+1,2)='intensity                 1   1   '
      jm=jm+1
      jh=jh+1

      strtm(jm+1,1)='background                1 1'
      strtm(jm+1,2)='background of reflected neutrons per channel'
      strth(jh+1,1)='background                0.00  0.0 0.0 1.0'
      strth(jh+1,2)='background                2   1   '
      jm=jm+1
      jh=jh+1
      

      strtm(jm+1,1)='Poincare_beam             ## 3 3'
      strtm(jm+1,2)='Poincare vector of the neutron beam'
      strth(jh+1,1)='Pxsi_b                    0.0  0.0 1.0  0.05'
      strth(jh+2,1)='Peta_b                    0.0  0.0 0.0  0.05'
      strth(jh+3,1)='Pzeta_b                   1.0  0.0 0.0  0.05'
      strth(jh+1,2)='Pxsi_b                    3    1 0 0 '
      strth(jh+2,2)='Peta_b                    4    0 1 0 '
      strth(jh+3,2)='Pzeta_b                   5    0 0 1 '
      jm=jm+1
      jh=jh+3

      strtm(jm+1,1)='Poincare_analyser           ## 3 3'
      strtm(jm+1,2)='Poincare vector of the neutron analyser'
      strth(jh+1,1)='Pxsi_a                   0.0  0.0 1.0  0.05'
      strth(jh+2,1)='Peta_a                   0.0  0.0 0.0  0.05'
      strth(jh+3,1)='Pzeta_a                  0.0  0.0 0.0  0.05'
      strth(jh+1,2)='Pxsi_a                   6    1 0 0 '
      strth(jh+2,2)='Peta_a                   7    0 1 0 '
      strth(jh+3,2)='Pzeta_a                  8    0 0 1 '
      jm=jm+1

      strtm(jm+1,1)='#end#      8  seq'
      strtm(jm+2,1)='#beg#'
      
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      strcmt(0)=' 7  8  '
      strcmt(1)='  the scatterer may consist of several layers'
      strcmt(2)=
     &'       layer 1        __________________  scatterer (cover)'
      strcmt(3)='     _                                              '
      strcmt(4)=
     &'    \\  layer 2       __________________  scatterer'
      strcmt(5)=
     &' repetition                    ...                      '
      strcmt(6)=
     &'    /_ layer n-1      __________________  scatterer  '
      strcmt(7)=
     &'       layer n        __________________  scatterer (substrate)'
      
      strcmt(8)='scatterer        sc          ##n  1# '  ! mstruct1
      strcmt(9)=' '
      strcmt(10)='scatterer consists of incoherent parts '
      strcmt(11)='theory/'//chth//'/layer/scatterer'

      return
c-------------------------------------------------------------------------
 200  continue
      if(lstruct2.gt.0) goto 210
      
            if(cmch.eq.'hdbk') then
        nstruct=' '
       return
      end if
      
c      common/vfr1trf/ inc_frac,Hext,theta_He,phi_He

       strcmt(1)='scatterer_layer pj  l l1=co li=sw ln=su # 3 3'
c      l1=cover li=sandwich ln=substrate 
       strcmt(2)=
     & 'two letters for name of the scatterer (sr)'
c     & 'two letters for name of incoherent parts of the scatterer (sr)'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/scatterer/layer'

      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
C
C jm: number of the transformation matrix
C jh: number of parameter
C      
c                    1        0         012345
       strtm(jm+1,1)='H_extern                     # 3 3'
       strtm(jm+1,2)='external mag. field ||z at the scatterer'
       strth(jh+1,1)='Hext-z               0.00  0.0 0.0  1.0'
       strth(jh+2,1)='theta_He             90.0  0.0 0.0  1.0'
       strth(jh+3,1)='phi_He                0.0  0.0 0.0  1.0'
       strth(jh+1,2)='Hext-z                  2    1 0 0 '
       strth(jh+2,2)='theta_He                3    0 1 0 '
       strth(jh+3,2)='phi_he                  4    0 0 1 '
       jm=jm+1
       jh=jh+3

c       strtm(jm+1,1)='incoherent_fract             1 1'
c       strtm(jm+1,2)='area fraction treated incoherently'
c       strth(jh+1,1)='inc_frac                , 1.0  0.0 0.0  0.01'
c       strth(jh+1,2)='inc_frac                , 1  1 '
c       jm=jm+1

       strtm(jm+1,1)='#end#    4 '
       strtm(jm+2,1)='#beg#'
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      return
      
 210  continue
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
      
c     common/acfr2trf/ domain_yn,rep.grp
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      jcb=k
      if(l_nfrtheo.eq.2) then
       strco(jc+1)='domain_yn                1    0 '
       jc=jc+1
      end if
      strco(jc+1)='rep.grp                  2    1.1 '
              ! layer belongs to a group which repeat with period
      jc=jc+1
      strco(jc+1)='#end#  2   seq'
      strco(jc+2)='#beg#'

      do k=jcb,jc
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
      end do
      
c------------------------------------------------------------------------
c     common/avfr2trf/ thicklay,B_eff,theta_B,phi_B,
c                      ar_scatldens,ai_scatldens,roughness      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c     common/avfr2trf/ thicklay,B_eff,theta_B,phi_B,
c                      ar_scatldens,ai_scatldens,roughness
c                    1        0         012345
      strtm(jm+1,1)='thickn_lay                1 1'
      strtm(jm+1,2)='thickness of the layer'
      strth(jh+1,1)='thicklay             , 1.0  0.0 0.0  0.1'
      strth(jh+1,2)='thicklay                1    , 1  '
      jm=jm+1
      jh=jh+1
c                     1        0         012345
      strtm(jm+1,1)='B_average              , 3 3'
      strtm(jm+1,2)=' B_average of the layer  '
      strth(jh+1,1)='B_eff                 0.00  0.0 0.0  0.1'  
      strth(jh+2,1)='theta_B               0.0   0.0 0.0  0.1'  
      strth(jh+3,1)='phi_B                 0.0   0.0 0.0  0.1'  
      strth(jh+1,2)='B_eff                   2    1 0 0'
      strth(jh+2,2)='theta_B                 3    0 1 0'
      strth(jh+3,2)='phi_B                   4    0 0 1'  
     
      strtm(jm+2,1)='scatl_density           ,  2 2'
      strtm(jm+2,2)='scattering length density of the layer  '
      strth(jh+4,1)='r_scatldens              , 0.0000  0.0 0.0  0.1'
      strth(jh+5,1)='i_scatldens              , 0.0000  0.0 0.0  0.1'
      strth(jh+4,2)='r_scatldens              5    1 0'
      strth(jh+5,2)='i_scatldens              6    0 1 '
     
      strtm(jm+3,1)='roughness               ,# 1 1'
      strtm(jm+3,2)='roughness of the layer  '
      strth(jh+6,1)='roughness               , 0.0  0.0 0.0  0.1'
      strth(jh+6,2)='roughness                7    1 '
      jm=jm+3
      jh=jh+6
     
      strtm(jm+1,1)='#end#     7'
      strtm(jm+2,1)='#beg#'

      strcmt(1)='scatterer_layer   s       ,#  0  0'
      strcmt(2)=' '
      strcmt(3)=' '
      strcmt(4)='theory/'//chth//'/scatterer/layer/sites'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      return
      end
      

