      subroutine frstr_synchrotron(l_nfrtheo,lstruct1,lstruct2,
     &                                   cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character*132 ch132,property,cmch*4,chth*8

      chth='fr'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_nfrtheo=',l_nfrtheo,
     & ' subr= frstr_synchrotron  nameth_as=',nameth_as(:40)

      if(cmch.eq.'name') then
       l_nfrtheo=1        
c####################################################
       property='Synchrotron spectrum' 
       ntheory(1)  ='Synchrotron source'
c####################################################
       return
      end if

 
      chth='fr'//property(1:6)
      nstruct=' '

      igo=lstruct1+1
      if(igo.gt.2) igo=2
      goto(100,200) igo
c------------------------------------------------------------------------
 100  continue

c      common/acstrf/acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,t0_norm,




      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=4  seq=2 chth='//chth
       return
      end if



c------------------------------------------------------------------------
c     variables of frame theory: source,absorber and detector orientation
c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta


      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c                    1        0         012345
      strtm(jm+1,1)='counts                   1 1'
      strtm(jm+1,2)='frame parameter total counts'
      strth(jh+1,1)='counts            , 10000.0  0.0 0.0 10.0'! sum of counts
      strth(jh+1,2)='counts                   1    1   '

      strtm(jm+2,1)='background                ,## 1 1'
      strtm(jm+2,2)='frame parameter background'
      strth(jh+2,1)='background        , 0.0 0.0 0.0 1.0'  ! background/channel
      strth(jh+2,2)='background               2    1  '
      jm=jm+2
      jh=jh+2

      strtm(jm+1,1)='Poincare_vector           ## 3 3'
      strtm(jm+1,2)='Poincare vector of the Synchrotron beam'
      strth(jh+1,1)='P_xsi           , -1.0  0.0 1.0  0.05'
      strth(jh+2,1)='P_eta           , 0.0  0.0 0.0   0.05'
      strth(jh+3,1)='P_zeta          , 0.0  0.0 0.0   0.05'
      strth(jh+1,2)='P_xsi                     3    1 0 0 '
      strth(jh+2,2)='P_eta                     4    0 1 0 '
      strth(jh+3,2)='P_zeta                    5    0 0 1 '
      jm=jm+1
      jh=jh+3
      strtm(jm+1,1)='#end#      5  seq'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      if(l_nfrtheo.eq.1) then
      strcmt(0)=' 7  8  '
      strcmt(1)=
     &'  the forward scatterer may consist of several layers'
      strcmt(2)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(3)=
     &'       layer 1        __________________  absorber 1'
      strcmt(4)='     _                                              '
      strcmt(5)=
     &'    \\  layer 2       __________________  absorber 2'
      strcmt(6)=
     &' repetition                    ...                      '
      strcmt(7)=
     &'    /_ layer n        __________________  absorber n'

      strcmt(8)='forward_scatterer     sp          ##  1# ' ! mstruct1
      strcmt(9)=' '
      strcmt(10)='absorber  consists of incoherent parts '
      strcmt(11)='theory/'//chth//'/forward_scatterer/layer'
      end if

      if(l_nfrtheo.eq.2) then
      strcmt(0)=' 8  9  '
      strcmt(1)=
     & ' the scatterer (grazing) may consist of several layers and '
      strcmt(2)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(3)=
     &'       layer 1        __________________  scatterer (cover)'
      strcmt(4)='     _                                              '
      strcmt(5)=
     &'    \\  layer 2       __________________  scatterer'
      strcmt(6)=
     &' repetition                    ...                      '
      strcmt(7)=
     &'    /_ layer n-1      __________________  scatterer  '
      strcmt(8)=
     &'       layer n        __________________  scatterer (substrate)'

      strcmt(9)='grazing_scatterer        sc          ##  1# '  ! mstruct1
      strcmt(10)=' '
      strcmt(11)='scatterer consists of incoherent parts '
      strcmt(12)='theory/'//chth//'/grazing_scatterer/layer'
      end if


      return
c-------------------------------------------------------------------------
 200  continue
      if(lstruct2.gt.0) goto 210

      if(cmch.eq.'hdbk') then
        nstruct=' '
       return
      end if


c      common/cfr1trf/ inc_frac,Hext,thetaHe,phiHe,phi,theta,psi

      if(l_nfrtheo.eq.1) then
       strcmt(1)='forward_scatterer_layer  pj       l         #  1  1'
       strcmt(2)=
     & 'two letters for incoherent parts of the scatterer (fs)'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/forward_scatterer/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      end if
       if(l_nfrtheo.eq.2) then
       strcmt(1)='scatterer_layer  pj     l l1=co li=sw ln=su # 1 1'
       strcmt(2)=
     & 'two letters for name of incoherent parts of the scatterer (gs)'
c       strcmt(2)='l1=cover li=sandwich ln=substrate '
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/grazing_scatterer/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      end if
c      write(6,'(a,6i4)') 'frth ksthe(0,0-6)=',(ksthe(0,i),i=0,6)
c      write(6,'(a,6i4)') 'frth l_nfrtheo=',l_nfrtheo

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c                     123456789012345678901234567
       strtm(jm+1,1)='H_extern                     # 3 3'
       if(l_nfrtheo.eq.1) strtm(jm+1,2)=
     &              'external magnetic field at the absorber'
       if(l_nfrtheo.eq.2) strtm(jm+1,2)=
     &              'external magnetic field at the scatterer'
       strth(jh+1,1)='Hext            , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='thetaHe         , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='phiHe           , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                    2       1 0 0 '
       strth(jh+2,2)='thetaHe                 3       0 1 0 '
       strth(jh+3,2)='phiHe                   4       0 0 1 '
       jm=jm+1
       jh=jh+3
       if(l_nfrtheo.eq.1) then
        strtm(jm+1,1)='orientation                #  3 3'
        strtm(jm+1,2)='Euler angle of the absorber in the LAB'
        strth(jh+1,1)='phi             , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta           , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psi             , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phi                     5    1 0 0'
        strth(jh+2,2)='theta                   6    0 1 0'
        strth(jh+3,2)='psi                     7    0 0 1'
        jm=jm+1
        jh=jh+3
       end if
       strtm(jm+1,1)='incoherent_fract             1 1'
       strtm(jm+1,2)='area fraction treated incoherently'
       strth(jh+1,1)='inc_frac                 1.0  0.0 0.0  0.01'
       strth(jh+1,2)='inc_frac                 1  1 '

       jm=jm+1
       strtm(jm+1,1)='#end#    7 '
       strtm(jm+2,1)='#beg#'
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do


      return

 210  continue

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

c     common/acfr2trf/ repeat_group
c     common/avfr2trf/ thicklay,re_chilay,ai_chilay,roughness
      if(l_nfrtheo.ge.2) then
       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       jc=k-1
       jcb=k
       strco(jc+1)='rep.grp                  1    1.1 '
                ! layer belongs to a group which repeat with period
       strco(jc+2)='#end#  1   seq'
       strco(jc+3)='#beg#'
       jc=jc+1
       do k=jcb,jc
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do
      end if

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      if(l_nfrtheo.ge.2) then
c                    1        0         01234567
       strtm(jm+1,1)='thickn_lay                1 1'
       strtm(jm+1,2)='thickness of the layer'
       strth(jh+1,1)='thicklay        , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='thicklay                1    , 1  '
       jm=jm+1
       jh=jh+1
       strtm(jm+1,1) ='chi_electronic          , 2 2'
       strtm(jm+1,2) ='chi_electronic of the layer  '
       strth(jh+1,1)='r_chilay        , -14.50  0.0 0.0  0.1'  ! iron
       strth(jh+2,1)='i_chilay        ,   0.70  0.0 0.0  0.1'  ! iron'
       strth(jh+1,2)='r_chilay                2    1 0'
       strth(jh+2,2)='i_chilay                3    0 1'

       strtm(jm+2,1)='roughness                ,# 1 1'
       strtm(jm+2,2)='roughness of the layer  '
       strth(jh+3,1)='roughness        , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='roughness               4    1 '

       strtm(jm+3,1)='#end#    4'
       strtm(jm+4,1)='#beg#'
       jm=jm+3

       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do

       strcmt(1)='scatterer_layer   s       ,#  1  0'
       strcmt(2)=' '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='theory/'//chth//'/scatterer/layer/sites'
       strcmt(5)='distribution of parameters of site number'
      else

       strcmt(1)='scatterer_layer   s       ,#  1  1'
       strcmt(2)=' '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='theory/'//chth//'/scatterer/layer/sites'
       strcmt(5)='distribution of parameters of site number'
      end if

      return
      end





