      subroutine plotfold(cmch)

      include 'comglb.for'
      include 'comdat.for'
      include 'complt.for'

      integer maxsubn,
     &        iplotx,npntplot,nchanplot,n_subspectra
      real*8 plotx,ploty,ploterry,plotres,plotxx,plotyy,hd,resmin
      character*24 axesname,abscissa,ordinata,cmch*4,namechan*4,kform*8,
     &             axisformat*16,title*132
      parameter (maxsubn=maxsub*maxn,
     &           idumplot=MDBPLFT*2-12*maxn-maxsubn-maxn-5*maxplot-70)
      common /plot/ plotx(maxn),ploty(maxn),ploterry(maxn),
     &              plotres(maxn),plotxx(maxn),plotyy(maxn),
     &              plotsub(maxsubn),
     &              iplotx(maxn),
     &              npntplot(maxplot),nchanplot(maxplot),n_subspectra,
     &              namechan(maxplot),kform(maxplot),axisformat(3),
     &              axesname(3),title,idumpl(idumplot)

      common/acstrf/ dum1(5),
     &           channels,dum2(4),channels_vmax,dumcsp(icstrf-11)

      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,
     &              dumvsp(ivstrf-6)
      common/atos/thyy(maxn),theoy(maxn)

      logical b_vdarray
      parameter (maxn0=maxn+2,maxnh=maxn/2,
     &           mscrplot=8*maxn0+4*maxnh,
     &           idumscrt=maxscrt-3*maxn-maxn*maxsub-mscrplot)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            varray(maxn0),yarray(maxn0),yyarray(maxn0),
     &            v1array(maxn0),v3array(maxn0),vrarray(maxn0),
     &            vdarray(maxn0),irarray(maxnh),i0array(maxnh),
     &            i1array(maxnh),i2array(maxnh),resarray(maxn0),
     &            idumsc(idumscrt)
      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)


c      write(6,'(2a)')' plotfold cmch=',cmch
      if(cmch.eq.'dmod') then
       display_mode(1)='velocity scale'
       display_mode(2)='velocity scale, residual spectrum'
       display_mode(3)='channel scale'
       display_mode(4)='channel scale, residual spectrum'
       display_mode(5)=' '
       display_mode(6)=' '
       display_mode(7)=' '
       display_mode(8)=' '
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='erry'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)='*'
       return
      end if


      if(ndisplay_mode.lt.3) then
       kform(1)='f6.2'
       kform(2)='f10.6'
       kform(3)='f10.6'
       kform(4)='f10.6'
       kform(5)='f6.2'
       kform(6)='f10.6'
       kform(7)='f10.6'
      else
       kform(1)='f6.0'
       kform(2)='f10.0'
       kform(3)='f8.1'
       kform(4)='f10.1'
       kform(5)='f6.0'
       kform(6)='f10.0'
       kform(7)='f10.0'
      end if
       kform(8)='*'

      goto(1,2,3,4), ndisplay_mode
c       display_mode(1)='velocity scale'
 1     abscissa='mm/s'
       ordinata='relative transmission'
       axisformat(1)='%6.2f '
       axisformat(2)='%6.2f '
       goto 5
c       display_mode(2)='-velocity scale, residual spectrum'
 2     abscissa='mm/s'
       ordinata='relative transmission'
       axisformat(1)='%6.2f '
       axisformat(2)='%6.2f '
       goto 5
c       display_mode(3)='channel scale'
 3     abscissa='channel'
       ordinata='counts'
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       goto 5
c       display_mode(4)='-channel scale, residual spectrum'
 4     abscissa='channel'
       ordinata='counts'
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
 5     continue

       n_subspectra=n_subset
       nchansp=channels
       fold_point=channel_v0+channels_vmax
c      write(6,'(a,i4)') ' *****plotfold*********'
c      write(6,'(3(a,i6))') ' idumscr=',idumscr,'  maxscrt=',maxscrt
c       write(6,'(2(a,l5),a,i5)') ' b_data=',b_data,
c     &  '  b_theory=',b_theory,' n_subspectra=',n_subspectra
c       write(6,'(4(a,f10.3))') ' base=',base,'  geo=',geo,
c     &         '  fold=',fold_point,'  fresonant=',fresonant


c       if(b_theory) then

c       write(6,'(4e15.6)') (thyy(i),i=1,nchansp,64)
c       else
c         write(6,'(8f10.0)') (data(mypt+j),j=1,nchansp,16)
c         write(6,'(20L4)') (b_datfit(j),j=1,nchansp,16)
c       end if


      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory
      nresidue=0
      if(base.eq.0.) base=1.
      basepl=base
c      write(6,'(a,3f10.3)') ' velo(1,512)=',velocity(1),
c     &                 velocity(256),velocity(512)
c      write(6,'(a,3f10.3)') ' geof(1,512)=',geof(1),geof(256),geof(512)
c        do j=240,250
c         write(6,'(i4,4x,f15.6)') j,thyy(j)
c       end do

       ny=0
       nyy=0
       do ii=1,maxplot
        nchanplot(ii)=0
       end do
       do ii=1,6
        npntplot(ii)=(ii-1)*maxn
       end do


       if(b_data) then
        nbegin=0
        i=0
        do while(nbegin.eq.0.and.i.lt.nchansp)
         i=i+1
         if(b_datfit(i)) nbegin=i
        end do
        nend=0
        i=nchansp+1
        do while(nend.eq.0.and.i.gt.0)
         i=i-1
         if(b_datfit(i)) nend=i
        end do
        do i=1,nchansp
         varray(i)=velocity(i)
         iplotx(i)=0
        end do
        varray(nchansp+1)=varray(1)
        varray(nchansp+2)=varray(2)

        is1=sign(1.,varray(nbegin+1)-varray(nbegin))
        do ii=nbegin+1,nend
         is2=sign(1.,varray(ii+1)-varray(ii))
         if(is1*is2.lt.0) goto 9
        end do
 9      continue

        nsinglev=1                    ! double valued spectrum
        if(ii.gt.nend-2) nsinglev=-1  ! single valued  ''

c        write(6,'(a,2i6)') ' ndisplay_mode=',ndisplay_mode,nchansp
c        write(6,'(3(a,i4))') ' begin=',nbegin,' end=',nend,
c     & '  sigle_v=',nsinglev

        b_vdarray=.false.
        if(ndisplay_mode.le.2) then

         if(nsinglev.lt.0) then
          do ii=nbegin,nend
           if(b_datfit(ii)) then
            ny=ny+1
            iplotx(ny)=1
            plotx(ny)=dble(velocity(ii))
            ploty(ny)=dble(data(mypt+ii)/base)
            ploterry(ny)=dble(data(mdypt+ii)/base)
           end if
          end do

          if(b_theory) then
           do ii=nbegin,nend
            nyy=nyy+1
            plotxx(nyy)=dble(velocity(ii))
            plotyy(nyy)=dble(thyy(ii)/base)
           end do

           if(ndisplay_mode.eq.2) then
            nresidue=1
            ns=0
            do ii=nbegin,nend
             if(b_datfit(ii)) then
              ns=ns+1
              plotres(ns)=dble(ploty(ii)-plotyy(ii))
             end if
            end do
           end if

           if(n_subspectra.gt.0) then
            do j=1,n_subspectra
             ns=(j-1)*nyy
             npntplot(6+j)=6*maxn+ns
             nchanplot(6+j)=nend-nbegin+1
             do ii=nbegin,nend
              ns=ns+1
              plotsub(ns)=subspectrum(ii,j)/base
             end do
            end do
           end if
          end if   ! b_theory
          goto 200
         end if    !  nsinglev < 0

         sqrt2=sqrt(2.)
         base2=2*base
         basepl=base2
         l=3*int(log10(abs(v_max/nchansp*4.))*2.)
         glow=10**l
c        write(6,'(a,i4)') ' lower limit =',l
         if(b_theory) then
          do i=1,nchansp
           yyarray(i)=thyy(i)/geof(i)
          end do
          yyarray(nchansp+1)=thyy(1)/geof(1)
          yyarray(nchansp+2)=thyy(2)/geof(2)
         end if
         if(ndisplay_mode.eq.2) nresidue=1

         do i=1,nchansp
          resarray(i)=data(mypt+i)-thyy(i)
          yarray(i)=data(mypt+i)/geof(i)
         end do
         yarray(nchansp+1)=data(mypt+1)/geof(1)
         yarray(nchansp+2)=data(mypt+2)/geof(2)

         nh=nchansp/2.
         irh=int(fold_point)+1
         il=irh
         do ii=irh,irh+nh-1
          ir=ii
          if(ir.gt.nchansp) ir=ir-nchansp
          il=il+1
          vir=varray(ir)
          ivd=1
          il1=il+1
          vil1=varray(il+1)
          vil=varray(il)
          do while(ivd.gt.0)
           il2=il1
           il1=il
           vil2=vil1
           vil1=vil
           ivd=1

           if(vil2-vir.le.0)  ivd=-1
           if(vil2-vir.eq.0) goto 18

           if(vil1-vir.lt.0) then
            ivd=-ivd
           else if(vil1-vir.eq.0) then
            ivd=-1
           end if

   18      il=il-1
           if(il.lt.1) il=il+nchansp
           vil=varray(il)


          end do
          v1=vil-vil1
          v3=vil2-vil1
          vr=vir-vil1
          if(b_theory) then
           nyy=nyy+1
           irarray(nyy)=ir
           i0array(nyy)=il
           i1array(nyy)=il1
           i2array(nyy)=il2
           v1array(nyy)=v1
           v3array(nyy)=v3
           vrarray(nyy)=vr
           vdarray(nyy)=0.

           v1mv3=v1-v3
           det=v1*v3*v1mv3
           if(abs(det).gt.glow) then
            vdarray(nyy)=det
            b_vdarray=.true.
            y1=yyarray(il)
            y2=yyarray(il1)
            y3=yyarray(il2)
            y1=y1-y2
            y3=y3-y2
            y1=y1*v3
            y3=y3*v1
            aa=y1-y3
            bb=-y1*v3+y3*v1
            ff=vr*(vr*aa+bb)/det+y2
           else
            ff=yyarray(il1)
            b_vdarray=.false.
           end if
           plotxx(nyy)=dble(vir)
           plotyy(nyy)=dble((yyarray(ir)+ff)/base2)
          else
           b_vdarray=.false.
          end if  ! b_theory

          if(b_datfit(ir)) then
           y1=yarray(il)
           y2=yarray(il1)
           y3=yarray(il2)
           if(y1.ne.0..and.y2.ne.0..and.y3.ne.0.) then
            ny=ny+1
            iiii=ny/64
            if(b_vdarray) then
             y1=y1-y2
             y3=y3-y2
             y1=y1*v3
             y3=y3*v1
             aa=y1-y3
             bb=-y1*v3+y3*v1
             ff=vr*(vr*aa+bb)/det+y2
c            if(iiii*64.eq.ny) write(6,'(a,i4,f15.5)')
c    &       ' b_vdarray=true ny,ff=',ny,ff
            else
             ff=y2
c            if(iiii*64.eq.ny) write(6,'(a,i4,f15.5)')
c    &       ' b_vdarray=false ny,ff=',ny,ff
            end if
            iplotx(ny)=1
            plotx(ny)=dble(vir)
            ploty(ny)=dble((abs(yarray(ir))+abs(ff))/base2)
            ploterry(ny)=dble(sqrt2*data(mdypt+ir)/base2)
            if(ndisplay_mode.eq.2) plotres(ny)=dble(resarray(ir)/base2)
c           if(iiii*64.eq.ny) write(6,'(2(a,i4,f15.5))')
c     & '   ny,plotres(ny)=',ny,plotres(ny),' ir,base=',ir,base
           end if
          end if
         end do
c        ny plot points for the data
c        nyy plot points for the theory

         if(b_theory.and.n_subspectra.gt.0) then
          do j=1,n_subspectra
           do i=1,nchansp
            yyarray(i)=subspectrum(i,j)
           end do
           yyarray(nchansp+1)=yyarray(1)
           yyarray(nchansp+2)=yyarray(2)

           ns=(j-1)*nh
           npntplot(6+j)=6*maxn+ns
           nchanplot(6+j)=nh
           do ii=1,nh
            v1=v1array(ii)
            v3=v3array(ii)
            vr=vrarray(ii)
            det=vdarray(ii)
            ir=irarray(ii)
            il0=i0array(ii)
            il1=i1array(ii)
            il2=i2array(ii)
            if(det.ne.0.) then
             y1=yyarray(il0)
             y2=yyarray(il1)
             y3=yyarray(il2)
             y1=y1-y2
             y3=y3-y2
             y1=y1*v3
             y3=y3*v1
             aa=y1-y3
             bb=-y1*v3+y3*v1
             ff=vr*(vr*aa+bb)/det+y2
            else
             ff=yyarray(il1)
            end if
            ns=ns+1
            plotsub(ns)=(subspectrum(ir,j)+ff)/base2
           end do
          end do
         end if
        else     ! ndisplay_mode.le.2
         do i=nbegin,nend
          if(b_datfit(i)) then
           ny=ny+1
           iplotx(ny)=1
           plotx(ny)=dble(i)
           ploty(ny)=dble(data(mypt+i))
           ploterry(ny)=dble(data(mdypt+i))
          end if
         end do

         if(b_theory) then
          do i=nbegin,nend
           nyy=nyy+1
           plotyy(nyy)=dble(thyy(i))
           plotxx(nyy)=dble(i)
          end do
          if(ndisplay_mode.eq.4) then
           nresidue=1
           ns=0
           do ii=nbegin,nend
            if(b_datfit(ii)) then
             ns=ns+1
             plotres(ns)=dble(data(mypt+ii)-thyy(ii))
            end if
           end do
          end if
          if(n_subspectra.gt.0) then
           do j=1,n_subspectra
            ns=(j-1)*nyy
            npntplot(6+j)=6*maxn+ns
            nchanplot(6+j)=nend-nbegin+1
            do ii=nbegin,nend
             ns=ns+1
             plotsub(ns)=subspectrum(ii,j)
            end do
           end do
          end if
         end if  ! b_theory
        end if   ! ndisplay_mode.le.2
       else  ! b_data

        if(ndisplay_mode.le.2) then
         nyy=nchansp/2
         do i=1,nyy
          plotxx(i)=dble(velocity(i))
          plotyy(i)=dble(thyy(i)/base/geof(i))
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*nyy
           npntplot(6+j)=6*maxn+ns
           nchanplot(6+j)=nyy
           do i=1,nyy
            plotsub(ns+i)=subspectrum(i,j)/base/geof(i)
           end do
          end do
         end if
        else
         nyy=nchansp
         do i=1,nchansp
          plotxx(i)=dble(nyy-i+1)
          plotyy(i)=dble(thyy(i))
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*nyy
           npntplot(6+j)=6*maxn+ns
           nchanplot(6+j)=nyy
           do i=1,nyy
            plotsub(ns+i)=subspectrum(i,j)
           end do
          end do
         end if
        end if
       end if ! b_data

 200  continue

      if(nresidue.eq.1) then
        nchanplot(4)=ny
        resmin=0.d0
        do i=1,ny
         hd= plotres(i)-ploterry(i)           
         if(hd.lt.resmin) resmin=hd
        end do
        if(ndisplay_mode.eq.2) then
         hd=1.0d0-2.0d0*resmin        
        else if(ndisplay_mode.eq.4) then
         hd= dble(base)-2.0d0*resmin 
        end if
        do i=1,ny
         plotres(i)=plotres(i)+hd
        end do
      end if

      if(b_data) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
      end if
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
      end if

c     write(6,'(a,10i5)') ' nchanplot=',(nchanplot(ii),ii=1,8)
c      write(6,'(2(a,i4))')  ' ny=',ny,'    nyy=',nyy
c      write(6,'(a)')  ' j,plotx(j),ploty(j)'
c      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotx(j),ploty(j),j=1,ny,16)
c      write(6,'(a)')  ' j,plotres(j),ploty(j)'
c      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotres(j),ploty(j),j=1,ny,16)

      return
      end

      subroutine drive(mode_drive)

      include 'comglb.for'
      include 'comdat.for'
c      include 'comlc1.for'

      logical mode_nlin

      common/acstrf/ dum1(5),
     &           channels,dum2(4),channels_vmax,dumcsp(icstrf-11)

      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        dumvsp(ivstrf-11)

      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)

      nchansp=channels

c      write(6,'(a,f10.3)') ' ****--------*******drive v_max=',v_max
c      write(6,'(a,2f10.3)') ' drive_mode,channels_vmax=',
c     &                        drive_mode,channels_vmax
c     calculation  of velocity ,geo, dfdgeo
c     nchen mode = +1   triangular wave mode
c     nchen mode = +2   sine wave mode
c     nchen mode = +3   triangular wave mode with cosine correction :
c                   x = x - vmax2*cos(c2p*(x-fold_point2))-
c                           vmax3*cos(c2p*(x-fold_point3))-
c     nchen mode = +4   sine wave mode with cosine correction :
c                   x = x - vmax2*cos(c2p*(x-fold_point2))-
c                           vmax3*cos(c2p*(x-fold_point3))-
c
c      write(6,'(a,i4,5f10.3)') ' drive mode_drive,v_max=',
c     &                     mode_drive,v_max,channels_vmax,channel_v0


      iperiod=channels_vmax*2.0
      mode_nlin=.true.
      cp=3.141592/channels_vmax/2.0
      c2p=2.0*cp
      c3p=3.0*cp
      fold_point=channel_v0+channels_vmax
      fold_point2=vphase2+channels_vmax*2.0
      fold_point3=vphase3+channels_vmax*2.0

      goto (10,100,10,100,1000),mode_drive

c     triangular wave

   10 continue
      if(mode_drive.eq.3) mode_nlin=.true.

      period2=channels_vmax*4.0
      fptmchpd=channel_v0-channels_vmax
      fptpchpd=channel_v0+channels_vmax*3.0
      fptmpdh =channel_v0
      fptppdh =channel_v0+channels_vmax*2.0
      vmax_chan=v_max/channels_vmax

      do ii=1,nchansp
       x=ii
       if(x-fold_point.gt.0.)goto 30
c      left side
       if(x.gt.fptmchpd) goto 22
       x=x+period2
       goto 32
   22  c1=fptmpdh-x
       s=1.
       goto 40
c      right side
   30  if(x.lt.fptpchpd) goto 32
       x=x-period2
       goto 22
   32  c1=fptppdh-x
       s=-1.
   40  c4=s*vmax_chan
       vh=c4*c1
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-
     &                     v_max3*cos(c3p*(x-fold_point3))
       velocity(ii)=vh

       cx=vh/v_max
       c2=s*(cx**2-1.)
       c5=1.+geo*c2
       geof(ii)=1./c5**2
       dfdgeo(ii)=-2.*geof(ii)/c5*c2
      end do
      return
c
c     sine wave
c
  100 continue
      if(mode_drive.eq.4) mode_nlin=.true.
      do ii=1,nchansp
       x=ii
       arg=cp*(x-fold_point)
       vh=-v_max*cos(arg)
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-
     &                   v_max3*cos(c3p*(x-fold_point3))
       velocity(ii)=vh

       sx=sin(arg)
       c5=1.+geo*sx
       geof(ii)=1./c5**2
       dfdgeo(ii)=-2.*geof(ii)/c5*sx
      end do

 1000 continue
      return
      end



