      subroutine th_11indexsad(isubthe,icase,iput,iget)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

c     sad= source,absorber,detector : lstr1case=1,2,3
      
      integer isubthe,icase,iput,iget,dstr,istr,idex,
     &        lstr1case,idum1,idum2,nAS,nSC,idum
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),lstr1case,idum1,idum2,                   !13.9.05 
     &              nAS,nSC,idum(3),srw8,idex(7)      

      logical       b_vs,b_v_max,b_dumvsp
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5)


      real          c1,gamnat,flag_SAMP,flag_Voigt,dumcm
      common/acmaps/c1,gamnat,flag_SAMP,flag_Voigt,dumcm(icstrf-4)
      real          avm,shift,dumvm         
      common/avmaps/avm(2),shift,dumvm(ivstrf-3)
      logical       b_vm,b_shift,b_dumvm
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3)


      integer      i1,i2
      real         Eagd,rtr,w_Lorentz,w_Gauss
      dimension    w_Lorentz(maxjge),w_Gauss(maxjge)
      dimension    rtr(maxjge),Eagd(maxjge)
      
      integer    idumscrd
      parameter (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real      sTr,dumscrd
      complex   cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)
      
      logical   b_pc,b_Gauss
      integer   iflag_Voigt,i,j,n,ni,sk2,nst
      real      hr,hi,hti,srw
      complex   hc,hci

      
      if(isubthe.lt.0) then
       theoryname='1x1_ref_index_static_sad'
c      if(ak2.gt.sk2) then
c       nAS=sk2+ak2+ib2
c       nSC=sk2+ib2
c      else
c       nSC=sk2+ak2+ib2
c       nAS=ak2+ib2
c      end if
       if(-isubthe.eq.1) then
        c1=2*(nSC+1)+1
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       end if
       if(-isubthe.eq.2) c1=2*(nAS+1)
       if(-isubthe.eq.3) c1=2*(nSC+1)
       return
      end if
c      write(6,'(a,12f10.3)')'th_11refindex acmaps:',c1,gamnat
c      write(6,'(a,20f10.3)')'th_11refindex avmaps:',v1,(dumv(i),i=1,20)
      
c     storage use nst2_8 for 4 complex numbers of r_ik
      
      hci=cmplx(0.,1.)
      iflag_Voigt=flag_Voigt
      nst=4

c     only line positions are taken
c       write(6,'(a,2i4)') 'th_11refindex avsstrf 1 jge=',jge
c       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz      
       call get_theory(isubthe)
c       write(6,'(a,2i4)') 'th_11refindex avsstrf 2 jge=',jge
c       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz     

        b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1)
        if(.not.b_pc) then
         isubthe=-abs(isubthe)
         goto 400
        end if  
        isubthe=abs(isubthe)

       i1=iget+1
       jge=real(array_fr(i1))
       i2=i1+jge
       do i=1,jge
        Eagd(i)=real(array_fr(i1+i))+shift
        rtr(i)=aimag(array_fr(i1+i))
        w_Gauss(i)=real(array_fr(i2+i))
        w_Lorentz(i)=aimag(array_fr(i2+i))
       end do
c       write(6,'(8f10.3)') (Eagd(i),i=1,jge)
c       write(6,'(8f10.3)') (rtr(i),i=1,jge)
       b_Gauss=.true.
      
       goto(100,200,300),lstr1case
c-------------------------------------------------------------
      
 100   continue
c      source
c       write(6,'(a,i7)') 'ch_case(1:6).eq.source iput=',iput
        do n=iput+1,iput+(nSC+1)*2
         array_fr(n)=(0.,0.)
        end do
      
        srw=4.0*srw8
        do i=1,jge
         call aLORGAU(b_Gauss,Eagd(i),gamnat,srw,
     &                     w_Lorentz(i),w_Gauss(i),nSC,iflag_Voigt)
c        write(6,'(a,i2,a,6f12.4)')'i=',i,
c     &  'th_subrmoss gamnat,srw,w_Lorentz,w_Gauss=',
c     &    gamnat,srw,w_Lorentz(i),w_Gauss(i)
         do n=0,nSC
          ni=iput+2*n
          array_fr(ni+1)=array_fr(ni+1)+cmplx(0.,aimag(cLG(n))*rtr(i))
          array_fr(ni+2)=array_fr(ni+2)+cmplx(0.,aimag(cLG(-n))*rtr(i))
         end do       ! n loop
        end do        ! i=1,jge
      
c       write(6,'(a,2i6)') ' th_11ref - source, iput,nSC=',iput,nSC
c       write(6,'(4f15.6)') (rtr(i),i=1,jge)
c       write(6,'(6f12.6)') (aimag(array_fr(iput+i)),i=0,12)
      
c       The sum of the Lorentz-Gauss curves of the jge lines
c       have to be normalized to 1 for each subspectrum of the source
c       iscpi=iscpr+2*nSC+1
      
        do i=0,nSC
         ni=iput+2*i
         sTr(i)=aimag(array_fr(ni+1))
         sTr(-i)=aimag(array_fr(ni+2))
        end do
c       write(6,'(8f10.3)') (sTr(n),n=0,64)
      
c       write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',
c     &    sTr(i),sTr(-i),i=0,5)
      
        ni=iput+2*(nSC+1)+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
c       write(6,'(a,4i5)')'theomoss nAS,NSC,sk2=',nAS,NSC,sk2
c       write(6,'(8f10.3)') (array_fr(iscn+i),i=0,sk2,16)
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,a,2f15.8)') '----th=',ni,' hr/3.=',hr/3.
        
        end if
        goto 400
c----------------------------------------------------------
 200    continue
c       absorber
        do n=iput+1,iput+(nAS+1)*2
         array_fr(n)=0.
        end do
        srw=srw8*float(nst)
        do i=1,jge
         if(rtr(i).gt.1.e-5) then
          call aLORGAU(b_Gauss,Eagd(i),gamnat,srw,
     &                     w_Lorentz(i),w_Gauss(i),nAS,iflag_Voigt)
      
          hti=rtr(i)/2.0          ! ? donot remember why 30.6.05
          do n=0,nAS
           ni=iput+2*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           hc=conjg(cLG(-n))
           array_fr(ni+2)=array_fr(ni+2)-hc*hti
          end do       ! n loop
         end if
        end do        ! i=1,jge

c       write(6,'(a,2i6)') ' th_11ref - absorber, iput,nAS=',iput,nAS
c       write(6,'(4f15.6)') (rtr(i),i=1,jge)
c       write(6,'(6f12.6)') (aimag(array_fr(iput+i)),i=0,12)

       goto 400
c--------------------------------------------------------------
 300   continue
c       detector
      
        do n=iput+1,iput+(nSC+1)
         array_fr(n)=(0.,0.)
        end do
        do i=1,jge
         call aLORGAU(b_Gauss,Eagd(i),gamnat,srw8,
     &                         w_Lorentz(i),w_Gauss(i),nSC,iflag_Voigt)
         do n=0,nSC
          ni=iput+n+1
          array_fr(ni)=array_fr(ni)+
     &     cmplx(aimag(cLG(n)),aimag(cLG(-n)))*rtr(i)
         end do       ! n loop
        end do     ! i=1,jge
      
 400   return
        end
      

      subroutine th_11index(isubthe,icase,iput,iget)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'
c called by    stroboscopic transmission spectrum_3
c              stroboscopic reflection spectrum_3

      integer isubthe,icase,iput,iget,dstr,istr,idex,
     &        idum,nAS,idum1,nsampling,idum2,idum3
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),                                         !13.9.05 
     &              idum(3),nAS,idum1,nsampling,idum2,idum3,srw8,idex(7)      

      logical       b_vs,b_v_max,b_dumvsp
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5)


      real          c1,gamnat,dumcm
      common/acmaps/c1,gamnat,dumcm(icstrf-2)
      real          avm,shift,dumvm         
      common/avmaps/avm(2),shift,dumvm(ivstrf-3)
      logical       b_vm,b_shift,b_dumvm
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3)


      integer      i1,i2
      real         Eagd,rtr,w_Lorentz,w_Gauss
      dimension    w_Lorentz(maxjge),w_Gauss(maxjge)
      dimension    rtr(maxjge),Eagd(maxjge)
      
      integer    idumscrd
      parameter (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real      sTr,dumscrd
      complex   cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)
      
      logical   b_pc,b_Gauss
      integer   iflag_Voigt,i,n,ni
      real      hti,srw
      complex   hc,hci

      if(isubthe.lt.0) then
       theoryname='1x1_ref_index_static'
       c1=2*(nAS+1)
       return
      end if


c     storage use n_sampling=1,2,4,8 for 4 complex numbers of r_ik

      hci=cmplx(0.,1.)
      iflag_Voigt=1

       call get_theory(isubthe)
c       write(6,'(a,2i4)') 'th_11refindex avsstrf 2 jge=',jge
c       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz     

        b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1)
        if(.not.b_pc) then
         isubthe=-abs(isubthe)
         return
        end if  
        isubthe=abs(isubthe)

       i1=iget+1
       jge=real(array_fr(i1))
       i2=i1+jge
       do i=1,jge
        Eagd(i)=real(array_fr(i1+i))+shift
        rtr(i)=aimag(array_fr(i1+i))
        w_Gauss(i)=real(array_fr(i2+i))
        w_Lorentz(i)=aimag(array_fr(i2+i))
       end do
c       write(6,'(8f10.3)') (Eagd(i),i=1,jge)
c       write(6,'(8f10.3)') (rtr(i),i=1,jge)
       b_Gauss=.true.
c      b_trans=.true.



        do n=iput+1,iput+(nAS+1)*2
         array_fr(n)=(0.,0.)
        end do
        srw=srw8*float(nsampling)
        do i=1,jge
         if(rtr(i).gt.1.e-5) then
          call aLORGAU(b_Gauss,Eagd(i),gamnat,srw,
     &                     w_Lorentz(i),w_Gauss(i),nAS,iflag_Voigt)

c         write(6,'(a,2i4)')' nAS,iflag_Voigt=',nAS,iflag_Voigt
c         write(6,'(6g12.4)') (cLG(j),j=-5,5),       
c     &          srw,gamnat,w_Lorentz(1),w_Gauss(1)     

          hti=rtr(i)/2.0
          do n=0,nAS
           ni=iput+2*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           hc=conjg(cLG(-n))
           array_fr(ni+2)=array_fr(ni+2)-hc*hti
          end do       ! n loop
         end if
        end do        ! i=1,jge
c        write(6,'(8f12.4)')(array_fr(iput09+i+1),i=0,2*nAS)
c       write(6,'(a,2i6)') ' theory9 - absorber,iput09=',iput09,nAS
c       write(6,'(6f12.6)') (aimag(array_fr(iput09+ii)),ii=0,nAS,16)

      return
      end



