      subroutine th_lines126(isubthe,icase,iput,iget)
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer        isubthe,icase,iput,iget
      real           avm,w_Gauss,w_Lorentz,fr_int,pos,dumvm                           
      common/avmaps/ avm,w_Gauss(8),w_Lorentz(8),fr_int(8),pos(8),
     &               dumvm(ivstrf-33)
      logical        b_vm,b_dumvm      
      common/bvmaps/ b_vm,b_dumvm(ivstrf-1)
      real           c1,dumcm
      common/acmaps/ c1,dumcm(icstrf-1)

      real    Eagd(maxjge),rtr(maxjge)

      if(isubthe.lt.0) then
       theoryname='singlet_doublet_sextet'
       if(icase.eq.1) jge=1
       if(icase.eq.2) jge=2
       if(icase.eq.3) jge=6
       c1=2*jge+1
       return
      end if
      
c     write(6,'(a,4i6,a)')'th_lines126 isubthe,icase,iput,iget=',
c    &                isubthe,icase,iput,iget,' ###########'
      
c      write(6,'(a,i4)') 'th_lines126 avsstrf:: icase=',icase
c      write(6,'(10f10.2)')avss 
c      write(6,'(10f10.2)')fr_int 
c      write(6,'(10f10.2)')pos 
      if(b_vm) then
       if(icase.eq.1) then
        jge=1
        rtr(1)=1.0
        Eagd(1)=0.0
       else
        if(icase.eq.2) jge=2
        if(icase.eq.3) jge=6
        do k=1,jge
         rtr(k)=fr_int(k)
         Eagd(k)=pos(k)
        end do
       end if
       i1=iput+1
       i2=i1+jge
c       write(6,'(a,i8)') 'th_lines126 i1=',i1
       array_fr(i1)=cmplx(float(jge),0.0)
       do i=1,jge
        array_fr(i1+i)=cmplx(Eagd(i),rtr(i))
        array_fr(i2+i)=cmplx(w_Gauss(i),w_Lorentz(i))          
       end do
      else
       isubthe=-abs(isubthe)
      end if 

      return
      end

      subroutine th_hdeqmiscellaneous(isubthe,icase,iput,iget)

      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'
      
      integer isubthe,icase,iput,iget
      
      
      real           avm,w_Gauss,w_Lorentz,fr_int,
     &               aH,thetaH,phiH,DEq,eta,dumvm                           
      common/avmaps/ avm,w_Gauss(8),w_Lorentz(8),fr_int(8),
     &               aH,thetaH,phiH,DEq,eta,dumvm(ivstrf-30)
      logical        b_vm,b_dumvm      
      common/bvmaps/ b_vm,b_dumvm(ivstrf-1)

      integer       dumcm
      common/acmaps/c1,cTms,
     &              ajg,aje,amueg,amuee,QgdQe,r_E2M1,dumcm(icstrf-8)

c---------------------------------------------------------------------      
      complex efgPAS(-2:2),Vm(-1:1,maxjge),hvE(-1:1),hc1
      integer i8,indx
      dimension i8(8),indx(maxjge)
      real      Eagd(maxjge),rtr(maxjge),arrin(maxjge),
     &          gauss(maxjge),lorentz(maxjge)
c---------------------------------------------------------------------
      


      jge=(2.*ajg+1)*(2.*aje+1)+0.01

       lint=0
       if(icase.gt.1) then
        lint=jge
        if(lint.gt.8)lint=8
       end if

       if(isubthe.lt.0) then
        theoryname='Hi_DEQ_miscellaneous'
        c1=1+jge+lint
        return
       end if
      
c      write(6,'(a)')' th_hdeqmiscellaneous avsstrf ::'
c      write(6,'(10f10.3)')avss,fr_int,aH,thetaH,phiH,DEq,eta

      if(.not.b_vm) then
       isubthe=-abs(isubthe)
       return
      end if



      
c--------------------------------------------------------------------------
c      eQVzz=DEq/sqrt(1.+eta**2/3.)*2.
c       efgm are the spherical tensor
c       components of the EFG in the PAS
c       efg-2=efg2 , efg+1=efg-1=0
      
      pi=atan(1.)*4.
      rad=atan(1.)/45.
      
      eQVzz=DEq/sqrt(1.+eta**2/3.)*2.
      efg0=eQVzz/2.
      efg2=eta*efg0/sqrt(6.)
      
c     write(6,'(a,5f12.6)') '  efg=', eQVzz,eta,phiE,thetaE,psiE
c      write(6,'(a,5f12.6)') '    H=',aH,thetaH,phiH
c      write(6,'(a,5f12.6)') '    A=',phiAL,thetaAL,psiAL
      
      efgPAS(0)=cmplx(efg0,0.0)
      efgPAS(-1)=(0.,0.)
      efgPAS(1)=(0.,0.)
      efgPAS(-2)=cmplx(efg2,0.)
      efgPAS(2)=cmplx(efg2,0.)
      
c     magnetic field parameter
      
      hvE(1) =-cmplx(cos(phiH*rad),sin(phiH*rad))*
     &                  sin(thetaH*rad)/sqrt(2.0)*aH
      hvE(0) = cmplx(cos(thetaH*rad),0.0)*aH
      hvE(-1)=-conjg(hvE(1))

      Lp=1
      call symbol3j(aje,Lp,ajg) 
      call hamJgJe(amueg,amuee,QgdQe,cTms,hvE,efgPAS,arrin,Vm)
      call INDEXX(jge,arrin,indx)
      
      do ii=1,jge
       i=indx(ii)
       hc1=Vm(1,i)*conjg(Vm(1,i))+
     &       Vm(0,i)*conjg(Vm(0,i))+
     &       Vm(-1,i)*conjg(Vm(-1,i))
       rtr(ii)=real(hc1)/3.0
       Eagd(ii)=arrin(i)
       gauss(ii)=w_Gauss(1)
       lorentz(ii)=w_Lorentz(1)
      end do   ! i=1-jge
c      write(6,'(a)')'(Eagd(i),i=1,jge)'
c      write(6,'(8f8.4)')(Eagd(i),i=1,jge)
c     write(6,'(a,8f8.4)')'rtr =',(rtr(i),i=1,jge)

      if(icase.gt.1) then
       do i=1,lint
        arrin(i)=i
       end do
       if(jge.gt.lint) then
        call INDEXX(jge,rtr,indx)
c       write(6,'(a,8i3)')'1 indx=',(indx(i),i=1,jge)
        do i=1,lint
         i8(i)=indx(jge+1-i)
        end do
c       write(6,'(a,8i3)')'i8=',(i8(i),i=1,lint)
      
        do i=1,lint
         arrin(i)=i8(i)
        end do
        call INDEXX(lint,arrin,indx)
c       write(6,'(a,8i3)')'2 indx=',(indx(i),i=1,lint)
        do ii=1,lint
         arrin(ii)=i8(indx(ii))
        end do
        if(icase.eq.3) then
         do ii=1,lint
          i=int(arrin(ii))
          rtr(i)=fr_int(ii)
          gauss(i)=w_Gauss(ii)
          lorentz(i)=w_Lorentz(ii)
         end do
        end if
c       write(6,'(a,8f8.4)')'Eagd=',(Eagd(i),i=1,jge)
c       write(6,'(a,8f8.4)')'rtr =',(rtr(i),i=1,jge)
       else
        if(icase.eq.3) then
         do k=1,jge
          rtr(k)=fr_int(k)
          gauss(k)=w_Gauss(k)
          lorentz(k)=w_Lorentz(k)
          end do
        end if
       end if
      end if


      i1=iput+1
      i2=i1+jge
      array_fr(iput+1)=cmplx(float(jge),0.0)
      do i=1,jge
       array_fr(i1+i)=cmplx(Eagd(i),rtr(i))
       array_fr(i2+i)=cmplx(gauss(i),lorentz(i))
      end do

      return
      end

