      subroutine th_22indexfsad(isubthe,icase,iput,iget)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      
c     sad= source,absorber,detector : lstr1case=1,2,3

      integer isubthe,icase,iput,iget,istr,dstr,idex,
     &        lstr1case,idum1,nLG,nAS,nSC,idum2,ak8,sk8
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),lstr1case,idum1,                         !13.9.05 
     &              nLG,nAS,nSC,idum2,ak8,sk8,srw8,idex(7)       

      
      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)

c     storage use nst2_8 for 4 complex numbers of r_ik
      real          c1,gamnat,flag_SAMP,flag_Voigt,dumc
      common/acmaps/c1,gamnat,flag_SAMP,flag_Voigt,dumc(icstrf-4)
      real          avm,sftr,aisom,w_Gauss,w_Lorentz,dumv
      logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,b_dumv
      common/avmaps/avm,sftr,aisom,w_Gauss,w_Lorentz,dumv(ivstrf-5)
      common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,
     &              b_dumv(ivstrf-5)



         
      integer     idumscrd
      parameter  (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real        sTr,dumscrd
      complex     cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)

      logical   b_pc,b_Lorentz,b_Gauss,b_trans,b_polisp,bxx
      
      integer   nE,iflag_SAMP,iflag_Voigt,jge,jn,ip,
     &          i,j,k,l,n,ni,nd,nn,npow,n_pow,nloop,n_loop,ii,
     &          iposLG,sk2,nst
      
      real      Eagd,hr,hi,hti,sqrt2,satrace_r,satrace_i,
     &          azz,d_x2,aszz,dsx2,fd,srw
      
      complex   sapp_p,sapm_p,samp_p,satrace_p,
     &          sapp_m,sapm_m,samp_m,satrace_m,
     &          hrtr,hrpm,ctr,cpm,cmp,hc,hci,
     &          Rmatrix(2,2),TSPCA(2,2),sph(2,2)
      

      b_polisp=.false.
      if(icase.eq.1) b_polisp=.true.

      if(isubthe.lt.0) then
       theoryname='2x2_ref_index_static_f_sad'
       if(ifrcase.eq.3.or.ifrcase.eq.4) then
        i=2
        if(b_polisp) i=4
        if(-isubthe.eq.1) then
         c1=i*(nSC+1)+1
         if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
        end if
        if(-isubthe.eq.2) then
         c1=2*(nAS+1)
         if(b_polisp)c1=c1*4
        end if
        if(-isubthe.eq.3) c1=i*(nSC+1)
       end if
       if(ifrcase.eq.5) then
         c1=2*(nAS+1)
         if(b_polisp) c1=c1*4
        end if
c        write(6,'(a,f10.2,2i3)') 'th_22refindexf c1,ifrcase,isubthe=',
c     &    c1,ifrcase,isubthe
       return
      end if
c       write(6,'(a,6f10.2)') 
c     &  'th_22refindexf avss,sftr,aisom,w_Gauss,w_Lorentz=',
c     &                  avss,sftr,aisom,w_Gauss,w_Lorentz

      hci=cmplx(0.,1.)
      iflag_SAMP=flag_SAMP
      iflag_Voigt=flag_Voigt
      
      nst=4

      b_trans=.true.
      if(ifrcase.eq.5) then
       b_trans=.false.
c      transformation matrix from spherical basis to (sigma,pi)-basis
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)
      end if

      call get_theory(isubthe)
c       write(6,'(a,5f10.4,/,50x,5l5)') 
c     &  'th_22refindexf avss,sftr,aisom,w_Gauss,w_Lorentz=',
c     &                  avss,sftr,aisom,w_Gauss,w_Lorentz,
c     &             b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz

      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.b_w_Lorentz.or.isubthe.gt.0
      if(.not.b_pc) then
       isubthe=-abs(isubthe)
       goto 400
      else
        isubthe=abs(isubthe)
      end if  
      goto (100,200,300),lstr1case
c---------------------- source ------------------------------------
      
 100  continue
      n_pow=real(array_fr(iget+1))
      n_loop=aimag(array_fr(iget+1))
      jge=real(array_fr(iget+2))
      bxx=aimag(array_fr(iget+2)).gt.0.01
      
      do npow=1,n_pow
       ip=iget+2+(npow-1)*3*jge*n_loop
       do jn=ip+1,ip+jge*3-2,3
        Eagd=real(array_fr(jn))+aisom
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')
     &    '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'
       end do   ! jn=
      end do   ! npow=1,n_pow
    
      b_Lorentz=b_w_Lorentz
      b_Gauss=b_w_Gauss

      if(iflag_SAMP.eq.1) then
     
       call cLORGAU(b_Lorentz,b_Gauss,
     &       gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)
      
c       write(6,'(a,2L5,i6,/,4f12.5)')
c     & ' *source* b_Lorentz,b_Gauss,iposLG,array_fr(iposLG,+1)=',
c     & b_Lorentz,b_Gauss,iposLG,array_fr(iposLG),array_fr(iposLG+1)
      
      
       do n=0,nSC

        if(b_polisp) then
         ni=iput+4*n
     
         satrace_p=(0.,0.)
         sapm_p=(0.,0.)
         satrace_m=(0.,0.)
         sapm_m=(0.,0.)

         do npow=1,n_pow
          ip=iget+2+(npow-1)*3*jge*n_loop

          do jn=ip,ip+jge*3-3,3
           nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)
            
           if(n_loop.gt.1) then
            hrtr=(0.,0.)
            hrpm=(0.,0.)
            do nloop=1,n_loop
             ii=ip+(nloop-1)*jge*3
             if(bxx) then
              aszz=aimag(array_fr(ii+1))
              dsx2=aimag(array_fr(ii+2))
              azz =aimag(array_fr(ii+3))
              d_x2=aimag(array_fr(ii+4))
              fd=exp(-azz*d_x2-aszz*dsx2)
              hrtr=hrtr+array_fr(jn+2)*fd 
              hrpm=hrpm+array_fr(jn+3)*fd           
             else
              fd=exp(-aimag(array_fr(ii+5)))
              hrtr=hrtr+array_fr(jn+2)*fd 
              hrpm=hrpm+array_fr(jn+3)*fd    
             end if
            end do
           else
            if(bxx) then
             aszz=aimag(array_fr(ii+1))
             dsx2=aimag(array_fr(ii+2))
             azz =aimag(array_fr(ii+3))
             d_x2=aimag(array_fr(ii+4))
             fd=exp(-azz*d_x2-aszz*dsx2)
            else
             fd=exp(-aimag(array_fr(ii+5)))
            end if
            hrtr=array_fr(jn+2)*fd 
            hrpm=array_fr(jn+3)*fd           
           end if
           
           nd=abs(4*n-nE)
           if(nd.le.nLG) then
c           Sum;ab rpq(ab)/2*LG(E-Eab)  LG(E-Eab) on 1,3,...,2n+1
            hi=aimag(array_fr(iposLG+nd))
            satrace_p=satrace_p+hi*hrtr
            sapm_p=sapm_p+hi*hrpm
           end if

           nd=abs(-4*n-nE)
           if(nd.le.nLG) then
            hi=aimag(array_fr(iposLG+nd))
            satrace_m=satrace_m+hi*hrtr
            sapm_m=sapm_m+hi*hrpm
           end if

          end do     ! jn=jge
         end do      ! n_pow
         array_fr(ni+1)=satrace_p
         array_fr(ni+2)=sapm_p
         array_fr(ni+3)=satrace_m
         array_fr(ni+4)=sapm_m
        else
         ni=iput+2*n
     
         satrace_p=(0.,0.)
         satrace_m=(0.,0.)

         do npow=1,n_pow
          ip=iget+2+(npow-1)*3*jge*n_loop

          do jn=ip,ip+jge*3-3,3
           nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)
            
           if(n_loop.gt.1) then
            hrtr=(0.,0.)
            do nloop=1,n_loop
             ii=ip+(nloop-1)*jge*3
             if(bxx) then
              aszz=aimag(array_fr(ii+1))
              dsx2=aimag(array_fr(ii+2))
              azz =aimag(array_fr(ii+3))
              d_x2=aimag(array_fr(ii+4))
              fd=exp(-azz*d_x2-aszz*dsx2)
              hrtr=hrtr+array_fr(jn+2)*fd 
             else
              fd=exp(-aimag(array_fr(ii+5)))
              hrtr=hrtr+array_fr(jn+2)*fd 
             end if
            end do
           else
            if(bxx) then
             aszz=aimag(array_fr(ii+1))
             dsx2=aimag(array_fr(ii+2))
             azz =aimag(array_fr(ii+3))
             d_x2=aimag(array_fr(ii+4))
             fd=exp(-azz*d_x2-aszz*dsx2)
            else
             fd=exp(-aimag(array_fr(ii+5)))
            end if
            hrtr=array_fr(jn+2)*fd 
           end if
           
           nd=abs(4*n-nE)
           if(nd.le.nLG) then
            satrace_p=satrace_p+hrtr*aimag(array_fr(iposLG+nd))
           end if
           nd=abs(-4*n-nE)
           if(nd.le.nLG) then
            satrace_m=satrace_m+hrtr*aimag(array_fr(iposLG+nd))
           end if
          end do     ! jn=
         end do      ! n_pow
         array_fr(ni+1)=satrace_p
         array_fr(ni+2)=satrace_m
     
        end if
       end do       ! n loop
      
      
      else   ! if(iflag_SAMP.eq.0) then

       i=2
       if(b_polisp) i=4
       do n=iput+1,iput+(nSC+1)*i
        array_fr(n)=(0.,0.)
       end do
       srw=4.0*srw8

       do npow=1,n_pow
        ip=iget+2+(npow-1)*3*jge*n_loop

        do jn=ip,ip+jge*3-3,3

         call aLORGAU(b_Gauss,real(array_fr(jn+1))+aisom,gamnat,srw,
     &                       w_Lorentz,w_Gauss,nSC,iflag_Voigt)
          
         if(n_loop.gt.1) then
          hrtr=(0.,0.)
          hrpm=(0.,0.)
          do nloop=1,n_loop
           ii=ip+(nloop-1)*jge*3
           if(bxx) then
            aszz=aimag(array_fr(ii+1))
            dsx2=aimag(array_fr(ii+2))
            azz =aimag(array_fr(ii+3))
            d_x2=aimag(array_fr(ii+4))
            fd=exp(-azz*d_x2-aszz*dsx2)
            hrtr=hrtr+array_fr(jn+2)*fd 
            hrpm=hrpm+array_fr(jn+3)*fd           
           else
            fd=exp(-aimag(array_fr(ii+5)))
            hrtr=hrtr+array_fr(jn+2)*fd 
            hrpm=hrpm+array_fr(jn+3)*fd    
           end if
          end do
         else
          if(bxx) then
           aszz=aimag(array_fr(ip+1))
           dsx2=aimag(array_fr(ip+2))
           azz =aimag(array_fr(ip+3))
           d_x2=aimag(array_fr(ip+4))
           fd=exp(-azz*d_x2-aszz*dsx2)
          else
           fd=exp(-aimag(array_fr(ip+5)))
          end if
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd           
         end if
           
         if(b_polisp) then
          do n=0,nSC
           nn=iput+4*n
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n ))*hrpm
           array_fr(nn+3)=array_fr(nn+3)+ aimag(cLG(-n))*hrtr
           array_fr(nn+4)=array_fr(nn+4)+ aimag(cLG(-n))*hrpm
          end do
         else
          do n=0,nSC
           nn=iput+2*n
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(-n))*hrtr
          end do
         end if
        end do        ! jn=
       end do        ! n_pow
      end if         ! iflag_SAMP
      
      
c     The sum of the Lorentz-Gauss curves of the jge lines
c     have to be normalized to 1 for each subspectrum of the source
c     iscpi=iscpr+2*nSC+1
      
c     write(6,'(a,i5,5x,2f15.8)')
c    &           ' isc3,sTr(0)=',isc3,array_fr(isc3+1)
        if(b_polisp) then
         do i=0,nSC
          nn=iput+4*i
          sTr(i)=aimag(array_fr(nn+1))
          sTr(-i)=aimag(array_fr(nn+3))
         end do
        else
         do i=0,nSC
          nn=iput+2*i
          sTr(i)=aimag(array_fr(nn+1))
          sTr(-i)=aimag(array_fr(nn+2))
         end do
        end if
c         write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',
c     &    sTr(i),sTr(-i),i=0,5)
      
        i=2
        if(b_polisp) i=4
        ni=iput+(nSC+1)*i+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,f8.3)')'-------th-----iscn_nr,snorm=',ni,hr/3.
        end if
       goto 400
c------------------------ absorber ----------------------------------
 200   continue
c     write(6,'(a,2i8)') '2x2_ref_index_static_f_sad iget=',iget,iput
      n_pow=real(array_fr(iget+1))
      n_loop=aimag(array_fr(iget+1))
      jge=real(array_fr(iget+2))
      bxx=aimag(array_fr(iget+2)).gt.0.01
      
      do npow=1,n_pow
       ip=iget+2+(npow-1)*3*jge*n_loop
       do jn=ip+1,ip+jge*3-2,3
        Eagd=real(array_fr(jn))+aisom
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
        if (abs(nE).gt.ak8) write(nwr,'(2(a,f10.2),a)')
     &    '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'
       end do   ! jn=
      end do   !  npow=1,n_pow

      b_Lorentz=b_w_Lorentz
      b_Gauss=b_w_Gauss
      if(iflag_SAMP.eq.1) then

       call cLORGAU(b_Lorentz,b_Gauss,
     &           gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)
      
c       write(6,'(a)') 'array_fr(iposLG+0,...,16)'
c       write(6,'(4f15.6)') (array_fr(iposLG+i),i=0,15)
c       write(6,'(a,i6,2x,3i3,a,2i6,f15.6)')'iput,jge,n_pow,n_loop=',
c     &    iput,jge,n_pow,n_loop,' -+nAS,iposLG,srw8=',nAS,iposLG,srw8
      
       do n=0,nAS
        if(b_polisp) then
         ni=iput+8*n
    
         satrace_p=0.
         sapp_p=cmplx(0.,0.)
         sapm_p=cmplx(0.,0.)
         samp_p=cmplx(0.,0.)
         satrace_m=0.
         sapp_m=cmplx(0.,0.)
         sapm_m=cmplx(0.,0.)
         samp_m=cmplx(0.,0.)
      
         do npow=1,n_pow
          ip=iget+2+(npow-1)*3*jge*n_loop

          do jn=ip,ip+jge*3-3,3
           nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)

c          n_loop runs over equivalent sites with the same nE values            
c          density matrices (intensity matrices) are added
           if(n_loop.gt.1) then
            hrtr=(0.,0.)
            hrpm=(0.,0.)
            do nloop=1,n_loop
             ii=ip+(nloop-1)*jge*3
             if(bxx) then
              aszz=aimag(array_fr(ii+1))
              dsx2=aimag(array_fr(ii+4))
              azz =aimag(array_fr(ii+7))
              d_x2=aimag(array_fr(ii+10))
              fd=exp(-azz*d_x2-aszz*dsx2)
              hrtr=hrtr+array_fr(jn+2)*fd 
              hrpm=hrpm+array_fr(jn+3)*fd           
             else
              fd=exp(-aimag(array_fr(ii+13)))
              hrtr=hrtr+array_fr(jn+2)*fd 
              hrpm=hrpm+array_fr(jn+3)*fd    
             end if
            end do
           else
            if(bxx) then
             aszz=aimag(array_fr(ip+1))
             dsx2=aimag(array_fr(ip+4))
             azz =aimag(array_fr(ip+7))
             d_x2=aimag(array_fr(ip+10))
             fd=exp(-azz*d_x2-aszz*dsx2)
            else
             fd=exp(-aimag(array_fr(ip+13)))
            end if
             hrtr=array_fr(jn+2)*fd 
             hrpm=array_fr(jn+3)*fd           
           end if
c             if(n.eq.0) write(6,'(a,8f9.4)')'a fd,array_fr(ip+13)=',
c     &         fd,array_fr(ip+13)

           if(b_trans) then
            hti= aimag(hrtr)/2.0
            ctr= real(hrtr)*hci/2.0
            cpm= hrpm*hci/2.0
            cmp= conjg(hrpm)*hci/2.0
c            if(n.lt.5) write(6,'(3i6,8f9.4)') n,jn,nE, hrtr,hrpm
           else
            sph(1,1)= real(hrtr)+aimag(hrtr)
            sph(2,2)=-real(hrtr)+aimag(hrtr)
            sph(1,2)= hrpm
            sph(2,1)= conjg(hrpm)
            do i=1,2
            do k=1,2
             hc=cmplx(0.,0.)
             do j=1,2
             do l=1,2
              hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
             end do
             end do
             Rmatrix(i,k)=hc
            end do
            end do
            hrtr=cmplx(real(Rmatrix(1,1)-Rmatrix(2,2)),
     &                 real(Rmatrix(1,1)+Rmatrix(2,2)))/2.
            hrpm=Rmatrix(1,2)

            hti= aimag(hrtr)+real(hrtr)
            ctr= cmplx(aimag(hrtr)-real(hrtr),0.)
            cpm= hrpm
            cmp= conjg(hrpm)
           end if

c           nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)
c           nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))
c           b1=1/2 kz*(npm+nmp)
c           b2=1/2 kz*(npm-nmp)*i
c           b3=1/2 kz*(npp-nmm)
c
c           the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2rpq )
c           fLG=(4*n-nE)*srw8/(hga/2.) is written as

           nd=nst*n-nE                  ! +n
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            satrace_p=satrace_p-hc*hti
            sapp_p=sapp_p-hc*ctr
            sapm_p=sapm_p-hc*cpm
            samp_p=samp_p-hc*cmp
c            if(n.lt.5) write(6,'(3i6,8f9.4)')iposLG,nd,nE,hc*100.,hti
c            if(n.lt.5) write(6,'(3i6,8f9.4)') n,jn,nE,ctr,cpm,cmp
           end if

           nd=-nst*n-nE                  ! -n
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            satrace_m=satrace_m-hc*hti
            sapp_m=sapp_m-hc*ctr
            sapm_m=sapm_m-hc*cpm
            samp_m=samp_m-hc*cmp
           end if

          end do        ! jn=
         end do        ! n_pow
      
         array_fr(ni+1)= satrace_p
         array_fr(ni+2)= sapp_p
         array_fr(ni+3)= sapm_p
         array_fr(ni+4)= samp_p
         array_fr(ni+5)= satrace_m
         array_fr(ni+6)= sapp_m
         array_fr(ni+7)= sapm_m
         array_fr(ni+8)= samp_m

        else ! if .not.polarized

         ni=iput+2*n
      
         satrace_p=0.
         satrace_m=0.

         do npow=1,n_pow
          ip=iget+2+(npow-1)*3*jge*n_loop

          do jn=ip,ip+jge*3-3,3
           nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)
            
           if(n_loop.gt.1) then
            hrtr=(0.,0.)
            do nloop=1,n_loop
             ii=ip+(nloop-1)*jge*3
             if(bxx) then
              aszz=aimag(array_fr(ii+1))
              dsx2=aimag(array_fr(ii+4))
              azz =aimag(array_fr(ii+7))
              d_x2=aimag(array_fr(ii+10))
              fd=exp(-azz*d_x2-aszz*dsx2)
              hrtr=hrtr+array_fr(jn+2)*fd 
             else
              fd=exp(-aimag(array_fr(ii+13)))
              hrtr=hrtr+array_fr(jn+2)*fd 
             end if
            end do
           else
            if(bxx) then
             aszz=aimag(array_fr(ii+1))
             dsx2=aimag(array_fr(ii+4))
             azz =aimag(array_fr(ii+7))
             d_x2=aimag(array_fr(ii+10))
             fd=exp(-azz*d_x2-aszz*dsx2)
            else
             fd=exp(-aimag(array_fr(ii+13)))
            end if
            hrtr=array_fr(jn+2)*fd 
           end if

           if(b_trans) then
            hti = aimag(hrtr)/2.0
           else
            hti = aimag(hrtr)+real(hrtr)
           end if

           nd=nst*n-nE
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            satrace_p=satrace_p-hc*hti
           end if

           nd=-nst*n-nE
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            satrace_m=satrace_m-hc*hti
           end if
          end do     ! jn=
         end do     ! npow=1,n_pow

         array_fr(ni+1)= satrace_p
         array_fr(ni+2)= satrace_m
        end if
      
       end do       ! n loop

      else     !flag sampling
     
       i=2
       if(b_polisp) i=8
       do n=iput+1,iput+(nAS+1)*i
        array_fr(n)=(0.,0.)
       end do
       srw=srw8*float(nst)

       do npow=1,n_pow
        ip=iget+2+(npow-1)*3*jge*n_loop

        do jn=ip,ip+jge*3-3,3
          
         if(n_loop.gt.1) then
          hrtr=(0.,0.)
          hrpm=(0.,0.)
          do nloop=1,n_loop
           ii=ip+(nloop-1)*jge*3
           if(bxx) then
            aszz=aimag(array_fr(ii+1))
            dsx2=aimag(array_fr(ii+4))
            azz =aimag(array_fr(ii+7))
            d_x2=aimag(array_fr(ii+10))
            fd=exp(-azz*d_x2-aszz*dsx2)
            hrtr=hrtr+array_fr(jn+2)*fd 
            hrpm=hrpm+array_fr(jn+3)*fd           
           else
            fd=exp(-aimag(array_fr(ii+13)))
            hrtr=hrtr+array_fr(jn+2)*fd 
            hrpm=hrpm+array_fr(jn+3)*fd    
           end if
          end do
         else
          if(bxx) then
           aszz=aimag(array_fr(ip+1))
           dsx2=aimag(array_fr(ip+4))
           azz =aimag(array_fr(ip+7))
           d_x2=aimag(array_fr(ip+10))
           fd=exp(-azz*d_x2-aszz*dsx2)
          else
           fd=exp(-aimag(array_fr(ip+13)))
          end if
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd           
c           write(6,'(a,f10.4,2f12.3,5x,2i8)')
c     &       'fd..=',fd,array_fr(ip+13),ip+13,jn+1
         end if

         if(b_trans) then
          hti= aimag(hrtr)/2.0
          ctr= real(hrtr)*hci/2.0
          cpm= hrpm*hci/2.0
          cmp= conjg(hrpm)*hci/2.0
         else
          sph(1,1)= real(hrtr)+aimag(hrtr)
          sph(2,2)=-real(hrtr)+aimag(hrtr)
          sph(1,2)= hrpm
          sph(2,1)= conjg(hrpm)
          do i=1,2
          do k=1,2
           hc=cmplx(0.,0.)
           do j=1,2
           do l=1,2
            hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
           end do
           end do
           Rmatrix(i,k)=hc
          end do
          end do
          hrtr=cmplx(real(Rmatrix(1,1)-Rmatrix(2,2)),
     &                real(Rmatrix(1,1)+Rmatrix(2,2)))/2.
          hrpm=Rmatrix(1,2)
          hti= aimag(hrtr)+real(hrtr)
          ctr= cmplx(aimag(hrtr)-real(hrtr),0.)
          cpm= hrpm
          cmp= conjg(hrpm)
         end if
     
         call aLORGAU(b_Gauss,real(array_fr(jn+1))+aisom,gamnat,srw,
     &                        w_Lorentz,w_Gauss,nAS,iflag_Voigt)
     
         do n=0,nAS
          if(b_polisp) then
           ni=iput+8*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           array_fr(ni+2)=array_fr(ni+2)-hc*ctr
           array_fr(ni+3)=array_fr(ni+3)-hc*cpm
           array_fr(ni+4)=array_fr(ni+4)-hc*cmp
           hc=conjg(cLG(-n))
           array_fr(ni+5)=array_fr(ni+5)-hc*hti
           array_fr(ni+6)=array_fr(ni+6)-hc*ctr
           array_fr(ni+7)=array_fr(ni+7)-hc*cpm
           array_fr(ni+8)=array_fr(ni+8)-hc*cmp
          else
           ni=iput+2*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           hc=conjg(cLG(-n))
           array_fr(ni+2)=array_fr(ni+2)-hc*hti
          end if
         end do      ! nAS 
        end do       !   jn=
       end do        ! npow=1,n_pow
      end if         ! iflag_SAMP
      goto 400
     
c--------------------------------------------------------------------
 300   continue
c      detector
      n_pow=real(array_fr(iget+1))
      n_loop=aimag(array_fr(iget+1))
      jge=real(array_fr(iget+2))
      bxx=aimag(array_fr(iget+2)).gt.0.01
      
      do npow=1,n_pow
       ip=iget+2+(npow-1)*3*jge*n_loop
       do jn=ip+1,ip+jge*3-2,3
        Eagd=real(array_fr(jn))+aisom
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')
     &    '**** E(detector)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'
       end do   ! jn=
      end do   ! npow=1,n_pow
    

      
      if(iflag_SAMP.eq.1) then
       b_Lorentz=b_w_Lorentz
       b_Gauss=b_w_Gauss
     
       call cLORGAU(b_Lorentz,b_Gauss,
     &         gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)
      
c      write(6,'(a,2L5,i6,/,4f12.5)')
c    &  ' *detector* b_Lorentz,b_Gauss,iposLG,array_fr(iposLG,+1)=',
c    &  b_Lorentz,b_Gauss,iposLG,array_fr(iposLG),array_fr(iposLG+1)
      
       do n=0,nSC
        ni=iput+n+1
        satrace_r=0.
        satrace_i=0.

        do npow=1,n_pow
         ip=iget+2+(npow-1)*3*jge*n_loop

         do jn=ip,ip+jge*3-3,3
          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)
           
          if(n_loop.gt.1) then
           hrtr=(0.,0.)
           do nloop=1,n_loop
            ii=ip+(nloop-1)*jge*3
            if(bxx) then
             aszz=aimag(array_fr(ii+1))
             dsx2=aimag(array_fr(ii+2))
             azz =aimag(array_fr(ii+3))
             d_x2=aimag(array_fr(ii+4))
             fd=exp(-azz*d_x2-aszz*dsx2)
             hrtr=hrtr+array_fr(jn+2)*fd 
            else
             fd=exp(-aimag(array_fr(ii+5)))
             hrtr=hrtr+array_fr(jn+2)*fd 
            end if
           end do
          else
           if(bxx) then
            aszz=aimag(array_fr(ip+1))
            dsx2=aimag(array_fr(ip+2))
            azz =aimag(array_fr(ip+3))
            d_x2=aimag(array_fr(ip+4))
            fd=exp(-azz*d_x2-aszz*dsx2)
           else
            fd=exp(-aimag(array_fr(ip+5)))
           end if
           hrtr=array_fr(jn+2)*fd 
          end if
c         Sum;ab rpq(ab)/2*LG(E-Eab)
          nd=abs(4*n-nE)
          if(nd.le.nLG) 
     &     satrace_r=satrace_r+aimag(array_fr(iposLG+nd))*aimag(hrtr)
          nd=abs(-4*n-nE)
          if(nd.le.nLG)
     &     satrace_i=satrace_i+aimag(array_fr(iposLG+nd))*aimag(hrtr)

         end do     ! jn=
        end do     !  npow=1,n_pow
        array_fr(ni)=cmplx(satrace_r,satrace_i)
       end do       ! n loop

      else  ! if(iflag_SAMP.eq.1) then

       do n=iput+1,iput+(nSC+1)
        array_fr(n)=(0.,0.)
       end do
      
       do npow=1,n_pow
        ip=iget+2+(npow-1)*3*jge*n_loop

        do jn=ip,ip+jge*3-3,3
         nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)
          
         if(n_loop.gt.1) then
          hrtr=(0.,0.)
          do nloop=1,n_loop
           ii=ip+(nloop-1)*jge*3
           if(bxx) then
            aszz=aimag(array_fr(ii+1))
            dsx2=aimag(array_fr(ii+2))
            azz =aimag(array_fr(ii+3))
            d_x2=aimag(array_fr(ii+4))
            fd=exp(-azz*d_x2-aszz*dsx2)
            hrtr=hrtr+array_fr(jn+2)*fd 
           else
            fd=exp(-aimag(array_fr(ii+5)))
            hrtr=hrtr+array_fr(jn+2)*fd 
           end if
          end do
         else
          if(bxx) then
           aszz=aimag(array_fr(ii+1))
           dsx2=aimag(array_fr(ii+2))
           azz =aimag(array_fr(ii+3))
           d_x2=aimag(array_fr(ii+4))
           fd=exp(-azz*d_x2-aszz*dsx2)
          else
           fd=exp(-aimag(array_fr(ii+5)))
          end if
          hrtr=array_fr(jn+2)*fd 
         end if

         call aLORGAU(b_Gauss,real(array_fr(jn+1))+aisom,gamnat,srw8,
     &                         w_Lorentz,w_Gauss,nSC,iflag_Voigt)
         do n=0,nSC
          ni=iput+n+1
          array_fr(ni)=array_fr(ni)+
     &     cmplx(aimag(cLG(n)),aimag(cLG(-n)))*aimag(hrtr)
         end do       ! n loop
        end do     ! jn=
       end do     !  npow=1,n_pow
      end if        ! iflag_SAMP
      
 400  return
      end



      subroutine th_22indexsad(isubthe,icase,iput,iget)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

c     sad= source,absorber,detector : lstr1case=1,2,3

      integer isubthe,icase,iput,iget,istr,dstr,idex,
     &        lstr1case,idum1,nLG,nAS,nSC,idum2,ak8,sk8
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),lstr1case,idum1,                         !13.9.05 
     &              nLG,nAS,nSC,idum2,ak8,sk8,srw8,idex(7)      

      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)

c     storage use nst2_8 for 4 complex numbers of r_ik
      real          c1,gamnat,flag_SAMP,flag_Voigt,dumc
      common/acmaps/c1,gamnat,flag_SAMP,flag_Voigt,dumc(icstrf-4)
      real          avm,sftr,aisom,w_Gauss,w_Lorentz,dumv
      logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,b_dumv
      common/avmaps/avm,sftr,aisom,w_Gauss,w_Lorentz,dumv(ivstrf-5)
      common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,
     &              b_dumv(ivstrf-5)


      integer     idumscrd
      parameter  (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real        sTr,dumscrd
      complex     cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)

      logical   b_pc,b_Lorentz,b_Gauss,b_trans,b_polisp
      
      integer   nE(maxjge),iflag_SAMP,iflag_Voigt,
     &          i,i2,i3,ij,j,k,l,n,ni,nd,nn,
     &          iposLG,sk2,nst
      
      real      hr,hi,hti,sqrt2,satracer,satracei,srw,
     &          hEagd(maxjge),htr(maxjge)

      complex   sapph,sapmh,samph,satraceh,hc,hci,
     &          hrtr(maxjge),hrpm(maxjge),
     &          chtr(maxjge),chpm(maxjge),chmp(maxjge),
     &          Rmatrix(2,2),TSPCA(2,2),sph(2,2),ctr,cpm,cmp
      
      

      b_polisp=.false.
      if(icase.eq.1) b_polisp=.true.

      if(isubthe.lt.0) then
       theoryname='2x2_ref_index_static_sad'
      if(ifrcase.lt.3) then
        i=2
        if(b_polisp) i=4
        if(-isubthe.eq.1) then
         c1=i*(nSC+1)+1
         if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
        end if
        if(-isubthe.eq.2) then
         c1=2*(nAS+1)
         if(b_polisp)c1=c1*4
        end if
        if(-isubthe.eq.3) c1=i*(nSC+1)
       end if
       if(ifrcase.eq.5) then
         c1=2*(nAS+1)
         if(b_polisp) c1=c1*4
        end if
       return
      end if
      
      nst=4
      hci=cmplx(0.,1.)
      iflag_SAMP=flag_SAMP
      iflag_Voigt=flag_Voigt
      
      b_trans=.false.
      if(ifrcase.lt.5) b_trans=.true.
      


      call get_theory(isubthe)

      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.b_w_Lorentz.or.isubthe.gt.0
      if(.not.b_pc) then
       isubthe=-abs(isubthe)
       goto 400
      end if
      isubthe=abs(isubthe)

      i2=iget+jge
      i3=i2+jge
      do i=1,jge
       hEagd(i)=real(array_fr(iget+i))
       hrtr(i)=array_fr(i2+i)
       hrpm(i)=array_fr(i3+i)
      end do
    
      if (isubthe.gt.0.and.(.not.b_trans)) then
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)
c      transformation matrix from spherical basis to (sigma,pi)-basis
       do ij=1,jge
        sph(1,1)= real(hrtr(ij))+aimag(hrtr(ij))
        sph(2,2)=-real(hrtr(ij))+aimag(hrtr(ij))
        sph(1,2)= hrpm(ij)
        sph(2,1)= conjg(hrpm(ij))
        do i=1,2
        do k=1,2
         hc=cmplx(0.,0.)
         do j=1,2
         do l=1,2
          hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
         end do
         end do
         Rmatrix(i,k)=hc
        end do
        end do
        hrtr(ij)=cmplx(real(Rmatrix(1,1)-Rmatrix(2,2)),
     &                  real(Rmatrix(1,1)+Rmatrix(2,2)))/2.
        hrpm(ij)=Rmatrix(1,2)
       end do
       i2=iget+jge
       i3=i2+jge
       do i=1,jge
        array_fr(iget+i)=cmplx(hEagd(i),0.0)
        array_fr(i2+i)=hrtr(i)
        array_fr(i3+i)=hrpm(i)
       end do
      end if   
      
c      write(6,'(a,g15.6)') 'th-subrmossbaue gamnat=',gamnat
c      write(6,'(8f10.6)') (hEagd(i),i=1,jge)
c      write(6,'(8f10.6)') (real(hrtr(i))+aimag(hrtr(i)),i=1,jge)
c      write(6,'(8f10.6)') (-real(hrtr(i))+aimag(hrtr(i)),i=1,jge)
c      write(6,'(8f10.6)') (real(hrpm(i)),i=1,jge)
c      write(6,'(8f10.6,/)') (aimag(hrpm(i)),i=1,jge)

      
       goto (100,200,300),lstr1case
c-----------------------------------------------------------------
           
 100   continue
c      source
c        write(6,'(a,i6)') 'eagd ,jge=',jge
c         write(6,'(8f12.6)') (array_fr(iget+i),i=-3,4)
c         write(6,'(8f9.6)') (hEagd(i),i=1,jge)
c        write(6,'(a)') 'hrtr,hrpm ='
c        write(6,'(8f9.6)') (hrtr(i),i=1,8)
c        write(6,'(8f9.6)') (hrpm(i),i=1,8)
c        write(6,'(a,2f12.4)')' theomoss aisom,srw8=',aisom,srw8
        do i=1,jge
         hEagd(i)=hEagd(i)+aisom
         nE(i)=ifix(hEagd(i)/srw8+0.5)          ! nE <= sk8
         if (abs(nE(i)).gt.sk8) write(nwr,'(2(a,f10.2),a)')
     &   '**** E(source)=',hEagd(i),' out of range ',sk8*srw8,'[mm/s]'
        end do   ! i=1,jge
      
        b_Lorentz=b_w_Lorentz
        b_Gauss=b_w_Gauss
        if(iflag_SAMP.eq.1) then
      
         call cLORGAU(b_Lorentz,b_Gauss,
     &           gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)
      
c        write(6,'(a,2L5,i6,/,4f12.5)')
c     &  ' *source* b_Lorentz,b_Gauss,iposLG,array_fr(iposLG,+1)=',
c     &  b_Lorentz,b_Gauss,iposLG,array_fr(iposLG),array_fr(iposLG+1)
      
c        write(6,'(a,i4)') ' source'
c        write(6,'(9i6)') nSC,(nE(i),i=1,jge)
c        write(6,'(8g10.3)') (hrtr(i),i=1,jge)
c        write(6,'(8g10.3)') (hrpm(i),i=1,jge)
c         write(6,'(a,i7)')'theomoss do n=0,nSC ni=iput+4*n iput=',
c     &                      iput
      
         do n=0,nSC
          if(b_polisp) then
           ni=iput+4*n
      
           satraceh=(0.,0.)
           sapmh=(0.,0.)
           do i=1,jge
            nd=abs(4*n-nE(i))
            if(nd.le.nLG) then
c            Sum;ab rpq(ab)/2*LG(E-Eab)
c            LG(E-Eab) on 1,3,...,2n+1
             hi=aimag(array_fr(iposLG+nd))
             satraceh=satraceh+hi*hrtr(i)
             sapmh=sapmh+hi*hrpm(i)
            end if
           end do     ! i=1,jge  loop
           array_fr(ni+1)=satraceh
           array_fr(ni+2)=sapmh
      
           satraceh=(0.,0.)
           sapmh=(0.,0.)
           do i=1,jge
            nd=abs(-4*n-nE(i))
            if(nd.le.nLG) then
c            Sum;ab rpq(ab)/2*LG(E-Eab)
c            LG(E-Eab) on 1,3,...,2n+1
             hi=aimag(array_fr(iposLG+nd))
             satraceh=satraceh+hi*hrtr(i)
             sapmh=sapmh+hi*hrpm(i)
            end if
           end do     ! i=1,jge  loop
           array_fr(ni+3)=satraceh
           array_fr(ni+4)=sapmh
c           if(n.lt.4) write(6,'(a,i6,4f15.5)')
c     &      'polisp nn ,array_fr(nn+1,3)=',
c     &       nn,array_fr(nn+1),array_fr(nn+3)
          else
           ni=iput+2*n
      
           satraceh=(0.,0.)
           do i=1,jge
            nd=abs(4*n-nE(i))
            if(nd.le.nLG) then
             satraceh=satraceh+hrtr(i)*aimag(array_fr(iposLG+nd))
             sapmh=sapmh+hi*hrpm(i)
            end if
           end do     ! i=1,jge  loop
           array_fr(ni+1)=satraceh
      
           satraceh=(0.,0.)
           do i=1,jge
            nd=abs(-4*n-nE(i))
            if(nd.le.nLG) then
             satraceh=satraceh+hrtr(i)*aimag(array_fr(iposLG+nd))
            end if
           end do     ! i=1,jge  loop
           array_fr(ni+2)=satraceh
c           if(n.lt.4) write(6,'(a,i6,4f15.5)')
c     &      'no pol nn ,array_fr(nn+1,2)=',
c     &       nn,array_fr(nn+1),array_fr(nn+2)
          end if
         end do       ! n loop
      
      
        else
c        calculation of aimag(cLG(i))
         i=2
         if(b_polisp) i=4
         do n=iput+1,iput+(nSC+1)*i
          array_fr(n)=(0.,0.)
         end do
         srw=4.0*srw8
c         write(6,'(a,L5,3f10.3)')
c     &     's theomoss b_Gauss,gamnat,w_Lorentz,w_Gauss=',
c     &     b_Gauss,gamnat,w_Lorentz,w_Gauss
         do i=1,jge
          call aLORGAU(b_Gauss,hEagd(i)+aisom,gamnat,srw,
     &                         w_Lorentz,w_Gauss,nSC,iflag_Voigt)
          if(b_polisp) then
           do n=0,nSC
            nn=iput+4*n
            array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n))*hrtr(i)
            array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n))*hrpm(i)
            array_fr(nn+3)=array_fr(nn+3)+ aimag(cLG(-n))*hrtr(i)
            array_fr(nn+4)=array_fr(nn+4)+ aimag(cLG(-n))*hrpm(i)
           end do
          else
           do n=0,nSC
            nn=iput+2*n
            array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n))*hrtr(i)
            array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(-n))*hrtr(i)
           end do
          end if
         end do        ! i=1,jge
        end if         ! iflag_SAMP
      
      
c     The sum of the Lorentz-Gauss curves of the jge lines
c     have to be normalized to 1 for each subspectrum of the source
c     iscpi=iscpr+2*nSC+1
      
c     write(6,'(a,i5,5x,2f15.8)')
c    &           ' isc3,sTr(0)=',isc3,array_fr(isc3+1)
        if(b_polisp) then
         do i=0,nSC
          nn=iput+4*i
          sTr(i)=aimag(array_fr(nn+1))
          sTr(-i)=aimag(array_fr(nn+3))
         end do
        else
         do i=0,nSC
          nn=iput+2*i
          sTr(i)=aimag(array_fr(nn+1))
          sTr(-i)=aimag(array_fr(nn+2))
         end do
        end if
c         write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',
c     &    sTr(i),sTr(-i),i=0,5)
      
        i=2
        if(b_polisp) i=4
        ni=iput+(nSC+1)*i+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,f8.3)')'-------th-----iscn_nr,snorm=',ni,hr/3.
        end if
       goto 400
c----------------------------------------------------------
 200   continue
c      absorber
c       write(6,'(a,f10.3)') ' bwidth=true  gamnat=',gamnat
c       write(6,'(a,i5)') ' -----------absorber,iflag_SAMP=',iflag_SAMP
             
        b_Lorentz=b_w_Lorentz
        b_Gauss=b_w_Gauss
        if(iflag_SAMP.eq.1) then
         call cLORGAU(b_Lorentz,b_Gauss,
     &           gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)
      
c         write(6,'(a,2L5,i6,/,4f12.5)')
c     &   ' *absorber* b_Lorentz,b_Gauss,iposLG,array_fr(iposLG,+1)=',
c     &   b_Lorentz,b_Gauss,iposLG,array_fr(iposLG),array_fr(iposLG+1)
      
         do i=1,jge
          hEagd(i)=hEagd(i)+aisom
          nE(i)=ifix(hEagd(i)/srw8+0.5)                ! nE <= ak8
          if (abs(nE(i)).gt.ak8) write(nwr,'(2(a,f10.2),a)')
     &    '**E(absorber)=',hEagd(i),' out of range=',ak8*srw8,'[mm/s]'
         end do   ! i=1,jge
      
          if(b_trans) then
           do i=1,jge
            htr(i) = aimag(hrtr(i))/2.0
            chtr(i)= real(hrtr(i))*hci/2.0
            chpm(i)= hrpm(i)*hci/2.0
            chmp(i)= conjg(hrpm(i))*hci/2.0
           end do
          else
           do i=1,jge
            htr(i) = aimag(hrtr(i))+real(hrtr(i))
            chtr(i)= cmplx(aimag(hrtr(i))-real(hrtr(i)),0.)
            chpm(i)= hrpm(i)
            chmp(i)= conjg(hrpm(i))
           end do
          end if
c         write(6,'(4f12.6)') (htr(i),i=1,8)
c         write(6,'(a)') 'array_fr(iposLG+0,...,16)'
c         write(6,'(4f15.6)') (array_fr(iposLG+i),i=0,15)
c         write(6,'(a,2i6,f15.6)') ' -+nAS,iposLG,srw8=',nAS,iposLG,srw8
      
c        write(6,'(a,i7)') 'do n=0,nAS ni=iput+8*n   iput=',iput
         do n=0,nAS
          if(b_polisp) then
           ni=iput+8*n
      
           satraceh=0.
           sapph=cmplx(0.,0.)
           sapmh=cmplx(0.,0.)
           samph=cmplx(0.,0.)
      
           do i=1,jge
            nd=nst*n-nE(i)
            if(abs(nd).le.nLG) then
      
c            nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)
c            nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))
c            b1=1/2 kz*(npm+nmp)
c            b2=1/2 kz*(npm-nmp)*i
c            b3=1/2 kz*(npp-nmm)
c
c            the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2rpq )
c            fLG=(4*n-nE)*srw8/(hga/2.) is written as
      
             if(nd.gt.0) then
              hc=conjg(array_fr(iposLG+nd))
             else
              hc=-array_fr(iposLG-nd)
             end if
             satraceh=satraceh-hc*htr(i)
             sapph=sapph-hc*chtr(i)
             sapmh=sapmh-hc*chpm(i)
             samph=samph-hc*chmp(i)
            end if
c            if(n.lt.5) write(6,'(2i6,8f9.4)') n,nE(i),hc*100.,htr(i)
           end do     ! i=1,jge
      
           array_fr(ni+1)= satraceh
           array_fr(ni+2)= sapph
           array_fr(ni+3)= sapmh
           array_fr(ni+4)= samph
c           if(abs(n).lt.5) write(6,'(a,i2,i6,8f9.4)') 'sub',n,ni,
c     &      (array_fr(ni+i)*1000.,i=1,4)
          else
           ni=iput+2*n+1
      
           satraceh=0.
           do i=1,jge
            nd=nst*n-nE(i)
            if(abs(nd).le.nLG) then
             if(nd.gt.0) then
              hc=conjg(array_fr(iposLG+nd))
             else
              hc=-array_fr(iposLG-nd)
             end if
             satraceh=satraceh-hc*htr(i)
            end if
           end do     ! i=1,jge
           array_fr(ni)= satraceh
          end if
      
          if(b_polisp) then
           satraceh=0.
           sapph=cmplx(0.,0.)
           sapmh=cmplx(0.,0.)
           samph=cmplx(0.,0.)
           do i=1,jge
            nd=-nst*n-nE(i)
            if(abs(nd).le.nLG) then
             if(nd.gt.0) then
              hc=conjg(array_fr(iposLG+nd))
             else
              hc=-array_fr(iposLG-nd)
             end if
             satraceh=satraceh-hc*htr(i)
             sapph=sapph-hc*chtr(i)
             sapmh=sapmh-hc*chpm(i)
             samph=samph-hc*chmp(i)
            end if
c           if(n.lt.5) write(6,'(3i6,8f9.4)') iflag_SAMP,-n,i,hc*100.
           end do     ! i=1,jge
      
           array_fr(ni+5)= satraceh
           array_fr(ni+6)= sapph
           array_fr(ni+7)= sapmh
           array_fr(ni+8)= samph
c          if(abs(n).lt.5) write(6,'(i2,i6,8f9.4)') -n,ni,
c     &      (array_fr(ni+i)*1000.,i=5,8)
          else
           nn=iput+2*n+2
           satraceh=0.
           do i=1,jge
            nd=-nst*n-nE(i)
            if(abs(nd).le.nLG) then
             if(nd.gt.0) then
              hc=conjg(array_fr(iposLG+nd))
             else
              hc=-array_fr(iposLG-nd)
             end if
             satraceh=satraceh-hc*htr(i)
            end if
           end do     ! i=1,jge
           array_fr(ni)= satraceh
          end if
         end do       ! n loop
        else
         i=2
         if(b_polisp) i=8
         do n=iput+1,iput+(nAS+1)*i
          array_fr(n)=0.
         end do
         srw=srw8*float(nst)
c        write(6,'(a,2i4)') 'call aLORGAU nst,iflag_Voigt=',
c    &                      nst,iflag_Voigt
c         write(6,'(a,L5,3f10.3)')
c     &     'a theomoss b_Gauss,gamnat,w_Lorentz,w_Gauss=',
c     &     b_Gauss,gamnat,w_Lorentz,w_Gauss
         do i=1,jge
      
          call aLORGAU(b_Gauss,hEagd(i)+aisom,gamnat,srw,
     &                        w_Lorentz,w_Gauss,nAS,iflag_Voigt)
      
          if(b_trans)then
           hti=aimag(hrtr(i))/2.0
           ctr=real(hrtr(i))*hci/2.0
           cpm=hrpm(i)*hci/2.0
           cmp=conjg(hrpm(i))*hci/2.0
          else
           hti=aimag(hrtr(i))+real(hrtr(i))
           ctr=cmplx(aimag(hrtr(i))-real(hrtr(i)),0.)
           cpm=hrpm(i)
           cmp=conjg(cpm)
          end if
          do n=0,nAS
           if(b_polisp) then
            ni=iput+8*n
            hc=conjg(cLG(n))
c          if(abs(n).lt.5) write(6,'(3i6,8f9.4)')
c    &      ' iflag_SAMP,n,i,hc*100.=',iflag_SAMP,n,i,hc*100.
            array_fr(ni+1)=array_fr(ni+1)-hc*hti
            array_fr(ni+2)=array_fr(ni+2)-hc*ctr
            array_fr(ni+3)=array_fr(ni+3)-hc*cpm
            array_fr(ni+4)=array_fr(ni+4)-hc*cmp
            hc=conjg(cLG(-n))
c            if(n.lt.5) write(6,'(3i6,8f9.4)') iflag_SAMP,-n,i,hc*100.
            array_fr(ni+5)=array_fr(ni+5)-hc*hti
            array_fr(ni+6)=array_fr(ni+6)-hc*ctr
            array_fr(ni+7)=array_fr(ni+7)-hc*cpm
            array_fr(ni+8)=array_fr(ni+8)-hc*cmp
           else
            ni=iput+2*n
            hc=conjg(cLG(n))
            array_fr(ni+1)=array_fr(ni+1)-hc*hti
            hc=conjg(cLG(-n))
            array_fr(ni+2)=array_fr(ni+2)-hc*hti
           end if
          end do       ! n loop
         end do        ! i=1,jge
        end if         ! iflag_SAMP
       goto 400
c--------------------------------------------------------------------
 300   continue
c      detector
        do i=1,jge
         hEagd(i)=hEagd(i)+aisom
         nE(i)=ifix(hEagd(i)/srw8+0.5)  ! nE <= sk8
         if (abs(nE(i)).gt.sk8) write(nwr,'(2(a,f10.2),a)')
     &    '***E(detector)=',hEagd(i),' out of range=',sk8*srw8,'[mm/s]'
        end do   ! i
      
        if(iflag_SAMP.eq.1) then
         b_Lorentz=b_w_Lorentz
         b_Gauss=b_w_Gauss
      
         call cLORGAU(b_Lorentz,b_Gauss,
     &           gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)
      
c        write(6,'(a,2L5,i6,/,4f12.5)')
c    &   ' *detector* b_Lorentz,b_Gauss,iposLG,array_fr(iposLG,+1)=',
c    &   b_Lorentz,b_Gauss,iposLG,array_fr(iposLG),array_fr(iposLG+1)
      
         do n=0,nSC
          ni=iput+n
          satracer=0.
          do i=1,jge
           nd=abs(4*n-nE(i))
           if(nd.le.nLG) then
c           Sum;ab rpq(ab)/2*LG(E-Eab)
            satracer=satracer+aimag(array_fr(iposLG+nd))*aimag(hrtr(i))
           end if
          end do     ! i=1,jge  loop
      
          satracei=0.
          do i=1,jge
           nd=abs(-4*n-nE(i))
           if(nd.le.nLG)
     &      satracei=satracei+aimag(array_fr(iposLG+nd))*aimag(hrtr(i))
          end do     ! i=1,jge  loop
          array_fr(ni+1)=cmplx(satracer,satracei)
         end do       ! n loop
        else
         do n=iput+1,iput+(nSC+1)
          array_fr(n)=(0.,0.)
         end do
      
         do i=1,jge
          call aLORGAU(b_Gauss,hEagd(i),gamnat,srw8,
     &                         w_Lorentz,w_Gauss,nSC,iflag_Voigt)
          do n=0,nSC
           ni=iput+n+1
           array_fr(ni)=array_fr(ni)+
     &     cmplx(aimag(cLG(n)),aimag(cLG(-n)))*aimag(hrtr(i))
          end do       ! n loop
         end do     ! i=1,jge
        end if        ! iflag_SAMP
      
 400  return
      end


cccccccccccccccccccccc stroboscopy and synchrotron ccccccccccccccccccccc

      subroutine th_22index(isubthe,icase,iput,iget)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

c     called by i.e. stroboscopy and synchrotron

      integer isubthe,icase,iput,iget,istr,dstr,idex,
     &        iflag_basis,l_trans,nLG,nTH,
     &        idum1,nsampling,ak8,idum2
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),iflag_basis,l_trans,nLG,nTH,                 !13.9.05 
     &              idum1,nsampling,ak8,idum2,srw8,idex(7)      

      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)

      logical        b_vfr1trf
      common/bvfr1trf/b_vfr1trf(ivfr1trf)

c     storage use nst2_8 for 4 complex numbers of r_ik
      real          c1,gamnat,flag_SAMP,dumc
      common/acmaps/c1,gamnat,flag_SAMP,dumc(icstrf-3)
      real          avm,sftr,aisom,w_Gauss,w_Lorentz,dumv
      logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,b_dumv
      common/avmaps/avm,sftr,aisom,w_Gauss,w_Lorentz,dumv(ivstrf-5)
      common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,
     &              b_dumv(ivstrf-5)


      integer     idumscrd
      parameter  (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real        sTr,dumscrd
      complex     cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)

      logical   b_Lorentz,b_Gauss,b_trans,b_pc
      integer   iflag_SAMP,iflag_Voigt,nd,iposLG,nE,
     &          i2,i3,i,j,ij,k,l,n,ni
      dimension nE(maxjge)

      real      htr(maxjge),hEagd(maxjge),hti,srw,sqrt2
      complex   hc,hci,sapph,sapmh,samph,satraceh,
     &          chtr(maxjge),chpm(maxjge),chmp(maxjge),
     &          hrtr(maxjge),hrpm(maxjge),
     &          ctr,cpm,cmp,trv(2,2),TSPCA(2,2),sph(2,2)


      if(isubthe.lt.0) then
       c1=8*(nTH+1)
       theoryname='2x2_refraction_index_static'
       return
      end if

      hci=cmplx(0.,1.)
      iflag_SAMP=flag_SAMP
      iflag_Voigt=1


      b_trans=.false.
      if(l_trans.eq.1)  b_trans=.true.

c      write(6,'(a,4i6)') 'theory08 ....isubthe,nLG=',isubthe,nLG

c     i.e  th_hdeq
      call get_theory(isubthe)
      
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.b_w_Lorentz.or.isubthe.gt.0
      if(.not.b_pc) then
       isubthe=-abs(isubthe)
       return
      end if
      isubthe=abs(isubthe)
       
       i2=iget+jge
       i3=i2+jge
       do i=1,jge
        hEagd(i)=real(array_fr(iget+i))
        hrtr(i)=array_fr(i2+i)
        hrpm(i)=array_fr(i3+i)
       end do

c         write(6,'(a,3i7)') ' Eagd jge,iput,iget=',
c     &         jge,iput,iget
c        write(6,'(a,L5,3i4)') 'b_trans,iflag_basis,iflag_SAMP=',
c     &                        b_trans,iflag_basis,iflag_SAMP
c        write(6,'(6f12.6)') (hEagd(i),i=1,jge)
c        write(6,'(a)') '(hrtr(i),i=1,jge)'
c        write(6,'(6f12.6)') (hrtr(i),i=1,jge)
c        write(6,'(a)') '(hrpm(i),i=1,jge)'
c        write(6,'(6f12.6)') (hrpm(i),i=1,jge)

c-----------------------------------------------------------------------
c      basis for linear polarization
       if(iflag_basis.eq.0) then
        sqrt2=1./sqrt(2.)
        TSPCA(1,1)=cmplx( sqrt2,0.)
        TSPCA(1,2)=cmplx(-sqrt2,0.)
        TSPCA(2,1)=cmplx(0.,-sqrt2)
        TSPCA(2,2)=cmplx(0.,-sqrt2)

        do ij=1,jge
         sph(1,1)= real(hrtr(ij))+aimag(hrtr(ij))
         sph(2,2)=-real(hrtr(ij))+aimag(hrtr(ij))
         sph(1,2)= hrpm(ij)
         sph(2,1)= conjg(hrpm(ij))
         do i=1,2
         do k=1,2
          hc=cmplx(0.,0.) 
          do j=1,2
          do l=1,2
           hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
          end do
          end do
          trv(i,k)=hc
         end do
         end do
         hrtr(ij)=cmplx(real(trv(1,1)-trv(2,2)),
     &                    real(trv(1,1)+trv(2,2)))/2.
         hrpm(ij)=trv(1,2)
        end do
       end if
c----------------------------------------------------------------------
        b_Lorentz=b_w_Lorentz
        b_Gauss=b_w_Gauss
        if(iflag_SAMP.eq.1) then
         call cLORGAU(b_Lorentz,b_Gauss,
     &           gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG)

c        write(6,'(a,2L5,2i6,/,4f12.5)')
c     &   'b_Lorentz,b_Gauss,iposLG,nLG,array_fr(iposLG,+1)=',
c     &   b_Lorentz,b_Gauss,nLG,iposLG,
c     &   array_fr(iposLG),array_fr(iposLG+1)

         do i=1,jge
          hEagd(i)=hEagd(i)+aisom
          nE(i)=ifix(hEagd(i)/srw8+0.5)                ! nE <= ak8
          if (abs(nE(i)).gt.ak8)write(nwr,'(2(a,f15.5),a)')
     &    '**E(absorber)=',hEagd(i),' out of range=',ak8*srw8,'[mm/s]'
         end do   ! i=1,jge

          if(b_trans) then
           do i=1,jge
            htr(i) = aimag(hrtr(i))/2.0
            chtr(i)= real(hrtr(i))*hci/2.0
            chpm(i)= hrpm(i)*hci/2.0
            chmp(i)= conjg(hrpm(i))*hci/2.0
           end do
          else
           do i=1,jge
            htr(i) = aimag(hrtr(i))+real(hrtr(i))
            chtr(i)= cmplx(aimag(hrtr(i))-real(hrtr(i)),0.)
            chpm(i)= hrpm(i)
            chmp(i)= conjg(hrpm(i))
           end do
          end if
c        write(6,'(a)') '(htr(i),i=1,8)'
c        write(6,'(4f12.6)') (htr(i),i=1,8)
c        write(6,'(a)') '(chtr(i),i=1,8)'
c        write(6,'(4f12.6)') (chtr(i),i=1,8)
c        write(6,'(a)') '(chpm(i),i=1,8)'
c        write(6,'(4f12.6)') (chpm(i),i=1,8)
c        write(6,'(a)') 'array_fr(iposLG+0,...,16)'
c        write(6,'(4f15.6)') (array_fr(iposLG+i),i=-15,15)
c        write(6,'(a,4i6,f15.6)')'nsampling,nLG,nTH,iposLG,srw8=',
c     &                           nsampling,nLG,nTH,iposLG,srw8

         do n=0,nTH
           ni=iput+8*n

           satraceh=0.
           sapph=cmplx(0.,0.)
           sapmh=cmplx(0.,0.)
           samph=cmplx(0.,0.)

           do i=1,jge
            nd=nsampling*n-nE(i)
            if(abs(nd).le.nLG) then

c            nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)
c            nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))
c            b1=1/2 kz*(npm+nmp)
c            b2=1/2 kz*(npm-nmp)*i
c            b3=1/2 kz*(npp-nmm)
c
c            the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2rpq )
c            fLG=(4*n-nE)*srw8/(hga/2.) is written as

             if(nd.gt.0) then
              hc=conjg(array_fr(iposLG+nd))
             else
              hc=-array_fr(iposLG-nd)
             end if
             satraceh=satraceh-hc*htr(i)
             sapph=sapph-hc*chtr(i)
             sapmh=sapmh-hc*chpm(i)
             samph=samph-hc*chmp(i)
            end if
c          if(n.lt.5) write(6,'(3i6,8f9.4)') iflag_SAMP,n,i,hc*100.
           end do     ! i=1,jge

           array_fr(ni+1)= satraceh
           array_fr(ni+2)= sapph
           array_fr(ni+3)= sapmh
           array_fr(ni+4)= samph
c          if(abs(n).lt.5) write(6,'(a1,i2,i6,8f9.4)')'$', n,ni,
c     &      (array_fr(ni+i)*10.,i=1,4)

           satraceh=0.
           sapph=cmplx(0.,0.)
           sapmh=cmplx(0.,0.)
           samph=cmplx(0.,0.)
           do i=1,jge
            nd=-nsampling*n-nE(i)
            if(abs(nd).le.nLG) then
             if(nd.gt.0) then
              hc=conjg(array_fr(iposLG+nd))
             else
              hc=-array_fr(iposLG-nd)
             end if
             satraceh=satraceh-hc*htr(i)
             sapph=sapph-hc*chtr(i)
             sapmh=sapmh-hc*chpm(i)
             samph=samph-hc*chmp(i)
            end if
c           if(n.lt.5) write(6,'(3i6,8f9.4)') iflag_SAMP,-n,i,hc*100.
           end do     ! i=1,jge

           array_fr(ni+5)= satraceh
           array_fr(ni+6)= sapph
           array_fr(ni+7)= sapmh
           array_fr(ni+8)= samph
c           if(abs(n).lt.5) write(6,'(a1,i2,i6,8f9.4)')'$', n,ni,
c     &      (array_fr(ni+i)*10.,i=1,4)
         end do       ! n loop

        else
         do n=iput+1,iput+(nTH+1)*8
          array_fr(n)=(0.,0.)
         end do
         srw=srw8*nsampling
c        write(6,'(a,i4,2x,f15.6)')'theomoss2 nsampling,srw=',
c     &              nsampling,srw
c         write(6,'(a,L5,3f10.3)')
c     &     'a theomoss b_Gauss,gamnat,w_Lorentz,w_Gauss=',
c     &     b_Gauss,gamnat,w_Lorentz,w_Gauss
         do i=1,jge

          call aLORGAU(b_Gauss,hEagd(i)+aisom,gamnat,srw,
     &                        w_Lorentz,w_Gauss,nTH,iflag_Voigt)

          if(b_trans)then
           hti=aimag(hrtr(i))/2.0
           ctr=real(hrtr(i))*hci/2.0
           cpm=hrpm(i)*hci/2.0
           cmp=conjg(hrpm(i))*hci/2.0
          else
           hti=aimag(hrtr(i))+real(hrtr(i))
           ctr=cmplx(aimag(hrtr(i))-real(hrtr(i)),0.)
           cpm=hrpm(i)
           cmp=conjg(cpm)
          end if
          do n=0,nTH
           ni=iput+8*n
           hc=conjg(cLG(n))
c         if(abs(n).lt.5) write(6,'(a,2i6,8f9.4)')
c     &      ' iflag_SAMP, n,i,hc*100.=',iflag_SAMP,n,hc*100.

           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           array_fr(ni+2)=array_fr(ni+2)-hc*ctr
           array_fr(ni+3)=array_fr(ni+3)-hc*cpm
           array_fr(ni+4)=array_fr(ni+4)-hc*cmp
           hc=conjg(cLG(-n))

           array_fr(ni+5)=array_fr(ni+5)-hc*hti
           array_fr(ni+6)=array_fr(ni+6)-hc*ctr
           array_fr(ni+7)=array_fr(ni+7)-hc*cpm
           array_fr(ni+8)=array_fr(ni+8)-hc*cmp
          end do       ! n loop
         end do        ! i=1,jge
c         write(6,'(a1,2i6,2f10.4)')
c     & ('m',i,iput+i,array_fr(iput+i+1),i=0,8*nTH,nTH)
        end if         ! iflag_SAMP
c      write(6,'(a)') 'theomoss2 before return'
      return
      end

