      subroutine th_hdeqf(isubthe,icase,iput,iget)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer isubthe,icase,iput,iget


c     transmission: fr2 defines external magnetic field, orientation 
c     of the sample by phi,theta,psi is calculated by the routine sample 
c     orientation tansferred by  array_fr to main and than passed to fr2.


      real            avfr2,dum5,Hext,thetaHe,phiHe,
     &                phi,theta,psi,d_x2,x2_eta,x2_phi,x2_theta,x2_psi,
     &                axtexture,dumvfr2
      common/avfr2trf/avfr2,dum5(5),Hext,thetaHe,phiHe,
     &                phi,theta,psi,d_x2,x2_eta,x2_phi,x2_theta,x2_psi,
     &                axtexture,dumvfr2(ivfr2trf-18)
c     b_phi is named b_laba (laboratory angles)
c     b_laba has got the value of b_phi.or.b_theta.or.b_psi 
c     in the routine th_sampleorient
c     b_dum5(5) is reserved place for the parameters thicklay,re_chilay,
c     ai_chilay,roughness,xxx  which are used in scattering theories, 
      logical         b_vfr2,b_dum5,b_Hext,b_thetaHe,b_phiHe,
     &                b_laba,b_theta,b_psi,b_dx2,b_x2eta,
     &                b_x2phi,b_x2theta,b_x2psi,b_axtexture,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,
     &                b_laba,b_theta,b_psi,b_dx2,b_x2eta,b_x2phi,
     &              b_x2theta,b_x2psi,b_axtexture,b_dumvfr2(ivfr2trf-18)


      real          c1,symcase,timeinvers,cTms,
     &              ajg,aje,amueg,amuee,QgdQe,r_E2M1,dumc
      common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,
     &              symcase,timeinvers,dumc(icstrf-10)
      logical       b_c1,b_dum
      common/bcmaps/b_c1,b_dum(icstrf-1)
c     arrays derived from constants are calculated only once (transformation 
c     matrices for equivalent orientations, clebsch Gordan coefficients 
c     in the routine  hamJgJe, ...)
  
      real          avss,
     &              dsx2,sx2eta,sx2phi,sx2theta,sx2psi,
     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE,dumvss
      common/avmaps/avss,
     &              dsx2,sx2eta,sx2phi,sx2theta,sx2psi,
     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE,
     &              dumvss(ivstrf-14)
      logical       b_vss,
     &              b_dsx2,b_sx2eta,b_sx2phi,b_sx2theta,b_sx2psi,
     &              b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvss
      common/bvmaps/b_vss,
     &              b_dsx2,b_sx2eta,b_sx2phi,b_sx2theta,b_sx2psi,
     &              b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,
     &              b_dumvss(ivstrf-14)

c     logical avssfr,avari,dumvssfr
c     common/avsstrf/avssfr,avari(17),dumvssfr(ivsstrf-18)
c     logical b_vssfr,b_vari,b_dumvssfr
c     common/bvsstrf/b_vssfr,b_vari(17),b_dumvssfr(ivsstrf-18)

      logical b_He,b_Hi,b_Hea,b_Hia,b_Hegt0,b_Higt0,b_Hgt0,
     &        b_eq,b_eqa,b_eqgt0,b_sx2,b_sx2a,b_sx2gt0,
     &        b_x2,b_x2a,b_x2gt0,b_xx,b_hf,b_pc
      real    Eagd(maxjge),eagd_zz(2*maxjge),
     &        dj(-5:5,-5:5),
     &        phiH_r,thetaH_r,phi_r,theta_r,psi_r,phiE_r,thetaE_r,
     &        psiE_r,phiHe_r,thetaHe_r,h1,uveca(3,3),vik(3,3),vdd(3,3)

c     parameter(maxloop=5,..) has also to be changed in sym_equiv(...)
      integer ivv,iec,icl,iecv,id1,id2,istore,maxloop
      parameter(maxloop=5,ivv=90,iec=ivv+25,icl=iec+25,iecv=icl+9,
     &          id1=iecv+9,id2=id1+1+10*maxloop,istore=id2+25*maxloop)

      complex eagdzz(maxjge),
     &        efgPAS(-2:2),efgC(-2:2),efgC0(-2:2),efgL(-2:2),
     &        xxPAS(-2:2),sx2C(-2:2),sx2C0(-2:2),x2C(-2:2),
     &        hv(-1:1),hvL(-1:1),hvC(-1:1),hvC0(-1:1),hve(-1:1),
     &        dject(-2:2,-2:2),dsxct(-2:2,-2:2),dxxct(-2:2,-2:2),
     &        djecv(-1:1,-1:1),djclt(-2:2,-2:2),djclv(-1:1,-1:1),
     &        d21(-1:1,-1:1),hc1,Vm(-1:1,maxjge),ctimeinv(maxloop),
     &        d1(-1:1,-1:1,maxloop),d2(-2:2,-2:2,maxloop),efgo(-2:2)


      equivalence (eagdzz(1),eagd_zz(1))
      complex store(istore),caseloop
      equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),
     &            (store(11),efgL(-2)),(store(16),xxPAS(-2)),
     &            (store(21),sx2C(-2)),(store(26),x2C(-2)),
     &            (store(31),hv(-1)),(store(34),hvC(-1)),
     &            (store(37),hvL(-1)),(store(40),dject(-2,-2)),
     &            (store(65),dsxct(-2,-2)),(store(ivv),dxxct(-2,-2)),
     &            (store(iec),djclt(-2,-2)),
     &            (store(icl),djecv(-1,-1)),(store(iecv),djclv(-1,-1)),
     &            (store(id1),caseloop),(store(id1+1),ctimeinv(1)),
     &       (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))

      integer i,j,k,l,m,n,
     &        indx(maxjge),ncase,nloop,jloop,Npow,ip,ii
      real    a_mueg,a_muee,qg_qe,c_tms,fn,fm,efg0,efg2,pi,rad,
     &        timeinv(maxloop),aszz,azz,
     &        q62,vxx,vyy,vzz,vxy,vxz,vyz,xx0,xx2,
     &        hr,hm,hx,hy,hz
      
      jge=(2.*ajg+1)*(2.*aje+1)+0.01

      if(isubthe.lt.0) then
       nloop=symcase
       c1=2+3*jge*(nloop+1)+istore
       theoryname='H_DEQ_f_equivalent_sites'
c       write(6,'(a,3i6)') '<0 th_routines1 acmaps:',jge,nloop,istore
       return
      end if
c      write(6,'(a,2i8)')' th_hdeqf iput,iget=',iput,iget
c      write(6,'(a)')' th_hdeqf avmaps ::'
c      write(6,'(10f10.3)')avss,
c     &              dsx2,sx2eta,sx2phi,sx2theta,sx2psi,
c     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE
c      write(6,'(a,10f10.2)') 'th_routines1 acmaps:',c1,symcase,
c     &       timeinvers,cTms,ajg,aje,amueg,amuee
     
c      if(b_vss) then
c       do i=1,26+istore
c        stocomp(i)=array_fr(iput+i)
c       end do
c      end if

c       write(6,'(20L3)')b_vss,
c     &              b_dsx2,b_sx2eta,b_sx2phi,b_sx2theta,b_sx2psi,
c     &              b_aH,b_thetaH,b_phiH,
c     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE
c       if(b_vssfr) then
c        write(6,'(2L2,3x,20L3)')b_vssfr,b_vss,b_vari
c        write(6,'(2f10.3,3x,20f10.3)')avssfr,avss,avari
c       b_sx2a=.true.
c       b_sx2 =.true.
c       b_x2a =.true.
c       b_x2  =.true.
c       b_xx  =.true.
c       b_Hea=.true.
c       b_He=.true.
c       b_Hia=.true.
c       b_Hi=.true.

c       b_eqa=.true.
c       b_eq=.true.
c       b_hf=.true.
c       b_pc=.true.
c       else
       b_sx2a=b_sx2phi.or.b_sx2theta.or.b_sx2psi
       b_sx2 =b_sx2eta.or.b_sx2a
       b_x2a =b_x2eta.or.b_x2phi.or.b_x2theta.or.b_x2psi
       b_x2  =b_x2eta.or.b_x2a
       b_xx  =b_dsx2.or.b_sx2.or.b_dx2.or.b_x2.or.b_laba
       b_Hea=b_thetaHe.or.b_phiHe
       b_He=b_Hext.or.b_Hea
       b_Hia=b_thetaH.or.b_phiH
       b_Hi=b_aH.or.b_Hia
c     b_DEq     
      b_eqa=b_phiE.or.b_thetaE.or.b_psiE
      b_eq=b_DEq.or.b_eta.or.b_eqa
      b_hf=b_He.or.b_Hi.or.b_eq.or.b_laba
      b_pc=b_hf.or.b_xx
c      end if

      if(.not.b_pc) then
       isubthe=-abs(isubthe)
       return
      end if
      Lp=1
      call symbol3j(aje,Lp,ajg) 

c     logicals
      b_sx2gt0=abs(dsx2).gt.0.
      b_x2gt0=abs(d_x2).gt.0.

      pi=atan(1.)*4.
      rad=atan(1.)/45.
      a_mueg=amueg
      a_muee=amuee
      Qg_Qe=QgdQe
      c_Tms=cTms

      j=iput+2+3*jge
c      write(6,'(a,i8)') ' th_deqf j=iput+3*jge=',j
      do i=1,id1-1
       store(i)=array_fr(j+i)
      end do

      if(b_c1) then
       ncase=symcase
       call sym_equiv(ncase,timeinvers,nloop,ctimeinv,
     &                         d1,d2)
       caseloop=cmplx(float(nloop),symcase)
      else     
       do i=id1,istore
        store(i)=array_fr(j+i)
       end do
       nloop=real(caseloop)
      end if

      do k=1,maxloop
       timeinv(k)=real(ctimeinv(k))
      end do


      if(b_sx2) then
       if(b_sx2a)then
        call dewigner(2,sx2theta*rad,dj)
        do m=-2,2
        do n=-2,2
         fn=float(n)*sx2psi*rad
         fm=float(m)*sx2phi*rad
         dsxct(n,m)=cmplx(cos(fm+fn),sin(fm+fn))*dj(m,n)
        end do
        end do
       end if

c      xxPAS (-2..2) are the spherical tensor components of sx2 in the PAS
c      sx2 is the tensor attached to site 1 (of nloop+1 equivalent sites)
c      of the crystal 
       xx0=1.0/sqrt(1.0+sx2eta**2/3.)
       xx2=sx2eta*xx0/sqrt(6.)
  
       xxPAS(0)=cmplx(xx0,0.0)
       xxPAS(-1)=(0.,0.)
       xxPAS(1)=(0.,0.)
       xxPAS(-2)=cmplx(xx2,0.)
       xxPAS(2)=cmplx(xx2,0.)
  
       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+xxPAS(m)*dsxct(m,n)
        end do
        sx2C(n)=hc1
       end do
      end if  ! b_sx2

      if(b_x2) then
       if(b_x2a)then
        call dewigner(2,x2_theta*rad,dj)
        do m=-2,2
        do n=-2,2
         fn=float(n)*x2_psi*rad
         fm=float(m)*x2_phi*rad
         dxxct(n,m)=cmplx(cos(fm+fn),sin(fm+fn))*dj(m,n)
        end do
        end do
       end if
c      xxPAS (-2..2) are the spherical tensor components of x2 in the PAS
c      x2 are the tensor of the crystal (which has nloop+1 sites 
c      with tensors sx2)
       xx0=1.0/sqrt(1.0+x2_eta**2/3.)
       xx2=x2_eta*xx0/sqrt(6.)
  
       xxPAS(0)=cmplx(xx0,0.0)
       xxPAS(-1)=(0.,0.)
       xxPAS(1)=(0.,0.)
       xxPAS(-2)=cmplx(xx2,0.)
       xxPAS(2)=cmplx(xx2,0.)
  
       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+xxPAS(m)*dxxct(m,n)
        end do
        x2C(n)=hc1
       end do

c      transformation of the x2 tensor of the crystal to the lab-system
c      gamma parallel to +z of the lab-system
c      azz and d_x2 (invariant scalar) in the lab-system
       hc1=(0.,0.)
       do m=-2,2
        hc1=hc1+x2C(m)*djclt(m,0)
       end do
       azz=real(hc1)*2.0
      end if   ! b_x2


      b_eqgt0=abs(DEq).gt.0.      
      b_Hegt0=abs(Hext).gt.0.0
      b_Higt0=abs(aH).gt.0.0
      b_Hgt0=b_Higt0.or.b_Hegt0

      phi_r=phi*rad
      theta_r=theta*rad
      psi_r=psi*rad

      phiE_r=-psiE*rad
      thetaE_r=-thetaE*rad
      psiE_r=-phiE*rad

      if(b_laba)then
c      vector transformation matrix: sample to Lab
       call dewigner(1,theta_r,dj)
       do m=-1,1
       do n=-1,1
        fn=float(n)*psi_r
        fm=float(m)*phi_r
        djclv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   !!!!!
       end do
       end do

c      2. rank tensor transformation matrix: sample to Lab
       call dewigner(2,theta_r,dj)
       do m=-2,2
       do n=-2,2
        fn=float(n)*psi_r
        fm=float(m)*phi_r
        djclt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   ! !!!!
       end do
       end do
      end if  ! b_laba (lab angle)
        
c      if(b_eq)then
c       if(b_eqa)then
        call dewigner(2,thetaE_r,dj)
        do m=-2,2
        do n=-2,2
         fn=float(n)*psiE_r
         fm=float(m)*phiE_r
         dject(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
c       end if

c      efg (-2..2) are the spherical tensor components of the EFG in the PAS
       efg0=1.0/sqrt(1.+eta**2/3.)
       efg2=eta*efg0/sqrt(6.)

       efgPAS(0)=cmplx(efg0,0.0)
       efgPAS(-1)=(0.,0.)
       efgPAS(1)=(0.,0.)
       efgPAS(-2)=cmplx(efg2,0.)
       efgPAS(2)=cmplx(efg2,0.)

       do n=-2,2
        efgo(n)=efgC(n)
       end do

       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+efgPAS(m)*dject(m,n)
        end do
        efgC(n)=hc1
       end do


       hr=0.0
       do n=-2,2
        hr=hr+real(efgo(n)*conjg(efgo(n)))
     &       -real(efgC(n)*conjg(efgC(n)))
       end do
c       if(.not.b_eq)write(6,'(a,g15.5)') 'hr=',hr 
c      end if  ! b_eq
     
c-------------------EFG in the crystal system -----------------------------
        if(enwr(6)(1:1).eq.'y') then
         q62=sqrt(6.0)/2.0
         vxx=real(-efgC(0)+q62*(efgC(2)+efgC(-2)))
         vyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2)))
         vzz=2*real(efgC(0))
         vxy=aimag(q62*(efgC(2)-efgC(-2)))
         vxz=-real(q62*(efgC(1)-efgC(-1)))
         vyz=-aimag(q62*(efgC(1)+efgC(-1)))

         call dewigner(1,thetaE_r,dj)
         do m=-1,1
          do n=-1,1
           fn=float(n)*psiE_r
           fm=float(m)*phiE_r
           d21(n,m)=cmplx(cos(fm+fn),sin(fm+fn))*dj(m,n)        
          end do
         end do
    
         uveca(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
         uveca(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
         uveca(1,3)=-1./sqrt(2.)*real(d21(0,1)-d21(0,-1))
    
         uveca(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
         uveca(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
         uveca(2,3)=-1./sqrt(2.)*aimag(d21(0,1)+d21(0,-1))
    
         uveca(3,1)=-1./sqrt(2.)*real(d21(1,0)-d21(-1,0))
         uveca(3,2)=1./sqrt(2.)*aimag(d21(1,0)+d21(-1,0))
         uveca(3,3)=real(d21(0,0))
  

         vik(1,1)=vxx
         vik(1,2)=vxy
         vik(1,3)=vxz
         vik(2,1)=vxy
         vik(2,2)=vyy
         vik(2,3)=vyz
         vik(3,1)=vxz
         vik(3,2)=vyz
         vik(3,3)=vzz
         
         do i=1,3
         do l=1,3
          h1=0.0
          do j=1,3
          do k=1,3
           h1=h1+uveca(i,k)*vik(k,j)*uveca(l,j)
          end do
          end do
          vdd(i,l)=h1
         end do
         end do

         write(nwr,'(10x,a,3(f7.3,a1))')
     &    '      ( ',vdd(1,1),',',vdd(1,2),',',vdd(1,3),')'
         write(nwr,'(a10,a,3(f7.3,a1))')'EFG/PAS   ',
     &    'vik = ( ',vdd(2,1),',',vdd(2,2),',',vdd(2,3),')'
         write(nwr,'(10x,a,3(f7.3,a1),/)')
     &    '      ( ',vdd(3,1),',',vdd(3,2),',',vdd(3,3),')'

c         write(nwr,'(2(6x,a,3(f8.3,a1)))')
c     &    'eQx=(',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'
c         write(nwr,'(2(6x,a,3(f8.3,a1)))')
c     &    'eQy=(',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'
c         write(nwr,'(2(6x,a,3(f8.3,a1)))')
c     &    'eQz=(',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'

         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &    '            x ( ',vxx,vxy,vxz,')',
     &    '   = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')' 

         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &    '<i|V_C|k> = y ( ',vyy,vyz,')',
     &    'eQ = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'
         write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &    '            z ( ',vzz,')',
     &    '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'

        end if
c--------------------------------------------------------------------

       if(b_Hi) then
c       internal field 
        if(b_Hia) then
         phiH_r=phiH*rad
         thetaH_r=thetaH*rad
         hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*
     &                  sin(thetaH_r)/sqrt(2.0)
         hv(0) = cmplx(cos(thetaH_r),0.0)
         hv(-1)=-conjg(hv(1))
c        write(6,'(a,8f12.4)') 'hv    =',(hv(i),i=-1,1)
        end if ! b_Hia

        if(icase.eq.1) then
c        internal field with respect to the EFG system   
c        transformation of the magnetic field H from the  S_E to the 
c        crystal system S_C
c        hvC(n) in the crystal system  S_C 
         if(b_eqa)then
          call dewigner(1,thetaE_r,dj)
          do m=-1,1
          do n=-1,1
           fn=float(n)*psiE_r
           fm=float(m)*phiE_r
           djecv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
          end do
          end do
         end if
         do n=-1,1
          hc1=(0.,0.)
          do m=-1,1
           hc1=hc1+hv(m)*djecv(m,n)
          end do
           hvC(n)=hc1
         end do
c         write(6,'(a,8f12.4)') 'hv    =',(hvC(i),i=-1,1)
        else
c        magnetic field given in the crystal system Sc
         do i=-1,1
          hvC(i)= hv(i)
         end do
        end if ! case 1
       end if  ! b_Hi
c--------------------H-field in the crystal system -----------------
       if(enwr(6)(3:3).eq.'y') then
        hx=-real(hvC(1)-hvC(-1))/sqrt(2.0)
        hy=-aimag((hvC(1)+hvC(-1)))/sqrt(2.0)
        hz=real(hvC(0))
        write(nwr,'(/,a,3f8.3,a1)')'        h_C =   (', hx,hy,hz,')'
       end if
c--------------------------------------------------------------------
       if(b_Hea)then         
c       external field defined in the LAB system S_L
        phiHe_r=phiHe*rad
        thetaHe_r=thetaHe*rad
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*
     &                  sin(thetaHe_r)/sqrt(2.0)
        hve(0) = cmplx(cos(thetaHe_r),0.0)
        hve(-1)=-conjg(hve(1))
       end if

c      dipole transitions:
       Lp=1

       hc1=(0.,0.)
       if(.not.b_Hgt0) then
        do n=-1,1
         hvL(n)=hc1
        end do
       end if ! .not.b_Hgt0
       if(.not.b_eqgt0)then         
        do n=-2,2
         efgL(n)=hc1
        end do
       end if   ! .not.b_eqgt0
       if(.not.b_sx2gt0)then         
        aszz=0.0
       end if   ! .not.b_sx2gt0

       if(nloop.gt.0) then
        do m=-2,2
         efgC0(m)=efgC(m)
        end do
        do m=-2,2
         sx2C0(m)=sx2C(m)
        end do
        do i=-1,1
         hvC0(i)=hvC(i)
        end do
       end if


       Npow=1

       do jloop=0,nloop
        if(jloop.gt.0) then
         if(b_Higt0) then
          do n=-1,1
           hc1=(0.,0.)
           do m=-1,1
            hc1=hc1+hvC0(m)*d1(m,n,jloop)
           end do
           hvC(n)=hc1*timeinv(jloop)
          end do
         end if       
         if(b_eqgt0)then         
          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+efgC0(m)*d2(m,n,jloop)
           end do
           efgC(n)=hc1
          end do
         end if
         if(b_sx2gt0)then         
          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+sx2C0(m)*d2(m,n,jloop)
           end do
           sx2C(n)=hc1
          end do
         end if
        end if  ! jloop > 0

c------------------- transformation of EFG_C -----------------------------
        if(enwr(6)(1:1).eq.'y') then
        q62=sqrt(6.0)/2.0
        vxx=real(-efgC(0)+q62*(efgC(2)+efgC(-2)))
        vyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2)))
        vzz=2*real(efgC(0))
        vxy=aimag(q62*(efgC(2)-efgC(-2)))
        vxz=-real(q62*(efgC(1)-efgC(-1)))
        vyz=-aimag(q62*(efgC(1)+efgC(-1)))

        write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &  '            x ( ',vxx,vxy,vxz,')',
     &  '   = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')' 

        write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &  '<i|v_c|k> = y ( ',vyy,vyz,')',
     &  'eQ = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'
        write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &  '            z ( ',vzz,')',
     &  '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'

        end if
c----------------------------------------------------------------------
    
        if(b_Hgt0) then
         do n=-1,1
          hc1=(0.,0.)
          do m=-1,1
           hc1=hc1+hvC(m)*djclv(m,n)
          end do
          hvL(n)=hc1*aH+hve(n)*Hext
         end do
        end if ! b_Hgt0
 
        if(b_eqgt0)then         
         do n=-2,2
          hc1=(0.,0.)
          do m=-2,2
           hc1=hc1+efgC(m)*djclt(m,n)
          end do
          efgL(n)=hc1*DEq
         end do
        end if   ! b_eqgt0

        if(b_sx2gt0)then         
         hc1=(0.,0.)
         do m=-2,2
          hc1=hc1+sx2C(m)*djclt(m,0)
         end do
         aszz=real(hc1)*2.0
        end if   ! b_sx2gt0

        if(b_x2gt0)then  
         hc1=(0.,0.)
         do m=-2,2
          hc1=hc1+x2C(m)*djclt(m,0)
         end do
         azz=real(hc1)*2.0
        end if   ! b_x2gt0

c--------------- EFG in the Lab system ---------------------------
        if(enwr(6)(2:2).eq.'y') then

c        write(6,'(a,8f12.4)') 'hvL    =',(hvL(i),i=-1,1)
c        write(6,'(a,10f12.4)') 'efgL    =',(efgL(i),i=-2,2)
         write(nwr,'(a)')
         q62=sqrt(6.0)/2.0
         vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2)))
         vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2)))
         vzz=2*real(efgL(0))
         vxy=aimag(q62*(efgL(2)-efgL(-2)))
         vxz=-real(q62*(efgL(1)-efgL(-1)))
         vyz=-aimag(q62*(efgL(1)+efgL(-1)))
         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',vxx,vxy,vxz,')'
         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',vyy,vyz,')'
         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',vzz,')'
        end if
c---------------------------------------------------------------------
c----------------H-field in the Lab system ---------------------------
        if(enwr(6)(4:4).eq.'y') then
         hx=-real(hvL(1)-hvL(-1))/sqrt(2.0)
         hy=-aimag((hvL(1)+hvL(-1)))/sqrt(2.0)
         hz=real(hvL(0))
         write(nwr,'(/,a,3f8.3,a1)')'        h_L =   (', hx,hy,hz,')'
        end if
c---------------------------------------------------------------------
        call hamJgJe(a_mueg,a_muee,Qg_Qe,c_Tms,hvL,efgL,Eagd,Vm)

c       write(6,'(8f10.6)') (Eagd(i),i=1,jge)
c       hr=0.0
c       do i=1,7,6
c        hr=hr+real(conjg(Vm(1,i))*Vm(1,i))
c        hr=hr+real(conjg(Vm(1,i+1))*Vm(1,i+1))
c       end do
c       write(6,'(a,g12.6)') '1 sum real(conjg(Vm( 1,i))*Vm( 1,i))=',hr
c       hr=0.0
c       do i=1,7,6
c        hr=hr+real(conjg(Vm(-1,i))*Vm(-1,i))
c        hr=hr+real(conjg(Vm(-1,i+1))*Vm(-1,i+1))
c       end do
c       write(6,'(a,f10.6)') '1 sum real(conjg(Vm(-1,i))*Vm(-1,i))=',hr
   
c       hr=0.0
c       do i=3,6
c        hr=hr+real(conjg(Vm(1,i))*Vm(1,i))
c       end do
c       write(6,'(a,f10.6)') '3 sum real(conjg(Vm( 1,i))*Vm( 1,i))=',hr
c       hr=0.0
c       do i=3,6
c        hr=hr+real(conjg(Vm(-1,i))*Vm(-1,i))
c       end do
c       write(6,'(a,f10.6)') '3 sum real(conjg(Vm(-1,i))*Vm(-1,i))=',hr
c       write(6,'(8f10.6)') (real(conjg(Vm(1,i))*Vm(1,i)),i=1,jge)
c       write(6,'(8f10.6)') (real(conjg(Vm(0,i))*Vm(0,i)),i=1,jge)
c       write(6,'(8f10.6)') (real(conjg(Vm(-1,i))*Vm(-1,i)),i=1,jge)

        ip=iput+2+3*jge*jloop
        do i=1,jge
         ii=ip+3*(i-1)
         eagdzz(i)=array_fr(ii+1)
        end do
        if(b_xx.and.b_hf) then
         if(nloop.gt.0.and..not.b_Hegt0) then
          call INDEXX(jge,Eagd,indx)
          do j=1,jge
           i=indx(j)
           ii=ip+3*(i-1)
           hr =real(conjg(Vm(1,i))*Vm(1,i))
           hm=real(conjg(Vm(-1,i))*Vm(-1,i))
           eagd_zz(2*i-1)=Eagd(i)
           array_fr(ii+2)=cmplx(hr-hm,hr+hm)/2.0
           array_fr(ii+3)=conjg(Vm(1,i))*Vm(-1,i)
c           write(6,'(a,i6,2f12.3)')'  ii,array_fr(ii+2)=',
c     &                               ii,array_fr(ii+2) 
          end do
          eagd_zz(2)=aszz
          eagd_zz(4)=dsx2
          eagd_zz(6)=azz
          eagd_zz(8)=d_x2
          eagd_zz(10)=aszz*dsx2+azz*d_x2 
          do i=1,jge
           ii=ip+3*(i-1)
           array_fr(ii+1)=eagdzz(i)
          end do
         else !    if(nloop.eq.0.or.b_Hegt0) then
          do i=1,jge
           ii=ip+3*(i-1)
           hr =real(conjg(Vm(1,i))*Vm(1,i))
           hm=real(conjg(Vm(-1,i))*Vm(-1,i))
           eagd_zz(2*i-1)=Eagd(i)
           array_fr(ii+2)=cmplx(hr-hm,hr+hm)/2.0
           array_fr(ii+3)=conjg(Vm(1,i))*Vm(-1,i)
c           write(6,'(a,i6,2f12.3)')' 1 ii,array_fr(ii+2)=',
c     &                               ii,array_fr(ii+2) 
          end do
          eagd_zz(2)=aszz
          eagd_zz(4)=dsx2
          eagd_zz(6)=azz
          eagd_zz(8)=d_x2
          eagd_zz(10)=aszz*dsx2+azz*d_x2 
          do i=1,jge
           ii=ip+3*(i-1)
           array_fr(ii+1)=eagdzz(i)
          end do
         end if ! if nloop>0
        else if(b_xx.and..not.b_hf) then
         eagd_zz(2)=aszz
         eagd_zz(4)=dsx2
         eagd_zz(6)=azz
         eagd_zz(8)=d_x2 
         eagd_zz(10)=aszz*dsx2+azz*d_x2 
         do i=1,jge
          ii=ip+3*(i-1)
          array_fr(ii+1)=eagdzz(i)
         end do
        else if(.not.b_xx.and.b_hf) then
         if(nloop.gt.0.and..not.b_Hegt0) then
          call INDEXX(jge,Eagd,indx)
          do j=1,jge
           i=indx(j)
           ii=ip+3*(i-1)
           hr =real(conjg(Vm(1,i))*Vm(1,i))
           hm=real(conjg(Vm(-1,i))*Vm(-1,i))
           eagd_zz(2*i-1)=Eagd(i)
           array_fr(ii+2)=cmplx(hr-hm,hr+hm)/2.0
           array_fr(ii+3)=conjg(Vm(1,i))*Vm(-1,i)
          end do
          do i=1,jge
           ii=ip+3*(i-1)
           array_fr(ii+1)=eagdzz(i)
          end do
         else !          if(nloop.eq.0.or.b_Hegt0) then
          do i=1,jge
           ii=ip+3*(i-1)
           hr =real(conjg(Vm(1,i))*Vm(1,i))
           hm=real(conjg(Vm(-1,i))*Vm(-1,i))
           eagd_zz(2*i-1)=Eagd(i)
           array_fr(ii+2)=cmplx(hr-hm,hr+hm)/2.0
           array_fr(ii+3)=conjg(Vm(1,i))*Vm(-1,i)
c           write(6,'(a,i6,2f12.3)')'* ii,array_fr(ii+2)=',
c     &                               ii,array_fr(ii+2) 
          end do
          do i=1,jge
           ii=ip+3*(i-1)
           array_fr(ii+1)=eagdzz(i)
          end do
         end if  ! if nloop>0
        end if   ! b_xx,b_hf
       end do    ! nloop
     
      
c     decription of storage in array_fr
c     array_fr(iput+1)= (Npow,nloop)    array_fr(iput+2)= (jge,b_xx)
c     array_fr(iput+3)= (Eagd(1),aszz)  array_fr(iput+6)= (Eagd(2),dsx2)         
c     array_fr(iput+9)= (Eagd(9),azz)   array_fr(iput+12)=(Eagd(4),d_x2)          
c     array_fr(iput+15)=(Eagd(5),exp(-azz*d_x2-aszz*dsx2) 
c     array_fr(iput+18)=(Eagd(6),x1) ... array_fr(iput+3*jge)=(Eagd(jge),xj)
c     x1,xj are not yet defined-reserved for later use
c     array_fr(iput+4)= (hr-hm,hr+hm)/2 (1) 
c           ...
c     array_fr(iput+3*jge+1)= (hr-hm,hr+hm)/2 (jge)
c     array_fr(iput+5)= conjg(Vm(1,1))*Vm(-1,1) 
c           ...
c     array_fr(iput+3*jge+2)= conjg(Vm(1,jge))*Vm(-1,jge)
c 
c     for the case: b_xx=.false. the f-factor fd=exp(-azz*d_x2-aszz*dsx2) 
c     itself is stored  

      j=iput+2+3*jge*(nloop+1)*Npow
      array_fr(iput+1)=cmplx(float(Npow),float(nloop+1))
      if(b_xx) then
       array_fr(iput+2)=cmplx(float(jge),1.0)
      else
      array_fr(iput+2)=cmplx(float(jge),0.0)
      end if
c      write(6,'(a,i8)') ' th_deqf j=',j
      do i=1,istore
       array_fr(j+i)=store(i)
      end do
       return
      end




      subroutine th_hdeq(isubthe,icase,iput,iget)
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer isubthe,icase,iput,iget

      parameter (idumvfr1=ivfr1trf-8)
      real   avfr1,pvfr1,aHL,thetaHL,phiHL,phiAL,thetaAL,psiAL,dumvfr1
      common/avfr1trf/avfr1,pvfr1,aHL,thetaHL,phiHL,
     &                phiAL,thetaAL,psiAL,dumvfr1(idumvfr1)
      logical         b_vfr1,b_pvfr1,b_aHL,b_thetaHL,b_phiHL,
     &                b_phiAL,b_thetaAL,b_psiAL,b_dumvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_aHL,b_thetaHL,b_phiHL,
     &                b_phiAL,b_thetaAL,b_psiAL,b_dumvfr1(idumvfr1)

      real          c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,
     &              cnconz,cncony,dumc
      common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,
     &              cnconz,cncony,dumc(icstrf-10)

      real          avm,aH,thetaH,phiH,
     &              DEq,eta,phiE,thetaE,psiE,dumvm
      common/avmaps/avm,aH,thetaH,phiH,
     &              DEq,eta,phiE,thetaE,psiE,dumvm(ivstrf-9)
      logical       b_vm,b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm
      common/bvmaps/b_vm,b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm(ivstrf-9)



      logical b_HX,b_HS,b_efg,b_eqgt0,b_HXgt0,b_HSgt0,b_EA,b_AL,b_pc
      real    dj(-5:5,-5:5),Eagd(maxjge),
     &        rpp(maxjge),rpmr(maxjge),rpmi(maxjge),rmm(maxjge),
     &        phiH_r,thetaH_r,phiHL_r,thetaHL_r,phiE_r,thetaE_r,
     &        psiE_r,h1,h2

      complex rtr(maxjge),rpm(maxjge),
     &        efgPAS(-2:2),efgC(-2:2),efgL(-2:2),Vm(-1:1,maxjge),
     &        aVp1,aV00,aVm1,hc1,
     &        hv(-1:1),hvL(-1:1),hvC(-1:1),hvX(-1:1),
     &        djec(-2:2,-2:2),djcl(-2:2,-2:2),djecv(-1:1,-1:1),
     &        djclv(-1:1,-1:1)


      parameter(ivv=25,iec=ivv+25,icl=iec+25,iecv=icl+9)
      complex store(iecv+9)
      equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),
     &            (store(11),efgL(-2)),(store(16),hv(-1)),
     &            (store(19),hvC(-1)),(store(22),hvL(-1)),
     &            (store(ivv),djec(-2,-2)),(store(iec),djcl(-2,-2)),
     &            (store(icl),djecv(-1,-1)),(store(iecv),djclv(-1,-1))

c      write(6,'(a,5f10.3)')'theory02 acsp,ajg,aje,amueg,amuee=',
c     & acsp,ajg,aje,amueg,amuee
c      write(6,'(a,4i8,a)')'th_hdeq isubthe,icase,iput,iget=',
c     &                  isubthe,icase,iput,iget


      jge=(2.*ajg+1)*(2.*aje+1)+0.01

      if(isubthe.lt.0) then
        c1=3*jge+iecv+9
c        c1=3*jge
       theoryname='H_DEQ_equivalent_sites'
       return
      end if
      ist02=iput

      j=iput+3*jge
      do i=1,iecv+9
       store(i)=array_fr(j+i)
      end do
c      write(6,'(a)')' th_hdeq avmaps ::'
c      write(6,'(10f10.3)')avm,aH,thetaH,phiH,
c     &              DEq,eta,phiE,thetaE,psiE

c       write(6,'(a,8f12.4)') 'hvL    =',(hvL(i),i=-1,1)
c       write(6,'(a,8f12.6)') 'efgL_r=',(real(efgL(i)),i=-2,2)
c       write(6,'(a,8f12.6)') 'efgL_i=',(aimag(efgL(i)),i=-2,2)

c     dipole transitions:

c     logicals
      b_efg=b_DEq.or.b_eta
      b_eqgt0=abs(DEq).gt.0.
      b_HXgt0=aHL.gt.0.0
      b_HSgt0=aH.gt.0.0

      b_HX=b_aHL.or.b_thetaHL.or.b_phiHL
      b_HS=b_aH.or.b_thetaH.or.b_phiH

      pi=atan(1.)*4.
      rad=atan(1.)/45.

      b_AL=b_phiAL.or.b_thetaAL.or.b_psiAL
      phiAL_r=-psiAL*rad
      thetaAL_r=-thetaAL*rad
      psiAL_r=-phiAL*rad

      b_EA=b_phiE.or.b_thetaE.or.b_psiE
      phiE_r=-psiE*rad
      thetaE_r=-thetaE*rad
      psiE_r=-phiE*rad

      a_mueg=amueg
      a_muee=amuee
      Qg_Qe=QgdQe
      c_Tms=cTms

      b_pc=b_efg.or.b_HX.or.b_HS.or.b_AL.or.b_EA
      if(.not.b_pc) then
       isubthe=-abs(isubthe)
       return
      end if

      Lp=1
      call symbol3j(aje,Lp,ajg) 
c       write(6,'(a)') 'djcl'
c       write(6,'(10f10.3)') djcl

  
c     icase=1,2 magnetic field aH defined with respect to S_E,S_C

       nconyi=abs(cncony)
       nconzi=cnconz
       inv_time=cncony

        
       if(b_eqgt0)then
c       efg (-2..2) are the spherical tensor components of the EFG in the PAS
        eQVzz=DEq/sqrt(1.+eta**2/3.)*2.
        efg0=eQVzz/2.
        efg2=eta*efg0/sqrt(6.)
 
        efgPAS(0)=cmplx(efg0,0.0)
        efgPAS(-1)=(0.,0.)
        efgPAS(1)=(0.,0.)
        efgPAS(-2)=cmplx(efg2,0.)
        efgPAS(2)=cmplx(efg2,0.)
       else
        do i=-2,2
         efgPAS(i)=cmplx(0.0,0.0)
        end do
        do i=-2,2
         efgL(i)=cmplx(0.0,0.0)
        end do
       end if

c       write(6,'(a,5f12.6)') '  efg=', eQVzz,eta,phiE,thetaE,psiE
c      write(6,'(a,5f12.6)') '    H=',aH,phiH,thetaH
c      write(6,'(a,5f12.6)') '    A=',phiAL,thetaAL,psiAL
c       write(6,'(a,3i6)')'thmossub  sym=',inv_time,nconyi,nconzi

       if(b_HXgt0)then         
c       external field defined in the LAB system S_L
        phiHL_r=phiHL*rad
        thetaHL_r=thetaHL*rad
        hvX(1) =-cmplx(cos(phiHL_r),sin(phiHL_r))*
     &                  sin(thetaHL_r)/sqrt(2.0)*aHL
        hvX(0) = cmplx(cos(thetaHL_r),0.0)*aHL
        hvX(-1)=-conjg(hvL(1))
       else
        do i=-1,1
         hvX(i)= cmplx(0.0,0.0)
        end do
       end if

       if(b_HSgt0) then
c       internal field defined in the system S_L

        phiH_r=phiH*rad
        thetaH_r=thetaH*rad
        hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*
     &                  sin(thetaH_r)/sqrt(2.0)*aH
        hv(0) = cmplx(cos(thetaH_r),0.0)*aH
        hv(-1)=-conjg(hv(1))
c        write(6,'(a,8f12.4)') 'hv    =',(hv(i),i=-1,1)
       else
        do i=-1,1
         hv(i)= cmplx(0.0,0.0)
        end do
        do i=-1,1
         hvL(i)= hvX(i)
        end do
       end if

      if(nconyi+nconzi.gt.0) then
c      transformation:
c      Sum;n T(n)*Dnm(phiE,tetaE,psiE) = T(m)
 
       if(b_eqgt0)then
        if(b_EA)then
         call dewigner(2,thetaE_r,dj)
c        write(6,'(a,5f12.6)') 'rad,efg=', rad,phiE_r,psiE_r
         do m=-2,2
         do n=-2,2
          fn=float(n)*psiE_r
          fm=float(m)*phiE_r
          djec(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
         end do
        end if

        do n=-2,2
         hc1=(0.,0.)
         do m=-2,2
          hc1=hc1+efgPAS(m)*djec(m,n)
         end do
         efgC(n)=hc1
        end do

c       q62=sqrt(6.0)/2.0
c       vxx=real(-efgC(0)+q62*(efgC(2)+efgC(-2)))
c       vyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2)))
c       vzz=2*real(efgC(0))
c       vxy=aimag(q62*(efgC(2)-efgC(-2)))
c       vxz=-real(q62*(efgC(1)-efgC(-1)))
c       vyz=-aimag(q62*(efgC(1)+efgC(-1)))
c       write(6,'(8x,a,3f8.3,a1)')   '          x (',vxx,vxy,vxz,')'
c       write(6,'(8x,a,8x,2f8.3,a1)')'<i|V|k> = y (',vyy,vyz,')'
c       write(6,'(8x,a,16x,f8.3,a1)')'          z (',vzz,')'

        if(b_AL)then
c        absorber/crystal in the Lab system
         call dewigner(2,thetaAL_r,dj)
         do m=-2,2
         do n=-2,2
          fn=float(n)*psiAL_r
          fm=float(m)*phiAL_r
          djcl(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
         end do
        end if
        do n=-2,2
         hc1=(0.,0.)
         do m=-2,2
          hc1=hc1+efgC(m)*djcl(m,n)
         end do
         efgL(n)=hc1
        end do

c       if(nfit(0).eq.0) then
c        q62=sqrt(6.0)/2.0
c        vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2)))
c        vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2)))
c        vzz=2*real(efgL(0))
c        vxy=aimag(q62*(efgL(2)-efgL(-2)))
c        vxz=-real(q62*(efgL(1)-efgL(-1)))
c        vyz=-aimag(q62*(efgL(1)+efgL(-1)))
c        write(nwr,'(8x,a,3f8.3,a1)')   '          x (',vxx,vxy,vxz,')'
c        write(nwr,'(8x,a,8x,2f8.3,a1)')'<i|V|k> = y (',vyy,vyz,')'
c        write(nwr,'(8x,a,16x,f8.3,a1)')'          z (',vzz,')'
c       end if

       end if   ! else already efgL

       if(b_HSgt0) then
        icase=1
        if(icase.eq.1) then

c        transformation of the magnetic field H from the  S_E to the crystal system S_C
c        hvC(n) in the crystal system  S_C 
         if(b_EA)then
          call dewigner(1,thetaE_r,dj)
          do m=-1,1
          do n=-1,1
           fn=float(n)*psiE_r
           fm=float(m)*phiE_r
           djecv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
          end do
          end do
         end if
         do n=-1,1
          hc1=(0.,0.)
          do m=-1,1
           hc1=hc1+hv(m)*djecv(m,n)
          end do
           hvC(n)=hc1
         end do
        else
c        magnetic field given in the crystal system Sc
         do i=-1,1
          hvC(i)= hv(i)
         end do
        end if ! case 1

        if(b_AL)then
c        magnetic field transformed to the Lab system
         call dewigner(1,thetaAL_r,dj)
         do m=-1,1
         do n=-1,1
          fn=float(n)*psiAL_r
          fm=float(m)*phiAL_r
          djclv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
         end do
c         write(6,'(a)') 'djcl  b_AL=T'
c         write(6,'(10f10.3)') djcl
        end if
       
        do n=-1,1
         hc1=(0.,0.)
         do m=-1,1
          hc1=hc1+hvC(m)*djclv(m,n)
         end do
         hvL(n)=hc1+hvX(n)
        end do
       end if ! b_HSgt0

c       write(6,'(a,8f12.4)') 'hvL    =',(hvL(i),i=-1,1)
c       hx=(hvl(-1)-hvl(+1))/sqrt(2.0)
c       hy=(hvl(-1)+hvl(+1))/sqrt(2.0)
c       hz=hvl(0)
c       write(6,'(a,2f12.4)')' hx=', hx,' hy=', hy,' hz=', hz
c       write(6,'(a,8f12.6)') 'efgL_r=',(real(efgL(i)),i=-2,2)
c       write(6,'(a,8f12.6)') 'efgL_i=',(aimag(efgL(i)),i=-2,2)

       call hamJgJe(a_mueg,a_muee,Qg_Qe,c_Tms,hvL,efgL,Eagd,Vm)

      else
c       powder: ncony=nconz=0
        call hamJgJe(a_mueg,a_muee,Qg_Qe,c_Tms,hv,efgPAS,Eagd,Vm)
      end if  ! 

c       write(6,'(a,8f9.6)') 'eagd =',(Eagd(i),i=1,8)
c       write(6,'(a,8f9.6)') 'Vm1r =',(real(Vm(1,i)),i=1,8)
c       write(6,'(a,8f9.6)') 'Vm1i =',(aimag(Vm(1,i)),i=1,8)
c       write(6,'(a,8f9.6)') 'Vm0r =',(real(Vm(0,i)),i=1,8)
c       write(6,'(a,8f9.6)') 'Vm0i =',(aimag(Vm(0,i)),i=1,8)
c       write(6,'(a,8f9.6)') 'Vm-1r=',(real(Vm(-1,i)),i=1,8)
c       write(6,'(a,8f9.6)') 'Vm-1i=',(aimag(Vm(-1,i)),i=1,8)

      do i=1,jge

       aVp1 =Vm(1,i)
       aV00 =Vm(0,i)
       aVm1 =Vm(-1,i)

       rpp(i)=0.
       rpmr(i)=0.
       rpmi(i)=0.
       rmm(i)=0.

       if(nconyi+nconzi.eq.0) then
         hc1=aVp1*conjg(aVp1)+
     &       aV00*conjg(aV00)+
     &       aVm1*conjg(aVm1)
         rpp(i)=real(hc1)/3.
         rmm(i)=rpp(i)

       else if(nconyi.gt.0.and.nconzi.gt.0) then

        if(inv_time.lt.0) then
               hc1=aVp1
         aVp1=conjg(aVm1)
         aVm1=conjg(hc1)
         do jz=1,nconzi
c         equivalent sites with B||y related by O(time inversion)*C2z
c         O*C2z*V1m = conjg(V1-m)
    
          aVp1=-conjg(aVp1)
          aVm1=-conjg(aVm1)
    
          do jy=1,nconyi
c          equivalent sites with B||y related by a C2-rotation around y
c          C2y*V1m = (-1)**m*V1-m
            hc1=aVp1
           aVp1=-aVm1
           aVm1=-hc1
    
           hc1=conjg(aVp1)*aVp1
           rpp(i) =rpp(i)+real(hc1)
     
           hc1=conjg(aVp1)*aVm1
           rpmr(i)=rpmr(i)+real(hc1)
           rpmi(i)=rpmi(i)+aimag(hc1)
     
           hc1=conjg(aVm1)*aVm1
           rmm(i) =rmm(i)+real(hc1)
    
          end do    ! nconyi
         end do    ! nconzi
    
         h1=float(nconzi*nconyi)
         rpp(i) =rpp(i)/h1
         rpmr(i)=rpmr(i)/h1
         rpmi(i)=rpmi(i)/h1
         rmm(i) =rmm(i)/h1
   
        else if(inv_time.gt.0) then

         phisym=2.0*pi/float(nconzi)
         do jz=1,nconzi
c        equivalent sites with B||z related by a phisym rotation around z
          hc1=cmplx(cos(phisym),-sin(phisym))
    
          aVp1=conjg(aVp1*hc1)
          aVm1=conjg(aVm1)*hc1
    
          do jy=1,nconyi
c         equivalent sites with B||z related by O(time inversion)*C2y
           aVp1=conjg(aVp1)
           aVm1=conjg(aVm1)
    
           hc1=conjg(aVp1)*aVp1
           rpp(i) =rpp(i)+real(hc1)
    
           hc1=conjg(aVp1)*aVm1
           rpmr(i)=rpmr(i)+real(hc1)
           rpmi(i)=rpmi(i)+aimag(hc1)
  
           hc1=conjg(aVm1)*aVm1
           rmm(i) =rmm(i)+real(hc1)
          end do    ! nconyi
         end do    ! nconzi
         h1=float(nconzi*nconyi)
         rpp(i) =rpp(i)/h1
         rpmr(i)=rpmr(i)/h1
         rpmi(i)=rpmi(i)/h1
         rmm(i) =rmm(i)/h1
        end if    ! inv_time > 0

       else if(nconyi.gt.0.and.nconzi.eq.0) then

        if(inv_time.lt.0) then
         hc1=aVp1
         aVp1=conjg(aVm1)
         aVm1=conjg(hc1)
c        equivalent sites with B||y related by O(time inversion)*C2z
c        O*C2z*V1m = conjg(V1-m)
         do jy=1,nconyi
c         equivalent sites with B||y related by a C2-rotation around y
c         C2y*V1m = (-1)**m*V1-m
          hc1=aVp1
          aVp1=-aVm1
          aVm1=-hc1

          h1=real(conjg(aVp1)*aVp1)
          rpp(i) =rpp(i)+h1
          h1=real(conjg(aVm1)*aVm1)
          rmm(i) =rmm(i)+h1
         end do    ! nconyi

        else if(inv_time.gt.0) then

c        equivalent sites with B||z related by a phisym rotation around z
         do jy=1,nconyi
c        equivalent sites with B||z related by O(time inversion)*C2y
          h1=real(conjg(aVp1)*aVp1)
          rpp(i) =rpp(i)+h1
          h1=real(conjg(aVm1)*aVm1)
          rmm(i) =rmm(i)+h1
         end do    ! nconyi
        end if    ! inv_time > 0
        h1=float(nconyi)
        rpp(i) =rpp(i)/h1
        rpmr(i)=(0.0,0.0)
        rpmi(i)=(0.0,0.0)
        rmm(i) =rmm(i)/h1

       else if(nconyi.eq.0.and. nconzi.gt.0)then 

        if(inv_time.lt.0) then
         do jz=1,nconzi
c         equivalent sites with B||y related by O(time inversion)*C2z
c         O*C2z*V1m = conjg(V1-m)
          h1=real(conjg(aVp1)*aVp1+conjg(aVm1)*aVm1)/4.
          h2=real(conjg(aV00)*aV00)/2.
          rpp(i) =rpp(i)+h1+h2
          h1=h1-h2
          rpmr(i)=rpmi(i)+h1
         end do    ! nconzi
        else if(inv_time.gt.0) then
         phisym=2.0*pi/float(nconzi)
         k=0
         do jz=1,nconzi
c        equivalent sites with B||z related by a phisym rotation around z
          hc1=cmplx(cos(phisym),-sin(phisym))

          aVp1=conjg(aVp1*hc1)
          aV00=conjg(aV00)
          aVm1=conjg(aVm1)*hc1
          h1=real(conjg(aVp1)*aVp1+conjg(aVm1)*aVm1)/4.
          h2=real(conjg(aV00)*aV00)/2.
          rpp(i) =rpp(i)+h1+h2
          h1=h1-h2
          rpmr(i)=rpmi(i)+h1
         end do    ! nconzi
        end if    ! inv_time > 0
        h1=float(nconzi)
        rpp(i) =rpp(i)/h1
        rpmr(i)=rpmr(i)/h1
        rpmi(i)=(0.0,0.0)
        rmm(i) =rpp(i)
       end if     ! nconyi.eq.0 nconzi.gt.0 
  
       rtr(i)=cmplx(rpp(i)-rmm(i),rpp(i)+rmm(i))/2.0
       rpm(i)=cmplx(rpmr(i),rpmi(i))
      end do   ! i=1-jge

      i2=ist02+jge
      i3=i2+jge
      do i=1,jge
       array_fr(ist02+i)=cmplx(Eagd(i),0.0)
       array_fr(i2+i)=rtr(i)
       array_fr(i3+i)=rpm(i)
      end do
      array_fr(ist02+1)=cmplx(Eagd(1),float(jge))

      j=ist02+3*jge
      do i=1,iecv+9
       array_fr(j+i)=store(i)
      end do
c       write(6,'(a)') 'djcl'
c       write(6,'(10f10.3)') djcl

c      write(6,'(8f10.6)') (Eagd(i),i=1,jge)
c      write(6,'(8f10.6)') (rpp(i),i=1,jge)
c      write(6,'(8f10.6)') (rmm(i),i=1,jge)
c      write(6,'(8f10.6)') (rpmr(i),i=1,jge)
c      write(6,'(8f10.6)') (rpmi(i),i=1,jge)

      return
      end




