c     Jg Je arbitrary spin
c     synchrotron source
c
      subroutine synchrotron(b_total)
      implicit none
      include 'comglb.for'
      include 'comthe.for' 

c     ifrcase=1  ! forward scattering geometry
c     ifrcase=2  ! grazing incidence geometry,time differential


      integer     ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,iduma,nCP,idumb,nsrw,
     &            iflag_basis,l_trans,idumc,nTH,ith_channels,idumd,
     &            ak8,jt0_ch,iT_max,idum3
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),   !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,iaddr(6),
     &              iduma,nCP,idumb,nsrw,ifrth(4),                   
     &              iflag_basis,l_trans,idumc,nTH,ith_channels,idumd,
     &              ak8,idum3(3),jt0_ch,iT_max,idex(4)

c     &              iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
c     &              ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,idex(4)

      real          acsp,wavelength,uthick,unit_chi,dumcsp
      common/acstrf/acsp,wavelength,uthick,unit_chi,dumcsp(icstrf-4)


      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,graz_angle,phi_z,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,graz_angle,phi_z,dumvsp(ivstrf-9)

      logical       b_avsp,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_t_shift,b_graz_angle,b_phi_z,b_dumvsp
      common/bvstrf/b_avsp,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_t_shift,b_graz_angle,b_phi_z,b_dumvsp(ivstrf-9)

      real            avfr1,pvfr1,HextA,thetaHeA,phiHeA,
     &                phiA,thetaA,psiA,dumvfr1
      common/avfr1trf/avfr1,pvfr1,HextA,thetaHeA,phiHeA,
     &                phiA,thetaA,psiA,dumvfr1(ivfr1trf-8)
      logical         b_avfr1,b_pvfr1,b_HextA,b_thetaHeA,b_phiHeA,
     &                b_phiA,b_thetaA,b_psiA,b_dumvfr1
      common/bvfr1trf/b_avfr1,b_pvfr1,b_HextA,b_thetaHeA,b_phiHeA,
     &                b_phiA,b_thetaA,b_psiA,b_dumvfr1(ivfr1trf-8)

      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(ivfr2trf-5)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(ivfr2trf-5)

      real           vsstrf,sftr
      common/avsstrf/vsstrf(ivsstrf)
      logical        b_vsstrf,b_sftr
      common/bvsstrf/b_vsstrf(ivsstrf)

      logical  b_lay,b_isgt1,b_sites
      real      winc,wi,vkd
      dimension winc(maxfr1),wi(maxthss),vkd(maxfr2),
     &          b_sites(maxfr2)

      integer isubthe,nt,iss,inc_pos,
     &        lstruct1,lstruct2,lstruct3,iset,is_a,is_e,
     &        i,ii,j,jj,ij,l,n,nn,jftau,jt0,
     &        k,ll,lay,mlay,layb,laye,isctp,
     &        iposlay,npos,lays,mlays,laysites,laystr

      real pi,rad,grazing,vector_k,h1,h2,sqrt2,
     &     sing,sum,relthick,thicklayer,roughlay

      dimension thicklayer(maxfr2),roughlay(maxfr2),
     &          iposlay(maxfr2),
     &          laystr(2*maxfr2),laysites(maxfr2)



      complex hc,hc1,hci,hc0,app,apm,amp,
     &        satraceh,R_oo,
     &        aam(4,maxfr2),aa(4),bb(4),dd(4),rho(4),satrexp,
     &        Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2),trv(2,2),TSPCA(2,2),sph(2,2)


      integer mFF,mFF1,mAL,macr,macr1,mcLG
      parameter (mFF=16*maxn,mFF1=mFF+1,macr=8*(2*maxn+1),macr1=macr+1,
     &           mcLG=2*maxn,mAL=8*(2*maxn+1))
      complex carray,cLG,POC,dumscrd
      real yth
      dimension carray(mAL),cLG(-mcLG:mcLG),POC(mFF),
     &          yth(0:4*maxn)
      common/scrd/dumscrd(maxscrd/2)
      equivalence (dumscrd(1),POC(1)),(dumscrd(mFF1),yth(0))
      equivalence (dumscrd(1),carray(1)),(dumscrd(mFF1),cLG(-mcLG))

      logical b_total,b_ew
C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MGRP,GEOSTR(0:2*maxfr2)
      logical b_first
C ****                                                       ***     

c       thfrcase(1)='time differential transmission spectrum(11)'
c       thfrcase(2)='time differential reflection spectrum(21)'

cc       thfrcase(3)='time integral - rocking curve(Fourier)(22)'
cc       thfrcase(4)='time integral - rocking curve(24)'
cc       thfrcase(5)='prompt - rocking curve(23)'

c      write(6,'(a,2i4)')' th_synmos ifrcase=',ifrcase
       b_total=.false.
       b_ew=.false.
c------------------------------------------------------------------
c-------------------------------------------------------------------

      call mapsub(0)
      isubthe=1
      call get_theory(isubthe)
      b_total= b_total.or.(isubthe.gt.0) 

      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

      pi=atan(1.)*4.
      rad=pi/180.
      vector_k=2.0*pi/wavelength    ! /Angstroem
 
      rho(1)=cmplx(1.+Pzeta,0.)/2.
      rho(2)=cmplx(Pxsi,-Peta)/2.
      rho(3)=cmplx(Pxsi,Peta)/2.
      rho(4)=cmplx(1.-Pzeta,0.)/2.
c     write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)
c-----------------------------------------------------------
       if(iflag_basis.eq.0) then
c      linear polarization basis
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)

       sph(1,1)=rho(1)
       sph(1,2)=rho(2)
       sph(2,1)=rho(3)
       sph(2,2)=rho(4)
       do i=1,2
       do k=1,2
        hc=(0.,0.)
        do j=1,2
        do l=1,2
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
        end do
        end do
        trv(i,k)=hc
       end do
       end do
       rho(1)=trv(1,1)
       rho(2)=trv(1,2)
       rho(3)=trv(2,1)
       rho(4)=trv(2,2)
       end if
c-----------------------------------------------------------
      relthick=uthick


      lstruct1=0
      iss=1
 1000 continue

      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2500


       call mapsub(iss)
       winc(lstruct1)=pvfr1
       b_total=b_total.or.b_pvfr1
c      write(6,'(a,i1,a2,i8)')
c     &         'synmos l1_put(',lstruct1,')=',l1_put(lstruct1)  
      inc_pos=l1_put(lstruct1)

c      write(6,'(a,i4,a,g12.4)')' synmos case=',ifrcase,
c     &     ' graz_angle=',graz_angle
       if(l_trans.eq.0) then
        grazing=0.001*graz_angle
        sing=sin(grazing)
       end if

       iss=iss+1
       layb=istruct1(lstruct1-1)
       laye=istruct1(lstruct1)
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nTH------------0------------nTH                    srw
        lay=lstruct2-layb

        call mapsub(iss)
c        write(6,'(a,3g12.4)')' synmos r,i_chi,unit_chi=',
c     &        re_chilay,ai_chilay,unit_chi
         b_lay=b_vfr2
         b_total=b_total.or. b_lay       
        if(l_trans.eq.1) then
         thicklayer(lay)=1.
        else
         thicklayer(lay)=thicklay
         if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
          chilay(lay)=cmplx(re_chilay,ai_chilay)*unit_chi
         else
          chilay(lay)=(0.,0.)
         end if
         i=rep_grp
         laystr(2*lay-1)=i
         laystr(2*lay)=10*(rep_grp-float(i)+.01)
         roughlay(lay)=roughness
        end if

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
         b_isgt1=.true.
         iposlay(lay)=l2_put(lstruct2)
         do i=1,8*(nTH+1)
          carray(i)=(0.,0.)
         end do
        end if
        b_sites(lay)=.false.

        iss=iss+1
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

         iset=lstruct3
         b_sites(lay)=.true.

         call mapsub(iss)

         sftr=vsstrf(2)
         b_sftr= b_vsstrf(2)
         wi(iset)=sftr*relthick
c         write(6,'(a,i4,3g10.3)')'synmos lay,wi(iset),sftr,relthick=',
c     &   lay,wi(iset),sftr,relthick


         if(l_trans.eq.0) then
          if(b_sftr) then
           if(wi(iset).gt.sing/20..or.sing.gt.0.05)
     &     write(nwr,'(2(a,g8.1),a)')
     &     '** f*unit_thickness=',wi(iset),' << sin(th)=',sing,' << 1 ?'
          end if
         end if
         isubthe=0
         call get_theory(isubthe)
         b_lay=b_lay.or.b_sftr.or.(isubthe.gt.0)
         b_total=b_total.or.b_lay

         

         if(b_isgt1) then
          isctp=l3_get(lstruct3)
          do n=0,nTH
           nn=isctp+8*n
           ll=8*n
            do k=1,8
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(iset)
            end do
          end do
c        write(6,'(a)') 'synmoss carray(1..)='
c        write(6,'(8f12.4)') (carray(i)*1000,i=1,8)
         else
          iposlay(lay)=l3_get(lstruct3)
c           write(6,'(a,i2,a2,i8)')
c     &       'synmos  iposlay(',lay,')=',iposlay(lay)
         end if
         iss=iss+1
        end do

        if(b_isgt1.and.b_lay) then
         ll=iposlay(lay)
         do i=1,8*(nTH+1)
          array_fr(ll+i)=carray(i)
         end do
c         write(6,'(a,2i6)') 'synmoss carray(1..)  nn=',nn
c         write(6,'(8f12.4)') (carray(i)*1000,i=1,40)
        end if

       end do
       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0

c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sap(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)

c      write(6,'(a,20i3)')'synmos laystr(1..mlay)=',(laystr(i),i=1,mlay)
      if(.not.b_total) goto 2000

      do k=1,mlay
       laysites(k)=0
      end do
      if(l_trans.eq.1) then
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
        if(b_sites(lay)) then
         mlays=mlays+1
         iposlay(mlays)=iposlay(lay)
         if(is_e.gt.is_a) thicklayer(mlays)=thicklayer(lay)
         if(is_e.eq.is_a)
     &           thicklayer(mlays)=thicklayer(lay)*wi(is_a)
c         write(6,'(a,i4,2f10.3)')'synmos lay,wi(is_a),thicklayer',
c     &   lay,wi(is_a),thicklayer(lay)
        end if
       end do
      else
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
c       write(6,'(a,2i4)') '####### is_a,is_e=',is_a,is_e
        vkd(lay)=vector_k*thicklayer(lay)
        if(is_e.lt.is_a) then
         thicklayer(lay)=0.
        else
         if(is_e.gt.is_a) thicklayer(lay)=1./vector_k
         if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k
        end if
       end do
      end if

c      do lstruct2=layb+1,laye
c       lay=lstruct2-layb
c       write(6,'(i4,2x,L3,a,2g12.4,a,g12.4)')
c    & lay,b_sites(lay),' chilay=',chilay(lay)/unit_chi,' vkd=',vkd(lay)
c       end do


      if(l_trans.eq.0) then
C     *********************************************************************
C     We reconstruct the layer strucrure from the laystr variabale. 
c     ELEMENT(GRP) is the number of layers in group GRP.
C     *** L. Deak, 09.10.2002 *** 
       GRP         =0
       GEOSTR(GRP) =0
       MGRP      =0
C
       b_first     =.true.
       POINTER=1
       do lay=2,2*mlay,2
        if(b_first)then
         if(GRP.eq.laystr(lay))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(lay-1)
         end if
C
         if(vkd(lay/2).lt.0.) then
          b_first         =.false.
          vkd(lay/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ***********************************************************************
       do lay=1,mlay
        if(b_sites(lay)) then
         Cmatrix(1,1,lay)= hc0 
         Cmatrix(2,2,lay)= hc0
         Cmatrix(1,2,lay)= hc0
         Cmatrix(2,1,lay)= hc0
        end if
       end do

       call optic(b_ew,maxfr2,mlay,b_sites,MGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
       R_oo=Rmatrix(1,1)
      endif
c      write(6,'(a,i6)')' iposlay(1)=',iposlay(1) 

      do n=-nTH,nTH-1

c      construction of the input for general optics program
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
        npos=8*abs(n)
        if(n.lt.0)npos=npos+4

        if(l_trans.eq.1) then
           satraceh=cmplx(0.,0.)
           do lays=1,mlays
            nn=iposlay(lays)+npos
            satraceh=satraceh+array_fr(nn+1)*thicklayer(lays)
            app=array_fr(nn+2)*thicklayer(lays)
            apm=array_fr(nn+3)*thicklayer(lays)
            amp=array_fr(nn+4)*thicklayer(lays)
            call expo_22(app,apm,amp,dd)
            do k=1,4
             aam(k,lays)=dd(k)
            end do
           end do   ! lays=1,mlays
c          if(abs(n).lt.5) write(6,'(2i6,6g12.4)') 
c     &                 n,nn,array_fr(nn+1),array_fr(nn+2),thicklayer(1)
           satrexp=exp(satraceh*hci)
c          if(abs(n).lt.5) write(6,'(i6,6g12.4)') n,satrexp,app

c          multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c          laystr(rep,grp,rep,grp,.....)

           if(mlays.gt.1) then
            do k=1,4
             dd(k)=aam(k,mlays)
            end do

            do lays=mlays-1,1,-1
             do k=1,4
              aa(k)=dd(k)
              bb(k)=aam(k,lays)
             end do
             call matpro(aa,bb,dd)
            end do
           end if

           nn=(nTH+n)*4

           POC(nn+1)=(1.,0.)-dd(1)*satrexp
           POC(nn+2)=       -dd(2)*satrexp
           POC(nn+3)=       -dd(3)*satrexp
           POC(nn+4)=(1.,0.)-dd(4)*satrexp
c          if(abs(n).lt.10) write(6,'(i2,8g10.4)')
c     &    n,POC(nn+1),POC(nn+2),POC(nn+3),POC(nn+4)
         else   ! l_trans=1

           do lay=1,mlay
            if(b_sites(lay)) then
             nn=iposlay(lay)+npos
             Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
             Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
             Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
             Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
c           if(abs(n).lt.5) write(6,'(i6,8f9.4,4x,g12.3)') nn,
c     &      (array_fr(nn+ii),ii=1,4),thicklayer(lay)
            end if
           end do   ! lay=1,mlay          

           call optic(b_ew,maxfr2,mlay,b_sites,MGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
          
           nn=(nTH+n)*4
           POC(nn+1)=Rmatrix(1,1)-R_oo
           POC(nn+2)=Rmatrix(1,2)
           POC(nn+3)=Rmatrix(2,1)
           POC(nn+4)=Rmatrix(2,2)-R_oo
c          if(abs(n).lt.5) write(6,'(i6,8g12.3,5x,g12.3)') nn,
c     &                    (POC(nn+ii),ii=1,4)
         end if ! reflection (l_trans=0)
        end do     ! n=-nTH,nTH

c        write(6,'(a,4i8)')'synmos nTH1,nCP,nCC,nsrw=',nTH1,nCP,nCC,nsrw
c        i=nstorTH+nstorTH1+nTH/nsrw*4

        i=nstorTH1+nCP*4
        jj=4*nTH
        do n=-nCP,nCP-1
         j=4*n
         nn=jj+j*nsrw
         ii=i+j
         array_fr(ii+1)=POC(nn+1)
         array_fr(ii+2)=POC(nn+2)
         array_fr(ii+3)=POC(nn+3)
         array_fr(ii+4)=POC(nn+4)
        end do


c       write(6,'(a)') ' POC'
c       write(6,'(6g12.3)') (POC(i),i=1,40)
c       write(6,'(i5,2g12.3)') (nTH*4+i,POC(nTH*4+i),i=1,8)
c       write(6,'(a,i5)') 'nTH,POC(1:4)=',nTH
        nn=2*nTH
c       call fourier4(POC,nn,mFF,-1)
        call fourier4r(nn)

c       write(6,'(a)') ' POC'
c       write(6,'(8f10.3)') (POC(i),i=1,40)


        do n=1,nTH
c        trace (dd+*dd*rho) is the intensity
c        bb=cc+
          jj=4*(n-1)
          do i=1,4
           dd(i)=POC(jj+i)
          end do
c         if(n.eq.1) write(6,'(8f10.3)') (dd(i),i=1,4)
c         if(n.eq.2) write(6,'(8f10.3)') (dd(i),i=1,4)
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))
          call matpro(bb,dd,aa)
          call matpro(aa,rho,bb)
c        aa=cc*cc+ is a Hermitian matrix
         h1=real(bb(1)+bb(4))
          jj=4*(nTH+n-1)
          do i=1,4
           dd(i)=POC(jj+i)
          end do
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))
          call matpro(bb,dd,aa)
          call matpro(aa,rho,bb)
         h2=real(bb(1)+bb(4))
         yth(n)=h1
         yth(n+nTH)=h2
c        if(h1.lt.0.0) write(6,'(a,i6,f15.5)')' synmos  n,h1=',n,h1
c        if(h2.lt.0.0) write(6,'(a,i6,f15.5)')
c    &                                 ' synmos n+nTH,h2=',n+nTH,h2
        end do ! n
        yth(0)=yth(1)


c     normalization
      nt=2*nTH
      jt0=2*jt0_ch
      sum=0.
      do j=jt0+1,nt-1,2
       sum=sum+yth(j)*4
      end do
      do j=jt0+2,nt-2,2
       sum=sum+yth(j)*2
      end do
      sum=sum+yth(jt0)+yth(nt)
      sum=sum/6.0/ith_channels*(nt-jt0)/2.

c      write(6,'(a,2i6,f15.5)') ' synmos jt0_ch,nTH,sum=',
c     &                                  jt0_ch,nTH,sum
      if(sum.eq.0.0) sum=1.0
      jftau=0
      nn=nstorTH
      if(mstruct1.gt.1) nn=inc_pos
c      write(6,'(a,f15.5)') ' synmos sum=',sum

c     write(6,'(a,2i6)')'synmos iT_max,nstorTH=',iT_max,nstorTH
      if(iT_max.gt.0) then
        nt=nTH*2
        do k=1,iT_max
         nt=nt/2
         do j=1,nt
          yth(j)=yth(j)+yth(j+nt)
         end do
        end do
        jftau=nt/1024
c        write(6,'(a,3i6)') ' synmos nth,nTH,jftau=',
c     &             nth,nTH,jftau
        if(jftau.gt.1) then
         sum=sum/jftau
         nt=nt/2
         do i=1,512
          ij=i*jftau
          array_fr(nn+i)=cmplx(yth(ij),yth(n+ij))/sum
         end do
        else
         jftau=1
         ii=nt/2
         sum=sum*512/ii
         do i=1,ii
          array_fr(nn+i)=cmplx(yth(i),yth(ii+i))/sum
         end do
        end if
      else
        jftau=nTH/512
c        write(6,'(a,2i6)') ' synmos nTH,jf=',nTH,jftau
        if(jftau.gt.1) then
         sum=sum/jftau
         do i=1,512
          ij=i*jftau
          array_fr(nn+i)=cmplx(yth(ij),yth(nTH+ij))/sum
         end do
        else
         sum=sum*512/nTH
         do i=1,nTH
          array_fr(nn+i)=cmplx(yth(i),yth(nTH+i))/sum
         end do
        end if
      end if
c     end of calculation for incoherent part

 2000 continue
c     write(6,'(a,2i6)')'synmos lstruct1,mstruct1=',lstruct1,mstruct1
      if(mstruct1.gt.1) goto 1000

      if(.not.b_total) return

 2500  continue
      if(mstruct1.gt.1) then
c      summation of incoherent parts mstruct1
       n=nTH
       if(n.gt.512) n=512
       do i=1,n
        array_fr(nstorTH+i)=cmplx(0.,0.)
       end do
       do k=1,mstruct1
        nn=l1_put(k)
c       write(6,'(8f10.4)')(array_fr(nn+i)*100,i=1,16)
        do i=1,n
         array_fr(nstorTH+i)=
     &       array_fr(nstorTH+i)+array_fr(nn+i)*winc(k)
        end do
       end do
      end if

      return
      end


C  *****************************************************************
C
C                 Fourier-transformation
C                   (fortran recipies)
C  *****************************************************************
C
      subroutine fourier(DATA,NN,mFF,ISIGN)
      real*8 WR,WI,WPR,WPI,WTEMP,THETA
      real DATA(2*mFF)
C
      N=2*NN
      J=1
C
      do 11 I=1,N,2
        if(J.gt.I)then
          TEMPR=DATA(J)
          TEMPI=DATA(J+1)
          DATA(J)=DATA(I)
          DATA(J+1)=DATA(I+1)
          DATA(I)=TEMPR
          DATA(I+1)=TEMPI
        endif
        M=N/2
1       if ((M.ge.2).and.(J.gt.M)) then
          J=J-M
          M=M/2
        go to 1
        endif
        J=J+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        WPR=-2.D0*dsin(0.5D0*THETA)**2
        WPI=dsin(THETA)
        WR=1.D0
        WI=0.D0
        do 13 M=1,MMAX,2
          do 12 I=M,N,ISTEP
            J=I+MMAX
            TEMPR=WR*DATA(J)-WI*DATA(J+1)
            TEMPI=WR*DATA(J+1)+WI*DATA(J)
            DATA(J)=DATA(I)-TEMPR
            DATA(J+1)=DATA(I+1)-TEMPI
            DATA(I)=DATA(I)+TEMPR
            DATA(I+1)=DATA(I+1)+TEMPI
12        continue
          WTEMP=WR
          WR=WR*WPR-WI*WPI+WR
          WI=WI*WPR+WTEMP*WPI+WI
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end

C  *****************************************************************
C
C                 c-Fourier-transformation
C                   (fortran recipies)
C  *****************************************************************
C
      subroutine cfourier(DATA,NN,mFF,ISIGN)
      real*8 THETA
      complex DATA(mFF)
      complex ww,wwp,temp
C
      N=2*NN
      J=1
C
      do 11 I=1,N,2
        if(J.gt.I)then
          ii=(I+1)/2
          jj=(J+1)/2
          temp=DATA(jj)
          DATA(jj)=DATA(ii)
          DATA(ii)=temp
        endif
        M=N/2
1       if ((M.ge.2).and.(J.gt.M)) then
          J=J-M
          M=M/2
        go to 1
        endif
        J=J+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        wwp=cmplx(-2.D0*dsin(0.5D0*THETA)**2,dsin(THETA))
        ww=cmplx(1.0,0.0)
        do 13 M=1,MMAX,2
          do 12 I=M,N,ISTEP
            J=I+MMAX
          ii=(I+1)/2
          jj=(J+1)/2
            temp=ww*DATA(jj)
            DATA(jj)=DATA(ii)-temp
            DATA(ii)=DATA(ii)+temp
12        continue
          ww=(wwp+(1.,0.))*ww
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end


C  *****************************************************************
C
C                 Fourier-transformation
C                   (fortran recipies)
C                transform of 4 arrays (l=1-4)
C                          6.6.97
C  *****************************************************************
C
      subroutine fourier4r(NN)
      include 'comglb.for'
      real POC(32*maxn),dumscrd
      common/scrd/dumscrd(maxscrd)
      equivalence (dumscrd(1),POC(1))

      real*8 THETA
      real hr,wwr,wwi,wwpr,wwpi,tempr,tempi
C
      N=2*NN
      JN2=1
C
      do 11 IN2=1,N,2
        if(JN2.gt.IN2)then
          jj=4*(JN2-1)-1
          ii=4*(IN2-1)-1
          do l=2,8,2
           i=ii+l
           j=jj+l
           tempr=POC(j)
           tempi=POC(j+1)
           POC(j)=POC(i)
           POC(j+1)=POC(i+1)
           POC(i)=tempr
           POC(i+1)=tempi
          end do
        endif
        M=N/2
1       if ((M.ge.2).and.(JN2.gt.M)) then
          JN2=JN2-M
          M=M/2
        go to 1
        endif
        JN2=JN2+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/dfloat(MMAX)
        wwpr=dcos(THETA)
        wwpi=-dsin(THETA)
        wwr=1.
        wwi=0.
        do 13 M=1,MMAX,2
          do 12 IMN=M,N,ISTEP
           ii=4*(IMN-1)-1
           jj=ii+2*ISTEP
           do l=2,8,2
            i=ii+l
            j=jj+l
            tempr=wwr*POC(j)-wwi*POC(j+1)
            tempi=wwr*POC(j+1)+wwi*POC(j)
            POC(j)=POC(i)-tempr
            POC(j+1)=POC(i+1)-tempi
            POC(i)=POC(i)+tempr
            POC(i+1)=POC(i+1)+tempi
           end do
12        continue
          hr=wwr
          wwr=wwpr*wwr-wwpi*wwi
          wwi=wwpi*hr +wwpr*wwi
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end
