      subroutine thstr_neutron(l_jth,cmch,property)

c     case neutronrock
c          neutronoffspecular
c         neutronOffspecRoughness
c     for neutron scattering
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for' 
      
      integer l_jth,mthchild,mthparent,k
      character property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_neutron  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Neutron source (distribute)'                                    !name
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
      end if

c     name of this routine
      mthchild=2
      nameth(1)='Neutron specular scattering'
      nameth(2)='Neutron offspecular scattering'      
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='Neutron source'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      return
      end

      subroutine thstr_neutronspec(l_jth,cmch,property)
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer l_jth,mthchild,mthparent,k,j,jc,jm,jmb,jh,l
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_neutronspec nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Neutron rocking'                                       !name
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=8,3,0 '
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='Neutron rocking curve'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Neutron specular scattering'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(cmch.eq.'copa') then

c      common/acstrf/acsp,
c                   dwba,channels,scale,unit_sclB,unit_sclN,
c                   ch_v,v_beg,v_end,d_theta1,d_theta2,lambda,aver_points

c                   v=q        for neutronrock
c                   v=theta2   for neutronoffspecular,neutronOffspecRoughness

        j=1
        do while(strco(j)(:5).ne.'#beg#')
         j=j+1
        end do
        j=j-1
        jc=j+1
       
        
       strco(j+1)='nu_channels             2    ##n 1024 '
                 ! channel number of the spectrum
       strco(j+2)='Q_scale                 3    ## y 1 '
                 ! determines function for channel to velocity scale
       
c                  1                  012345
       strco(j+3)='unit_sclB               4      0.291E-05' ! 1.0e-9 !Now B is to be written in kOe 
                 ! 
       strco(j+4)='unit_sclN               5       0.126E-04'  !1.0e-6 Now Nb in 10^-6 A^-2
                 ! scattering length  multiplied by
       j=j+4
       strco(j+1)='nu_q_values             6       128 '
       strco(j+2)='q_begin                 7    ## 0.07  '
       strco(j+3)='q_end                   8    ## 0.7 '
        
       j=j+3
            
       strco(j+1)='#end#  8   seq'
       strco(j+2)='#beg#'

       do k=jc,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c        write(6,'(a)') strco(k)(:80)
       end do

c      common/avsptrf/avsp,aintensity,background,
c                     Pxsi_b,Peta_b,Pzeta_b,
c                     Pxsi_a,Peta_a,Pzeta_a,

c                     q_shift,q_min,phi_z            rock
       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
        
       strtm(jm+1,1)='calibration               ## y 1 1'
       strtm(jm+1,2)='frame parameter q-shift'
       strth(jh+1,1)='q_shift                 0.0 0.0 0.0 0.1'
       strth(jh+1,2)='q_shift                 1     1  '
      
       strtm(jm+2,1)='orientation                ##  y 2 2'
       strtm(jm+2,2)='q_min, phi_z of the scatterer plane'
       strth(jh+2,1)='q_min                   1.00  0.0 0.0  0.01'
       strth(jh+3,1)='phi_z                   0.00  0.0 0.0  1.0'
       strth(jh+2,2)='q_min                   2    1 0'
       strth(jh+3,2)='phi_z                   3    0 1'
       jm=jm+2
        
       strtm(jm+1,1)='#end#    3 '
       strtm(jm+2,1)='#beg#'
   
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if
      return
      end

      subroutine thstr_neutronoffspec(l_jth,cmch,property)
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
  
      integer l_jth,mthchild,mthparent,k,j,jc,jm,jmb,jh,l
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_neutronspec nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Neutron offspecular'                                   !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property='prop=nocall       nono,0   nc_v_a_the=14,3,0 '
       else if(l_jth.eq.2) then
        property='prop=nocall       nono,0   nc_v_a_the=14,4,0 '
       end if
       b_return=.true.
      end if

c     name of this routine
      mthchild=2
      nameth(1)='Neutron offspecular (smooth)'
      nameth(2)='Neutron offspecular (roughness)'
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Neutron offspecular scattering'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(cmch.eq.'copa') then

c      common/acstrf/acsp,
c                   dwba,channels,scale,unit_sclB,unit_sclN,
c                   ch_v,v_beg,v_end,d_theta1,d_theta2,lambda,aver_points

c                   v=q        for neutronrock
c                   v=theta2   for neutronoffspecular,neutronOffspecRoughness

       j=1
       do while(strco(j)(:5).ne.'#beg#')
        j=j+1
       end do
       j=j-1
       jc=j+1
       
       
       strco(j+1)='DWBA                    1        1 '
       strco(j+2)='nu_channels             2    ##n 1024 '
                 ! channel number of the spectrum
       strco(j+3)='theta2_scale            3    ## y 1 '
                 ! determines function for channel to velocity scale
       
c                  1                  012345
       strco(j+4)='unit_sclB               4      0.291E-05' 
c                  1.0e-9 !Now B is to be written in kOe 
       strco(j+5)='unit_sclN               5       0.126E-04'  
c                1.0e-6 Now Nb in 10^-6 A^-2
c                scattering length  multiplied by
       
       strco(j+6)='nu_theta2_values        6       128 '
       strco(j+7)='theta2_begin[mrad]      7    ##  10  '
       strco(j+8)='theta2_end[mrad]        8    ##  20 '
       strco(j+9)='theta1                  9        15 '
       strco(j+10)='lambda                  10      1.0'
       j=j+10
       strco(j+1)='d_theta1                11    ## 0.1 '
       strco(j+2)='d_theta2                12   ## 0.069 '
       strco(j+3)='d_lambda                13    ## 0.015 '
       strco(j+4)='aver_points             14    ## 15 '
         j=j+4
            
       strco(j+1)='#end#  14   seq'
       strco(j+2)='#beg#'

       do k=jc,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c        write(6,'(a)') strco(k)(:80)
       end do

c      common/avsptrf/avsp,aintensity,background,
c                     Pxsi_b,Peta_b,Pzeta_b,
c                     Pxsi_a,Peta_a,Pzeta_a,

c                     theta2_shift,fr_offspec,xi          offspecular
       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
        
       strtm(jm+1,1)='calibration                     1 1'
       strtm(jm+1,2)='frame parameter theta2-shift'
       strth(jh+1,1)='theta2_shift            0.0 0.0 0.0 0.1'
       strth(jh+1,2)='theta2_shift             1     1  '
  
       strtm(jm+2,1)='fraction                        1 1'
       strtm(jm+2,2)='fraction of off-specular intensity'
       strth(jh+2,1)='fr_offspec              0.10  0.0 0.0  1.0'
       strth(jh+2,2)='fr_offspec               2    1'
       if(l_jth.eq.1)then
        strtm(jm+3,1)='xi-correlation                   1 1'
        strtm(jm+3,2)='correlation length xi'
        strth(jh+3,1)='xi[A]                   1.0e4  0.0 0.0  1.0'
        strth(jh+3,2)='xi                       3    1'

        jm=jm+3
        strtm(jm+1,1)='#end#      3  seq'
       else if(l_jth.eq.2)then
        strtm(jm+3,1)='inout_correlation               2 2'
        strtm(jm+3,2)='correlation length in xi off A0'
        strth(jh+3,1)='xi[A]                   1.0e4  0.0 0.0  1.0'
        strth(jh+4,1)='Ao                      100.0 0.0 0.0  1.0'
        strth(jh+3,2)='xi[A]                    3    1  0'
        strth(jh+4,2)='Ao                       4    0  1'

        jm=jm+3
        strtm(jm+1,1)='#end#      4  seq'
       end if
        strtm(jm+2,1)='#beg#'

        do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if
      return
      end
