      subroutine thstr_sampleorient(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission
c     level 2 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_sampleorient  nameth_as=',nameth_as(:40)
      
       b_return=cmch.eq.'name'
      if(b_return) 
     & property='sample orientation'                                    !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=sample_orientation    nono,1  nc_v_a_the=0,10,t'
       else if(l_jth.eq.2) then
        property=
     & 'prop=sample_orientation    nono,2 nc_v_a_the=0,10,t'
       else if(l_jth.eq.3) then
        property=
     & 'prop=sample_orientation    nono,3 nc_v_a_the=0,10,t'
       else if(l_jth.eq.4) then
        property=
     & 'prop=sample_orientation    nono,4 nc_v_a_the=0,10,t'
       else if(l_jth.eq.5) then
        property=
     & 'prop=sample_orientation    nono,5 nc_v_a_the=0,10,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=5    ! <=(max_nth
      nameth(1)='nocall (angle(sample)=0)'
      nameth(2)='sample orient.( rot-axes)'
      nameth(3)='sample orient.(rot-axes,thickness)'
      nameth(4)='sample orient.( x,z-axes)'
      nameth(5)='sample orient.(x,z-axes,thickness)'
      nameth(6)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Mossbauer transmission_ext_2'

       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.ne.'copa') return
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
c       write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
       k=k+1
      end do
      jm=k-1
      jmb=jm+1
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

      if(l_jth.eq.2.or.l_jth.eq.3) then
      
c                     123456789012345678901234567      
       strtm(jm+1,1)='orient_euler            , 3 3'
       strtm(jm+1,2)='orientation of the sample in the lab'
       strth(jh+1,1)='phi                  , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='theta                , 0.0  0.0 0.0  1.0'
       strth(jh+3,1)='psi                  , 0.0  0.0 0.0  1.0'
       strth(jh+1,2)='phi                      1    1 0 0 '
       strth(jh+2,2)='theta                    2    0 1 0 '
       strth(jh+3,2)='psi                      3    0 0 1 '

       strtm(jm+2,1)='rotation                , 3 3'
       strtm(jm+2,2)='rotation axes in the lab system, rot.angle'
       strth(jh+4,1)='axtheta               , 0.0  0.0 0.0  0.1'
       strth(jh+5,1)='axphi                 , 0.0  0.0 0.0  0.1'
       strth(jh+6,1)='omega                 , 0.0  0.0 0.0  0.1'
       strth(jh+4,2)='axtheta                  4    1 0 0 '
       strth(jh+5,2)='axphi                    5    0 1 0 '
       strth(jh+6,2)='omega                    6    0 0 1 '
      
       jm=jm+2
       jh=jh+6
      else if(l_jth.gt.3) then
       strtm(jm+1,1)='orientation_x,z            , 4 4'
       strtm(jm+1,2)='x,z orientation of the sample in the lab'
       strth(jh+1,1)='x_theta              , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='x_phi                , 0.0  0.0 0.0  1.0'
       strth(jh+3,1)='z_theta              , 0.0  0.0 0.0  1.0'
       strth(jh+4,1)='z_phi                , 0.0  0.0 0.0 1.0'
       strth(jh+1,2)='x_theta                  7    1 0 0 0 '
       strth(jh+2,2)='x_phi                    8    0 1 0 0 '
       strth(jh+3,2)='z_theta                  9    0 0 1 0 '
       strth(jh+4,2)='z_phi                    10    0 0 0 1 '
       jm=jm+1
       jh=jh+4

      end if
       
      strtm(jm+1,1)='#end#  10 '
      strtm(jm+2,1)='#beg#'
      

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      return
      end
      


      

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
