/* Common blocks from Mosfun for use with XMOSPLO */
#pragma extern_model common_block

#define g77
#ifdef g77
#define plot_exita plot_exita__
#define plot_exit plot_exit__
#define plot plot_
#define win win_
#define wptr wptr_
#define xmosplo xmosplo_
#define updatetst updatetst_
#define updatefit updatefit_
#endif

#define VERSION "10-Jan-1994"

#define MAXSP 32
#define MAXSUB 8
#define MAXN   1024
#define MAXSUBN (MAXSUB*MAXN)
#define MAXPLOT (MAXSUB+6)
#define MDBPLFT (MAXN*72)
#define IDUMPLOT (MDBPLFT*2-12*MAXN-MAXSUBN-MAXN-5*MAXPLOT-70)
/* fortran units for main program */

extern struct plot{
      double xd[MAXN],yd[MAXN],yderr[MAXN],yres[MAXN],
             xt[MAXN],yt[MAXN];
      float  plotsub[MAXSUBN];
      int    idat[MAXN],npntplot[MAXPLOT],nchanplot[MAXPLOT],n_subspectra;
      char   namechan[4][MAXPLOT],kform[8][MAXPLOT],axisformat[16][3],
             axes[24][3],title[132];
      int    idumpl[IDUMPLOT];
} plot;

extern struct win{
      int    ksphandle,hold,whandle[MAXSP],sizex[MAXSP],sizey[MAXSP],
             posx[MAXSP],posy[MAXSP];
  char   wdescript[80];
} win;

extern struct wptr{
 long int  intptr[MAXSP];
} wptr;

