      subroutine euler
      include 'comglb.for'
      integer      i_array,icarr,irarr
      real         r_array,out,uveca,uvecb,uvec,uvec1,uvec2,uvec3,hi,dj,
     &             ax_theta,ax_phi,omega,oalpha,obeta,ogamma,omx,omy,omz
      complex hc,dj1,dj2,d21
      character*132 helpar,queryar,chin,chcom,ch132,cp132,querytype,
     &              ext*16,ch80*80,ch1*1,eai*3,ebi*3,ch2*2,c_array*4
      parameter (icarr=mc_scrd-2*maxcom*33-4*maxcom-5*33-22,
     &           irarr=mr_scrd-32-18-12-122-56)
      common/scrd/ i_array(mi_scrd),
     &             out(32),uveca(3,3),uvecb(3,3),uvec(3),
     &             uvec1(3),uvec2(3),uvec3(3),dj(-5:5,-5:5),hi,hc,
     &             dj1(-1:1,-1:1),dj2(-1:1,-1:1),d21(-1:1,-1:1),
     &             r_array(irarr),
     &             helpar(maxcom),queryar(maxcom),ext(maxcom),       ! charact
     &             chin,chcom,ch132,cp132,querytype,
     &             ch80,eai(3),ebi(3),ch2,c_array(icarr)



      do k=1,3
       do j=1,3
        uvecb(k,j)=0.0
       end do
      end do
      do k=1,3
       do j=1,3
        uveca(k,j)=0.0
       end do
      end do

      eai(1)='eax'
      eai(2)='eay'
      eai(3)='eaz'
      ebi(1)='ebx'
      ebi(2)='eby'
      ebi(3)='ebz'

      pi=4.0*atan(1.0)
      rad=pi/180.0


 5    lq=8
       lk=lq
       do k=1,lq
        ext(k)=' '
       end do
       ch80='unit'
       ch80(80:80)='#'
       helpar(1)='effi/read/angle/euler'
       helpar(2)='effi/read/angle/unitvectors'
       helpar(3)='effi/read/angle/rotationaxes'
       helpar(4)='effi/read/angle/product'
       helpar(5)='effi/read/angle/invers'
       helpar(7)='effi/read/angle/trans_rot'
       helpar(7)='effi/read/angle/rot_from_trans'
       helpar(7)='effi/read/angle/rot_from_2rot'

       queryar(1)='1 Euler angles from unit vectors'
       queryar(2)='2 unit vectors from Euler angles'
       queryar(3)='3 Euler angles for rotation '
       queryar(4)='4 Euler angles for a sequence of two transformations'
       queryar(5)='5 Euler angles of invers transformation'
       queryar(6)='6 Euler angles for invers transf. + invers rot.'
       queryar(7)='7 rotation from Euler angles'
       queryar(8)='8 rotation from a sequence of two rotations'
       chin='Euler angle/unitvectors'
       call query(lq,lk,chin,ch80)
       if(lq.eq.0) return
       if(lq.eq.1) goto 10
       if(lq.eq.3) goto 30
       if(lq.eq.4) goto 40
       if(lq.eq.5) goto 50
       if(lq.eq.6) goto 60
       if(lq.eq.7) goto 70
       if(lq.eq.8) goto 80

       querytype='Three Euler angles (alpha,beta,gamma):'
       chcom='effi/read/euler_angles'
       ch132='0,0,0'
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
       ch1=ch132(1:1)
       if(ch1.eq.'*'.or.ch1.eq.'q') return

       call trlch(80,ch132,nn,out)
       if(nn.ne.3) goto 5
       alpha=out(1)*rad
       beta=out(2)*rad
       gamma=out(3)*rad
       c2=cos(beta/2)**2
       s2=1.0-c2
       cp=cos(alpha+gamma)
       sp=sin(alpha+gamma)
       cm=cos(alpha-gamma)
       sm=sin(alpha-gamma)

       uvecb(1,1)= c2*cp-s2*cm
       uvecb(1,2)= c2*sp-s2*sm
       uvecb(1,3)=-sin(beta)*cos(gamma)

       uvecb(2,1)=-c2*sp-s2*sm
       uvecb(2,2)= c2*cp+s2*cm
       uvecb(2,3)= sin(beta)*sin(gamma)

       uvecb(3,1)= sin(beta)*cos(alpha)
       uvecb(3,2)= sin(beta)*sin(alpha)
       uvecb(3,3)= cos(beta)

       write(nwr,'(/,a)') 'unit vectors of system Sb in S'
      do k=1,3
       write(nwr,'(6x,a3,a,3(f8.3,a1))')ebi(k),'=(',
     &            uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
      end do


       write(nwr,'(/,a)')
     & 'polar angles (theta,phi) of unit vectors of system Sb in S'
       do k=1,3
        theta=arcos(uvecb(k,3))
        h=1.0-uvecb(k,3)**2
        if(h.le.0.0) then
         phi=0.0
        else
         h=sqrt(h)
         phi=arcos(uvecb(k,1)/h)
         if(uvecb(k,2).lt.0) phi=2.0*pi-phi
        end if
        write(nwr,'(6x,a3,a,2(f8.3,a1))')ebi(k),'=(',
     &            theta/rad,',',phi/rad,')'
       end do

      return
 30   continue                  ! rotation ange
       querytype='rotation axes (theta,phi) and rotation angle (omega):'
       chcom='effi/read/rotation_axes'
       ch132='54.7356,45.0,120.0'
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
       ch1=ch132(1:1)
       if(ch1.eq.'*'.or.ch1.eq.'q') return

       call trlch(80,ch132,nn,out)
       if(nn.ne.3) goto 10
       alpha=out(2)*rad
       beta=out(1)*rad
       gamma=out(3)*rad
       do k=1,3
        do i=1,3
        uveca(i,k)=0.0
        end do
       end do
       uveca(1,1)=1.
       uveca(2,2)=1.
       uveca(3,3)=1.
       cosa=cos(alpha)
       sina=sin(alpha)
       cosb=cos(beta)
       sinb=sin(beta)

       cosg=cos(gamma)
       sing=sin(gamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
       
       uvecb(1,1)=dx**2*omcosg +cosg
       uvecb(1,2)=dx*dy*omcosg+dz*sing
       uvecb(1,3)=dx*dz*omcosg-dy*sing

       uvecb(2,1)=dx*dy*omcosg-dz*sing
       uvecb(2,2)=dy**2*omcosg+cosg
       uvecb(2,3)=dz*dy*omcosg+dx*sing

       uvecb(3,1)=dx*dz*omcosg+dy*sing
       uvecb(3,2)=dy*dz*omcosg-dx*sing
       uvecb(3,3)=dz**2*omcosg+cosg

       goto 100
 40    j=1
 41    if(j.eq.1) then
       querytype='Three Euler angles (alpha,beta,gamma) 1. rotation:'
       else
       querytype='Three Euler angles (alpha,beta,gamma) 2. rotation:'
       end if
       chcom='effi/read/euler_angles'
       ch132='0,0,0'
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
       ch1=ch132(1:1)
       if(ch1.eq.'*'.or.ch1.eq.'q') return
       call trlch(80,ch132,nn,out)
       if(nn.ne.3) goto 41
       alpha=out(1)
       beta=out(2)
       gamma=out(3)
       if(j.eq.1) then
        call dewigner(1,beta*rad,dj)
        do m=-1,1
         do n=-1,1
          fn=float(n)*gamma*rad
          fm=float(m)*alpha*rad
          dj1(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
        end do
        j=j+1
        goto 41
       else
        call dewigner(1,beta*rad,dj)
        do m=-1,1
         do n=-1,1
          fn=float(n)*gamma*rad
          fm=float(m)*alpha*rad
          dj2(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
        end do
       end if

        do m=-1,1
         do n=-1,1
          hc=(0.,0.)
          do k=-1,1
           hc=hc+dj2(m,k)*dj1(k,n)
          end do
          d21(m,n)=hc
         end do
        end do
       uveca(1,1)=1.
       uveca(2,2)=1.
       uveca(3,3)=1.

       uvecb(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
       uvecb(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
       uvecb(1,3)=-1./sqrt(2.)*real(d21(0,1)-d21(0,-1))

       uvecb(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
       uvecb(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
       uvecb(2,3)=-1./sqrt(2.)*aimag(d21(0,1)+d21(0,-1))

       uvecb(3,1)=-1./sqrt(2.)*real(d21(1,0)-d21(-1,0))
       uvecb(3,2)=1./sqrt(2.)*aimag(d21(1,0)+d21(-1,0))
       uvecb(3,3)=real(d21(0,0))
       goto 100
 50    continue
       querytype='Three Euler angles (alpha,beta,gamma) of rotation:'
       chcom='effi/read/euler_angles'
       ch132='0,0,0'
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
       ch1=ch132(1:1)
       if(ch1.eq.'*'.or.ch1.eq.'q') return

       call trlch(80,ch132,nn,out)
       if(nn.ne.3) goto 5
       alpha=out(1)
       beta=out(2)
       gamma=out(3)
       call dewigner(1,beta*rad,dj)
       do m=-1,1
        do n=-1,1
         fn=float(n)*gamma*rad
         fm=float(m)*alpha*rad
         d21(n,m)=cmplx(cos(fm+fn),sin(fm+fn))*dj(m,n)        
        end do
       end do
       uveca(1,1)=1.
       uveca(2,2)=1.
       uveca(3,3)=1.

       uvecb(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
       uvecb(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
       uvecb(1,3)=-1./sqrt(2.)*real(d21(0,1)-d21(0,-1))

       uvecb(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
       uvecb(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
       uvecb(2,3)=-1./sqrt(2.)*aimag(d21(0,1)+d21(0,-1))

       uvecb(3,1)=-1./sqrt(2.)*real(d21(1,0)-d21(-1,0))
       uvecb(3,2)=1./sqrt(2.)*aimag(d21(1,0)+d21(-1,0))
       uvecb(3,3)=real(d21(0,0))
       goto 100

 10    lq=3
       lk=lq
       do k=1,lq
        ext(k)=' '
       end do
       ch80='unit'
       ch80(80:80)='#'
       helpar(1)='effi/read/angle/abS'
       helpar(2)='effi/read/angle/bSa'
       helpar(3)='effi/read/angle/aSb'
       queryar(1)='unit vectors eb(n),ea(m) in system S '
       queryar(2)='unit vectors eb(n) in system Sa'
       queryar(3)='unit vectors ea(n) in system Sb'
       chin='Euler angle: eb(n)=Sum;m ea(m)D1,mn(alpha,beta,gamma)'
       call query(lq,lk,chin,ch80)
       if(lq.eq.0) return

       lp=2
       lj=lp
       do k=1,lp
        ext(k)=' '
       end do
       ch80='unit'
       ch80(80:80)='#'
       helpar(1)='effi/read/unitvector/numbers'
       helpar(2)='effi/read/unitvector/angle'
       queryar(1)='unit vectors:(*,y,z),(x,*,z) or (x,y,*)'
       queryar(2)='unit vectors: beta,phi'
       chin='unit vectors representation'
       call query(lp,lj,chin,ch80)
       if(lp.eq.0) return


       if(lp.eq.1) then
        if(lq.eq.1) then
         querytype='two pairs of unitvectors:'
         chcom='effi/read/unitvectors/format11'
         ch132='eax=(1,0,*) eaz=(*,0,1) ebx=(1,0,*) ebz=(*,0,1)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
        else if(lq.eq.2) then
         querytype='one pairs of unitvectors:'
         chcom='effi/read/unitvectors/format12'
         ch132='ebx=(1,0,*) ebz=(*,0,1)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
        else if(lq.eq.3) then
         querytype='one pairs of unitvectors:'
         chcom='effi/read/unitvectors/format13'
         ch132='eax=(1,0,*) eaz=(*,0,1)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
        end if
       else if(lp.eq.2) then
        if(lq.eq.1) then
         querytype='two pairs of unitvectors:'
         chcom='effi/read/unitvectors/format21'
         ch132='eax=(90,0) eaz=(0,0) ebx=(90,0) ebz=(0,0)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
        else if(lq.eq.2) then
         querytype='one pairs of unitvectors:'
         chcom='effi/read/unitvectors/format22'
         ch132='ebx=(90,0) ebz=(0,0)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
        else if(lq.eq.3) then
         querytype='one pairs of unitvectors:'
         chcom='effi/read/unitvectors/format23'
         ch132='eax=(90,0) eaz=(0,0)'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
        end if
       end if

c      evaluation of ch132
       if(lp.eq.1) then
        if(lq.eq.1) then
c        ch132='eax=(1,0,*) eaz=(*,0,1) ebx=(1,0,*) ebz=(*,0,1)'
         iax=index(ch132,'eax')
         iay=index(ch132,'eay')
         iaz=index(ch132,'eaz')
         ibx=index(ch132,'ebx')
         iby=index(ch132,'eby')
         ibz=index(ch132,'ebz')


        else if(lq.eq.2) then
c        ch132='ebx=(1,0,*) ebz=(*,0,1)'
         do k=1,3
          do i=1,3
           uveca(k,1)=0.0
          end do
          uveca(k,k)=1.0
         end do
         iax=0
         iay=0
         iaz=0
         ibx=index(ch132,'ebx')
         iby=index(ch132,'eby')
         ibz=index(ch132,'ebz')


        else if(lq.eq.3) then
c        ch132='eax=(1,0,*) eaz=(*,0,1)'
         do k=1,3
          do i=1,3
           uvecb(k,1)=0.0
          end do
          uvecb(k,k)=1.0
         end do
         iax=index(ch132,'eax')
         iay=index(ch132,'eay')
         iaz=index(ch132,'eaz')
         ibx=0
         iby=0
         ibz=0
        end if

        i3=0
        if(iax.gt.0) then
         ibc=index(ch132(iax:),')')
         cp132=ch132(iax+5:iax+ibc-2)
c         write(6,'(a,a)')'vector eax=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uveca(1,k)=uvec(k)
         end do
         i3=i3+1
        end if ! iax

        if(iay.gt.0) then
         ibc=index(ch132(iay:),')')
         cp132=ch132(iay+5:iay+ibc-2)
c         write(6,'(a,a)')'vector eay=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uveca(2,k)=uvec(k)
         end do
         i3=i3+1
        end if ! iay

        if(iaz.gt.0) then
         ibc=index(ch132(iaz:),')')
         cp132=ch132(iaz+5:iaz+ibc-2)
c         write(6,'(a,a)')'vector eaz=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uveca(3,k)=uvec(k)
         end do
         i3=i3+1
        end if ! iaz

        if(i3.lt.3.and.i3.gt.0) then
         if(i3.eq.1) then
          write(nwr,'(a)') 'at least two unit vectors ea neeeded'
          goto 10
         end if
         if(iax.gt.0.and.iay.gt.0) then
          do k=1,3
           uvec1(k)=uveca(1,k)
           uvec2(k)=uveca(2,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)

          do k=1,3
           uveca(3,k)=uvec3(k)
           uveca(2,k)=uvec2(k)
          end do
         end if
         if(iax.gt.0.and.iaz.gt.0) then
          do k=1,3
           uvec1(k)=uveca(3,k)
           uvec2(k)=uveca(1,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uveca(2,k)=uvec3(k)
           uveca(1,k)=uvec2(k)
          end do
         end if
         if(iay.gt.0.and.iaz.gt.0) then
          do k=1,3
           uvec1(k)=uveca(2,k)
           uvec2(k)=uveca(3,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uveca(1,k)=uvec3(k)
           uveca(3,k)=uvec2(k)
          end do
         end if
        end if

        i3=0
        if(ibx.gt.0) then
         ibc=index(ch132(ibx:),')')
         cp132=ch132(ibx+5:ibx+ibc-2)
c         write(6,'(a,a)')'vector ebx=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uvecb(1,k)=uvec(k)
         end do
         i3=i3+1
        end if ! ibx

        if(iby.gt.0) then
         ibc=index(ch132(iby:),')')
         cp132=ch132(iby+5:iby+ibc-2)
c         write(6,'(a,a)')'vector eby=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uvecb(2,k)=uvec(k)
         end do
         i3=i3+1
        end if ! iby

        if(ibz.gt.0) then
         ibc=index(ch132(ibz:),')')
         cp132=ch132(ibz+5:ibz+ibc-2)
c         write(6,'(a,a)')'vector ebz=',cp132(:60)
         call uvector(cp132,uvec)
         do k=1,3
          uvecb(3,k)=uvec(k)
         end do
         i3=i3+1
        end if ! ibz

        if(i3.lt.3.and.i3.gt.0) then
         if(i3.eq.1) then
          write(nwr,'(a)') 'at least two unit vectors eb neeeded'
          goto 10
         end if
         if(ibx.gt.0.and.iby.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(1,k)
           uvec2(k)=uvecb(2,k)
          end do
c         write(6,'(a,3f15.2)')'uvec1=',(uvec1(j),j=1,3)
c         write(6,'(a,3f15.2)')'uvec2=',(uvec2(j),j=1,3)
          call crospr(uvec1,uvec2,uvec3)
c         write(6,'(a,3f15.2)')'uvec3=',(uvec3(j),j=1,3)
          call crospr(uvec3,uvec1,uvec2)

          do k=1,3
           uvecb(3,k)=uvec3(k)
           uvecb(2,k)=uvec2(k)
          end do
         end if
         if(ibx.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(3,k)
           uvec2(k)=uvecb(1,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(2,k)=uvec3(k)
           uvecb(1,k)=uvec2(k)
          end do
         end if

         if(iby.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(2,k)
           uvec2(k)=uvecb(3,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(1,k)=uvec3(k)
           uvecb(3,k)=uvec2(k)
          end do
         end if
        end if

c        write(6,'(a)')'uvecb(k,j),j=1,3)'
c        do k=1,3
c         write(6,'(3f15.2)')(uvecb(k,j),j=1,3)
c        end do

       else if(lp.eq.2) then
        if(lq.eq.1) then
c        ch132='eax=(90,0) eaz=(0,0) ebx=(90,0) ebz=(0,0)'
         iax=index(ch132,'eax')
         iay=index(ch132,'eay')
         iaz=index(ch132,'eaz')
         ibx=index(ch132,'ebx')
         iby=index(ch132,'eby')
         ibz=index(ch132,'ebz')

        else if(lq.eq.2) then
c        ch132='ebx=(90,0) ebz=(0,0)'
         do k=1,3
          do i=1,3
           uveca(k,1)=0.0
          end do
          uveca(k,k)=1.0
         end do
         iax=0
         iay=0
         iaz=0
         ibx=index(ch132,'ebx')
         iby=index(ch132,'eby')
         ibz=index(ch132,'ebz')

        else if(lq.eq.3) then
c        ch132='eax=(90,0) eaz=(0,0)'
         do k=1,3
          do i=1,3
           uvecb(k,1)=0.0
          end do
          uvecb(k,k)=1.0
         end do
         iax=index(ch132,'eax')
         iay=index(ch132,'eay')
         iaz=index(ch132,'eaz')
         ibx=0
         iby=0
         ibz=0
        end if

        i3=0
        if(iax.gt.0) then
         ibc=index(ch132(iax:),')')
         cp132=ch132(iax+5:iax+ibc-2)
c         write(6,'(a,a)')'angle eax=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uveca(1,1)=st*cos(out(2)*rad)
         uveca(1,2)=st*sin(out(2)*rad)
         uveca(1,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! iax

        if(iay.gt.0) then
         ibc=index(ch132(iay:),')')
         cp132=ch132(iay+5:iay+ibc-2)
c         write(6,'(a,a)')'angle eay=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uveca(2,1)=st*cos(out(2)*rad)
         uveca(2,2)=st*sin(out(2)*rad)
         uveca(2,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! iay

        if(iaz.gt.0) then
         ibc=index(ch132(iaz:),')')
         cp132=ch132(iaz+5:iaz+ibc-2)
c         write(6,'(a,a)')'angle eaz=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uveca(3,1)=st*cos(out(2)*rad)
         uveca(3,2)=st*sin(out(2)*rad)
         uveca(3,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! iaz
c        write(6,'(a)')'uveca(k,j),j=1,3)'
c        do k=1,3
c         write(6,'(3f15.2)')(uveca(k,j),j=1,3)
c        end do

        if(i3.lt.3.and.i3.gt.0) then
         if(i3.eq.1) then
          write(nwr,'(a)') 'at least two unit vectors ea neeeded'
          goto 10
         end if
         if(iax.gt.0.and.iay.gt.0) then
          do k=1,3
           uvec1(k)=uveca(1,k)
           uvec2(k)=uveca(2,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)

          do k=1,3
           uveca(3,k)=uvec3(k)
           uveca(2,k)=uvec2(k)
          end do
         end if
         if(iax.gt.0.and.iaz.gt.0) then
          do k=1,3
           uvec1(k)=uveca(3,k)
           uvec2(k)=uveca(1,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uveca(2,k)=uvec3(k)
           uveca(1,k)=uvec2(k)
          end do
         end if
         if(iay.gt.0.and.iaz.gt.0) then
          do k=1,3
           uvec1(k)=uveca(2,k)
           uvec2(k)=uveca(3,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uveca(1,k)=uvec3(k)
           uveca(3,k)=uvec2(k)
          end do
         end if
        end if

        i3=0
        if(ibx.gt.0) then
         ibc=index(ch132(ibx:),')')
         cp132=ch132(ibx+5:ibx+ibc-2)
c         write(6,'(a,a)')'angle ebx=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uvecb(1,1)=st*cos(out(2)*rad)
         uvecb(1,2)=st*sin(out(2)*rad)
         uvecb(1,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! ibx

        if(iby.gt.0) then
         ibc=index(ch132(iby:),')')
         cp132=ch132(iby+5:iby+ibc-2)
c         write(6,'(a,a)')'angle eby=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uvecb(2,1)=st*cos(out(2)*rad)
         uvecb(2,2)=st*sin(out(2)*rad)
         uvecb(2,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! iby

        if(ibz.gt.0) then
         ibc=index(ch132(ibz:),')')
         cp132=ch132(ibz+5:ibz+ibc-2)
c         write(6,'(a,a)')'angle ebz=',cp132(:60)
         call trlch(ibc,cp132,nn,out)
         st=sin(out(1)*rad)
         uvecb(3,1)=st*cos(out(2)*rad)
         uvecb(3,2)=st*sin(out(2)*rad)
         uvecb(3,3)=cos(out(1)*rad)
         i3=i3+1
        end if ! ibz

c        write(6,'(a)')'uvecb(k,j),j=1,3)'
c        do k=1,3
c         write(6,'(3f15.2)')(uvecb(k,j),j=1,3)
c        end do

        if(i3.lt.3.and.i3.gt.0) then
         if(i3.eq.1) then
          write(nwr,'(a)') 'at least two unit vectors eb neeeded'
          goto 10
         end if
         if(ibx.gt.0.and.iby.gt.0) then

          do k=1,3
           uvec1(k)=uvecb(1,k)
           uvec2(k)=uvecb(2,k)
          end do

          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)

          do k=1,3
           uvecb(3,k)=uvec3(k)
           uvecb(2,k)=uvec2(k)
          end do
         end if
         if(ibx.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(3,k)
           uvec2(k)=uvecb(1,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(2,k)=uvec3(k)
           uvecb(1,k)=uvec2(k)
          end do
         end if
         if(iby.gt.0.and.ibz.gt.0) then
          do k=1,3
           uvec1(k)=uvecb(2,k)
           uvec2(k)=uvecb(3,k)
          end do
          call crospr(uvec1,uvec2,uvec3)
          call crospr(uvec3,uvec1,uvec2)
          do k=1,3
           uvecb(1,k)=uvec3(k)
           uvecb(3,k)=uvec2(k)
          end do
         end if
        end if


       end if

 100   continue
c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma
       h=0.0
       do k=1,3
        h=h+uveca(3,k)*uvecb(3,k)
       end do
       beta=arcos(h)
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(1,k)
        end do
        alpha=arcos(h)
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(2,k)
        end do
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(1,k)
         end do
         gamma=0.0
         alpha=arcos(-h)
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(2,k)
         end do
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(3,k)
         end do
         alpha=arcos(h/st)
         h=0.0
         do k=1,3
          h=h+uveca(2,k)*uvecb(3,k)
         end do
         if(h.lt.0.0) alpha=2.0*pi-alpha

         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(1,k)
         end do
         gamma=arcos(-h/st)
         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(2,k)
         end do
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

       write(nwr,'(/,a)') 'unit vectors of system Sa in system S'
      do k=1,3
       write(nwr,'(6x,a3,a2,3(f8.3,a1))')eai(k),'=(',
     &            uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'
      end do


       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'
      do k=1,3
       write(nwr,'(6x,a3,a2,3(f8.3,a1))')ebi(k),'=(',
     &            uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
      end do

       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     & 'Euler angles alpha,beta,gamma',
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'

 
      return
 60   continue
 
         querytype='alpha,beta,gamma:'
         chcom='effi/read/unitvectors/format11'
         ch132='90,0,0'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
         call trlch(ncl,ch132,nn,out)
         oalpha=out(1)
         obeta=out(2)
         ogamma=out(3)

        querytype='ax_theta,ax_phi,omega:'
         chcom='effi/read/unitvectors/format11'
         ch132='54.7356 45.0 120.0'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
         call trlch(ncl,ch132,nn,out)
         ax_theta=out(1)
         ax_phi=out(2)
         omega=out(3)
      write(nwr,'(a)')
      ch80=enwr(6)
      enwr(6)='yyyy'
      icase=3
      call euler_omega(ax_theta,ax_phi,omega,oalpha,obeta,ogamma,
     &                        alpha,beta,gamma,thick,icase)
      enwr(6)= ch80
      return

 70   continue
      querytype='three Euler angles (alpha,beta,gamma) of rotation:'
       chcom='effi/read/euler_angles'
       ch132='0,0,0'
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
       ch1=ch132(1:1)
       if(ch1.eq.'*'.or.ch1.eq.'q') return

       call trlch(80,ch132,nn,out)
       if(nn.ne.3) goto 70
       alpha=out(1)
       beta=out(2)
       gamma=out(3)

 71    call dewigner(1,beta*rad,dj)
       do m=-1,1
        do n=-1,1
         fn=float(n)*gamma*rad
         fm=float(m)*alpha*rad
         d21(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)        
        end do
       end do

       uvecb(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
       uvecb(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
       uvecb(1,3)=-1./sqrt(2.)*real(d21(0,1)-d21(0,-1))

       uvecb(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
       uvecb(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
       uvecb(2,3)=-1./sqrt(2.)*aimag(d21(0,1)+d21(0,-1))

       uvecb(3,1)=-1./sqrt(2.)*real(d21(1,0)-d21(-1,0))
       uvecb(3,2)=1./sqrt(2.)*aimag(d21(1,0)+d21(-1,0))
       uvecb(3,3)=real(d21(0,0))

       write(nwr,'(/,a)') '7* unit vectors of system Sb in S'
      do k=1,3
       write(nwr,'(6x,a3,a,3(f8.3,a1))')ebi(k),'=(',
     &            uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
      end do

       h=(uvecb(1,2)-uvecb(2,1))**2+(uvecb(1,3)-uvecb(3,1))**2+
     &   (uvecb(2,3)-uvecb(3,2))**2
       sino=sqrt(h/4)
       h=sqrt(abs(1.0-h/4.0))

       omega=arcos(h)
 75    continue
       if(sino.gt.0.001) then
        omx= (uvecb(2,3)-uvecb(3,2))/2.0/sino
        omy=-(uvecb(1,3)-uvecb(3,1))/2.0/sino
        omz= (uvecb(1,2)-uvecb(2,1))/2.0/sino

         omcosg=1.0-cos(omega)
        
        h= abs((uvecb(1,2)+uvecb(2,1))/2.0-omx*omy*omcosg)
     &    +abs((uvecb(1,3)+uvecb(3,1))/2.0-omx*omz*omcosg)
     &    +abs((uvecb(2,3)+uvecb(3,2))/2.0-omy*omz*omcosg)
        if(h.gt.0.001) then
         omega=pi-omega
         goto 75
        end if
       else
c       omega=0 or pi
        if(abs(uvecb(1,1)+ uvecb(2,2)+uvecb(3,3)-3).lt.0.001) then
         omega=0
         omx=0.0
         omy=0.0
         omz=1.0
        else
         omega=pi
         omx=sqrt(abs(1.0+uvecb(1,1))/2.0)
         omy=sqrt(abs(1.0+uvecb(2,2))/2.0)
         omz=sqrt(abs(1.0+uvecb(3,3))/2.0)
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        - + +
         omx=-omx
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        + - +
         omx=-omx
         omy=-omy
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        + + -
         omy=-omy
         omz=-omz
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        --+
         omx=-omx
         omy=-omy
         omz=-omz
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        -+-
         omy=-omy
         omz=-omz
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        +--
         omx=-omx
         omy=-omy
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
c        ---
         omx=-omx
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz))         
     &     +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz))
     &     +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz))
         if(h.lt.0.001) goto 72
         omega=pi-omega
         goto 75
 72      continue

        end if               
       end if


c       write(6,'(a,3f10.3)')' omx,omy,omz=',omx,omy,omz
       ax_theta=arcos(omz)
       sint=sin(ax_theta)
       if(abs(sint).lt.0.001) then
        ax_phi=0.0
       else
        ax_phi=arcos(omx/sint)
        if(omy/sint.lt.0.0) ax_phi=2.0*pi-ax_phi
       end if
       ax_theta=ax_theta/rad
       ax_phi=ax_phi/rad
       write(nwr,'(/,5x,2(a,f10.2),/,5x,a,f10.2)')
     & 'polar angel of rotation axes: theta=',ax_theta,' phi=',ax_phi,
     & 'rotation angle omega=',omega/rad

      return

 80    continue
 
        querytype='ax_theta1,ax_phi1,omega1:'
         chcom='effi/read/unitvectors/format11'
         ch132='54.7356 45.0 120.0'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
         call trlch(ncl,ch132,nn,out)
         ax_theta=out(1)
         ax_phi=out(2)
         omega=out(3)

        querytype='ax_theta2,ax_phi2,omega2:'
         chcom='effi/read/unitvectors/format11'
         ch132='54.7356 45.0 120.0'
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
         ch1=ch132(1:1)
         if(ch1.eq.'*'.or.ch1.eq.'q') return
         call trlch(ncl,ch132,nn,out)
         ax_theta2=out(1)
         ax_phi2=out(2)
         omega2=out(3)
      write(nwr,'(a)')
      call euler_omega2(ax_theta,ax_phi,omega,ax_theta2,ax_phi2,omega2,
     &                        alpha,beta,gamma )
      goto 71

      end

      real function arcos(h)

      pi2=2.0*atan(1.0)
      hh=h*h
      if(hh.ge.1) then
       arcos=0.0
       if(h.lt.0.0) arcos=2.0*pi2
      else
       s=sqrt(1.0-hh)
       if(abs(h).lt.0.0001) then
        arcos=pi2
       else
        arcos=atan(s/h)
        if(h.lt.0) arcos=2.0*pi2+arcos
       end if
      end if
      return
      end

      subroutine uvector(cp132,uvec)

      character cp132*132
      dimension uvec(3),out(32)

       call stringlength(cp132,il)
       do k=2,il-1
        if(cp132(k:k).eq.' ') then
         do i=k,il-1
          cp132(i:i)=cp132(i+1:i+1)
         end do
        end if
       end do

       ist=index(cp132,',*,')
       if(ist.gt.0) then
        cp132(ist:ist+2)='   '
        call trlch(il,cp132,nn,out)
        if(nn.lt.2) then
         write(nwr,'(a)') 'less than 2 components found for eax'
         info=1
         return
        end if
        h=out(1)**2+out(2)**2
        if(h.gt.1) then
         h=sqrt(h)
         out(1)=out(1)/h
         out(2)=out(2)/h
         out(3)=0.0
        else
         out(3)=sqrt(1.0-h)
        end if
        uvec(1)=out(1)
        uvec(2)=out(3)
        uvec(3)=out(2)
        goto 100
       end if

       ist=index(cp132,'*,')
       if(ist.gt.0) then
        cp132(ist:ist+1)='   '
        call trlch(il,cp132,nn,out)
        if(nn.lt.2) then
         write(nwr,'(a)') 'less than 2 components found for eax'
         info=1
         return
        end if
        h=out(1)**2+out(2)**2
        if(h.gt.1) then
         h=sqrt(h)
         out(1)=out(1)/h
         out(2)=out(2)/h
         out(3)=0.0
        else
         out(3)=sqrt(1.0-h)
        end if
        uvec(1)=out(3)
        uvec(2)=out(1)
        uvec(3)=out(2)
        goto 100
       end if

       ist=index(cp132,',*')
       if(ist.gt.0) then
        cp132(ist:ist+1)='   '
        call trlch(il,cp132,nn,out)
        if(nn.lt.2) then
         write(nwr,'(a)') 'less than 2 components found for eax'
         info=1
         return
        end if
        h=out(1)**2+out(2)**2
        if(h.gt.1) then
         h=sqrt(h)
         out(1)=out(1)/h
         out(2)=out(2)/h
         out(3)=0.0
        else
         out(3)=sqrt(1.0-h)
        end if
        uvec(1)=out(1)
        uvec(2)=out(2)
        uvec(3)=out(3)
        goto 100
       end if

       call trlch(il,cp132,nn,out)
       uvec(1)=out(1)
       uvec(2)=out(2)
       uvec(3)=out(3)
 100  continue
      return
      end

      subroutine crospr(uvec1,uvec2,uvec3)
      dimension uvec1(3),uvec2(3),uvec3(3)

      uvec3(1)= uvec1(2)*uvec2(3)-uvec1(3)*uvec2(2)
      uvec3(2)=-uvec1(1)*uvec2(3)+uvec1(3)*uvec2(1)
      uvec3(3)= uvec1(1)*uvec2(2)-uvec1(2)*uvec2(1)
      h=0.0
      do k=1,3
       h=h+ uvec3(k)**2
      end do
      h=sqrt(h)
      do k=1,3
       uvec3(k)=uvec3(k)/h
      end do
c      write(6,'(3f12.3)')(uvec1(k),k=1,3)
c      write(6,'(3f12.3)')(uvec2(k),k=1,3)
c      write(6,'(3f12.3)')(uvec3(k),k=1,3)
      return
      end

       subroutine euler_omega(ax_theta,ax_phi,omega,oalpha,obeta,ogamma,
     &                        alpha,beta,gamma,thickness,case)
       include 'comglb.for'
       integer case
       real ax_theta,ax_phi,omega,oalpha,obeta,ogamma,alpha,beta,gamma,
     &      thickness
       real uveca(3,3),uvecb(3,3),dj(-5:5,-5:5),uvec(3,3)
       complex d21(-1:1,-1:1)      
       parameter (pi=3.141592654,rad=0.017453293)
       character*6 eai(3),ebi(3),text(3)*8
       logical b_error

c       write(6,'(a,3f10.1)')' alpha,beta,gamma=',oalpha,obeta,ogamma 
c      oalpha,obeta,ogamma is the transformation of the crystal system to the 
c      absorber system. 
c      omega rotation around the axis ax_theta,ax_phi in the absorbersystem

       call dewigner(1,obeta*rad,dj)
       do m=-1,1
        do n=-1,1
         fn=float(n)*ogamma*rad
         fm=float(m)*oalpha*rad
         d21(n,m)=cmplx(cos(fm+fn),sin(fm+fn))*dj(m,n)        
        end do
       end do

       uveca(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
       uveca(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
       uveca(1,3)=-1./sqrt(2.)*real(d21(0,1)-d21(0,-1))

       uveca(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
       uveca(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
       uveca(2,3)=-1./sqrt(2.)*aimag(d21(0,1)+d21(0,-1))

       uveca(3,1)=-1./sqrt(2.)*real(d21(1,0)-d21(-1,0))
       uveca(3,2)=1./sqrt(2.)*aimag(d21(1,0)+d21(-1,0))
       uveca(3,3)=real(d21(0,0))


       xalpha=ax_phi*rad
       xbeta=ax_theta*rad
       xgamma=omega*rad

       cosa=cos(xalpha)
       sina=sin(xalpha)
       cosb=cos(xbeta)
       sinb=sin(xbeta)

       cosg=cos(xgamma)
       sing=sin(xgamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
        

       uvecb(1,1)=dx**2*omcosg +cosg
       uvecb(1,2)=dx*dy*omcosg+dz*sing
       uvecb(1,3)=dx*dz*omcosg-dy*sing

       uvecb(2,1)=dx*dy*omcosg-dz*sing
       uvecb(2,2)=dy**2*omcosg+cosg
       uvecb(2,3)=dz*dy*omcosg+dx*sing

       uvecb(3,1)=dx*dz*omcosg+dy*sing
       uvecb(3,2)=dy*dz*omcosg-dx*sing
       uvecb(3,3)=dz**2*omcosg+cosg

c       zeta=arcos(uvecb(3,3)) is the angle between old and new z-axes
c       1/cos(zeta) > 1 is the increase of the thickness of the 
c       absorber with respect to the  g-direction parallel to the old z-axis 
       b_error=.false.
       if(abs(uvecb(3,3)).lt.0.001.and.case.eq.3) then
        write(nwr,'(a)')' orientation of the scatterer is such that',
     &  ' the z-axis lies in the plan of the scatterer'
        b_error=.true.
       else
        if(case.eq.3) thickness=1./abs(uvecb(3,3)) 
       end if          

       do k=1,3
        do i=1,3
         uvec(i,k)=uvecb(k,i)
        end do
       end do
      do k=1,3
       do i=1,3
         uvecb(k,i)=uvec(k,i)
        end do
       end do

c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma

       h=0.0
       do k=1,3
        h=h+uveca(3,k)*uvecb(3,k)
       end do
       beta=arcos(h)
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(1,k)
        end do
        alpha=arcos(h)
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(2,k)
        end do
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(1,k)
         end do
         gamma=0.0
         alpha=arcos(-h)
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(2,k)
         end do
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(3,k)
         end do
         alpha=arcos(h/st)
         h=0.0
         do k=1,3
          h=h+uveca(2,k)*uvecb(3,k)
         end do
         if(h.lt.0.0) alpha=2.0*pi-alpha

         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(1,k)
         end do
         gamma=arcos(-h/st)
         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(2,k)
         end do
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

c       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'
c      caution! vector a is the transpose matrix in order to print the 
c      unit vectors of the rotatet system in the original system.

      if(enwr(7).eq.'yyyy'.or.b_error) then       
       write(nwr,'(/,a,/,3(a,f10.2))') 
     &              'unit vectors of system Sa and system Sb',
     & ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega

       eai(1)='     x'
       eai(2)='eC = y'
       eai(3)='     z'
       ebi(1)='     x'
       ebi(2)='ra = y'
       ebi(3)='     z'
       text(1)=' in the '
       text(2)=' Lab.   '
       text(3)=' system '

        do k=1,3
         write(nwr,'(a8,x,2(a6,a3,3(f7.3,a1),3x))') text(k),
     &   eai(k),' ( ',uveca(k,1),',',uveca(k,2),',',uveca(k,3),')',
     &   ebi(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
        end do
        write(nwr,'(a)')

        write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     &  'Euler angles alpha,beta,gamma',
     &  'eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'
        if(b_error) then
         write(nwr,'(a,g10.4,a)')'the value of thickness=',thickness,
     &   ' is set to 1.0'
         thickness=1.0
        end if
       end if
       return 
       end

       subroutine  euler_dir(x_theta,x_phi,z_theta,z_phi,
     &                        alpha,beta,gamma,thickness)
       include 'comglb.for'

       real uveca(3,3),uvecb(3,3),uvec1(3),uvec2(3),uvec3(3)
  
       parameter (pi=3.141592654,rad=0.017453293)
       character*3 eai(3),ebi(3)
       logical b_error

         st=sin(x_theta*rad)
         uvecb(1,1)=st*cos(x_phi*rad)
         uvecb(1,2)=st*sin(x_phi*rad)
         uvecb(1,3)=cos(x_theta*rad)


         st=sin(z_theta*rad)
         uvecb(3,1)=st*cos(z_phi*rad)
         uvecb(3,2)=st*sin(z_phi*rad)
         uvecb(3,3)=cos(z_theta*rad)

c       zeta=arcos(uvecb(3,3)) is the angle between old and new z-axes
c       1/ uvecb(3,3)> 1 is the increase of the thickness of the 
c       absorber with respect to the  g-direction parallel to the old z-axis 
       b_error=.false.
       thickness=1./abs(uvecb(3,3)) 
       if(thickness.gt.100) then
        write(nwr,'(a)')' orientation of the scatterer is such that',
     &  ' the z-axis lies in the plan of the scatterer'
        b_error=.true.
       end if          

         do k=1,3
          uvec1(k)=uvecb(3,k)
          uvec2(k)=uvecb(1,k)
         end do
         call crospr(uvec1,uvec2,uvec3)
         do k=1,3
          uvecb(2,k)=uvec3(k)
         end do



c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma

       beta=arcos(uvecb(3,3))
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        alpha=arcos(uvecb(1,1))
        h=uvecb(2,1)
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=uvecb(1,1)
         gamma=0.0
         alpha=arcos(-h)
         h=uvecb(2,1)
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=uvecb(3,1)
         alpha=arcos(h/st)
         h=uvecb(3,2)
         if(h.lt.0.0) alpha=2.0*pi-alpha
         h=uvecb(1,3)
         gamma=arcos(-h/st)
         h=uvecb(2,3)
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

      if(enwr(6).eq.'yyyy'.or.b_error) then       
       
       write(nwr,'(/,a,/,3(a,f10.2))') 
     &              'unit vectors of system Sb in system S',
     & ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega
       eai(1)='eax'
       eai(2)='eay'
       eai(3)='eaz'
       ebi(1)='ebx'
       ebi(2)='eby'  
       ebi(3)='ebz'
      do k=1,3
       write(nwr,'(6x,a3,a2,3(f8.3,a1))')ebi(k),'=(',
     &            uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
      end do

       write(nwr,'(/,a)') 'unit vectors of system Sa in system S'
      do k=1,3
       write(nwr,'(6x,a3,a2,3(f8.3,a1))')eai(k),'=(',
     &            uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'
      end do

       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     & 'Euler angles alpha,beta,gamma',
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'

        if(b_error) then
         write(nwr,'(a,g10.4,a)')'the value of thickness=',thickness,
     &   ' is set to 1.0'
         thickness=1.0
        end if

       end if
       return
       end


       subroutine euler_omega2(ax_theta,ax_phi,omega,
     &                         ax_theta2,ax_phi2,omega2,
     &                        alpha,beta,gamma )
       include 'comglb.for'

       real uveca(3,3),uvecb(3,3),uvec(3,3)
       parameter (pi=3.141592654,rad=0.017453293)
       character*6 eai(3),ebi(3),text(3)*8

       xalpha=ax_phi2*rad
       xbeta=ax_theta2*rad
       xgamma=omega2*rad

       cosa=cos(xalpha)
       sina=sin(xalpha)
       cosb=cos(xbeta)
       sinb=sin(xbeta)

       cosg=cos(xgamma)
       sing=sin(xgamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
        
       uveca(1,1)=dx**2*omcosg +cosg
       uveca(1,2)=dx*dy*omcosg+dz*sing
       uveca(1,3)=dx*dz*omcosg-dy*sing

       uveca(2,1)=dx*dy*omcosg-dz*sing
       uveca(2,2)=dy**2*omcosg+cosg
       uveca(2,3)=dz*dy*omcosg+dx*sing

       uveca(3,1)=dx*dz*omcosg+dy*sing
       uveca(3,2)=dy*dz*omcosg-dx*sing
       uveca(3,3)=dz**2*omcosg+cosg



       do k=1,3
        do i=1,3
         uvec(i,k)=uveca(k,i)
        end do
       end do
       do k=1,3
        do i=1,3
         uveca(k,i)=uvec(k,i)
        end do
       end do



       xalpha=ax_phi*rad
       xbeta=ax_theta*rad
       xgamma=omega*rad

       cosa=cos(xalpha)
       sina=sin(xalpha)
       cosb=cos(xbeta)
       sinb=sin(xbeta)

       cosg=cos(xgamma)
       sing=sin(xgamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
        
       uvecb(1,1)=dx**2*omcosg +cosg
       uvecb(1,2)=dx*dy*omcosg+dz*sing
       uvecb(1,3)=dx*dz*omcosg-dy*sing

       uvecb(2,1)=dx*dy*omcosg-dz*sing
       uvecb(2,2)=dy**2*omcosg+cosg
       uvecb(2,3)=dz*dy*omcosg+dx*sing

       uvecb(3,1)=dx*dz*omcosg+dy*sing
       uvecb(3,2)=dy*dz*omcosg-dx*sing
       uvecb(3,3)=dz**2*omcosg+cosg

c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma

       h=0.0
       do k=1,3
        h=h+uveca(3,k)*uvecb(3,k)
       end do
       beta=arcos(h)
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(1,k)
        end do
        alpha=arcos(h)
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(2,k)
        end do
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(1,k)
         end do
         gamma=0.0
         alpha=arcos(-h)
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(2,k)
         end do
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(3,k)
         end do
         alpha=arcos(h/st)
         h=0.0
         do k=1,3
          h=h+uveca(2,k)*uvecb(3,k)
         end do
         if(h.lt.0.0) alpha=2.0*pi-alpha

         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(1,k)
         end do
         gamma=arcos(-h/st)
         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(2,k)
         end do
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

      eai(1)='     x'
      eai(2)='e1 = y'
      eai(3)='     z'
      ebi(1)='     x'
      ebi(2)='e2 = y'
      ebi(3)='     z'
      text(1)='        '
      text(2)='        '
      text(3)='        '
c       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'
c      caution! vector a is the transpose matrix in order to print the 
c      unit vectors of the rotatet system in the original system.

       do k=1,3
        write(nwr,'(a8,x,2(a6,a3,3(f7.3,a1),3x))') text(k),
     &  eai(k),' ( ',uveca(k,1),',',uveca(k,2),',',uveca(k,3),')',
     &  ebi(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
       end do
       write(nwr,'(a)')

       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     & 'Euler angles alpha,beta,gamma',
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'

        return 
        end

