      subroutine gethdb(ihdb,nhandbook)
      character nhandbook*32

      if(ihdb.eq.0) then
       if(nhandbook.eq.'nucleus.hdb') then
         ihdb=1
       else if(nhandbook.eq.'material.hdb') then
         ihdb=2
       end if
      else
       if(ihdb.eq.1) then
         nhandbook='nucleus.hdb'
       else if(ihdb.eq.2) then
        nhandbook='material.hdb'
       end if
      end if
      return
      end



      subroutine getfrstring(nfrtheo,l_nfrtheo,lstruct1,lstruct2,
     &                                              cmch,property)
      character cmch*4,property*132

c       write(6,'(a,i2,3(a,i2),/,2a)')'getfrstring  nfrtheo=',nfrtheo,
c     &  ' l_nfrtheo=',l_nfrtheo,' lstruct1=',lstruct1,
c     &   ' lstruct2=',lstruct2,' property=',property(1:60)   

       i0=ichar('0')
       i10=nfrtheo/10
       i1=nfrtheo-10*i10
       property(1:2)=char(i10+i0)//char(i1+i0)
       i10=l_nfrtheo/10
       i1=l_nfrtheo-10*i10
       property(3:6)=char(i10+i0)//char(i1+i0)//'  '

       if(nfrtheo.eq.1) then
        call frstr_stroboscopy(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
       else if(nfrtheo.eq.2) then
        call frstr_synchrotron(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
       else if(nfrtheo.eq.3) then
        call frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
       else if(nfrtheo.eq.4) then
        call frstr_neutron(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
      end if
      nfrtheo=4            ! loop nfrtheo will end at nfrtheo instead 
c                          ! at maxs=16
      return
      end

      subroutine distribthfr(iframe,cmch,iss,info)
      character cmch*4
c      write(6,'(a,i4)') ' distribthfr iframe=',iframe     
c       write(6,'(a,i2,a,a4,a,i2)')'distribthfr   iframe=',iframe,
c     &  ' cmch=',cmch,' iss=',iss

      if(iframe.eq.1) then
       call fr_stroboscopy(cmch,iss,info)
      else if(iframe.eq.2) then
       call fr_synchrotron(cmch,iss,info)
      else if(iframe.eq.3) then
       call fr_mossbauer(cmch,iss,info)
      else if(iframe.eq.4) then
       call fr_neutron(cmch,iss,info)
      end if
      iframe=4
      return
      end



      subroutine getthstring(jth,l_jth,cmch,property)
      character property*132,cmch*4

c      write(6,'(2(a,i4),2a)') ' getthstring jth=',jth,' l_jth=',l_jth,
c     &                        ' cmch=',cmch
       i0=ichar('0')
       i10=jth/10
       i1=jth-10*i10
       property(1:2)=char(i10+i0)//char(i1+i0)
       i10=l_jth/10
       i1=l_jth-10*i10
       property(3:6)=char(i10+i0)//char(i1+i0)//'  '

       if(jth.eq.1) then 
        call thstr_11indexmoss(l_jth,cmch,property)
       else if(jth.eq.2) then
        call thstr_11index(l_jth,cmch,property)
       else if(jth.eq.3) then
        call thstr_relaxhalfintegral(l_jth,cmch,property)
       else if(jth.eq.4) then
        call thstr_lines126(l_jth,cmch,property)
       else if(jth.eq.5) then
        call thstr_hdeqmiscil(l_jth,cmch,property)
       else if(jth.eq.6) then
        call thstr_22indexmoss(l_jth,cmch,property)
       else if(jth.eq.7) then
        call thstr_22indexfmoss(l_jth,cmch,property)
       else if(jth.eq.8) then
        call thstr_22index(l_jth,cmch,property)
       else if(jth.eq.9) then
        call thstr_hdeq(l_jth,cmch,property)
       else if(jth.eq.10) then
        call thstr_hdeqf(l_jth,cmch,property)
       else if(jth.eq.11) then
        call thstr_mossbauer(l_jth,cmch,property)
       else if(jth.eq.12) then
        call thstr_sampleorient(l_jth,cmch,property)
       else if(jth.eq.13) then
        call thstr_synstrob(l_jth,cmch,property)
       else if(jth.eq.14) then
        call thstr_synstrobtrans(l_jth,cmch,property)
       else if(jth.eq.15) then
        call thstr_strobwindow(l_jth,cmch,property)
       else if(jth.eq.16) then
        call thstr_synstrobrefl(l_jth,cmch,property)
       else if(jth.eq.17) then
        call thstr_synsource(l_jth,cmch,property)
       else if(jth.eq.18) then
        call thstr_syntransmission(l_jth,cmch,property)
       else if(jth.eq.19) then
        call thstr_synreflection(l_jth,cmch,property)
       else if(jth.eq.20) then
        call thstr_neutron(l_jth,cmch,property)
       else if(jth.eq.21) then
        call thstr_neutronspec(l_jth,cmch,property)
       else if(jth.eq.22) then
        call thstr_neutronoffspec(l_jth,cmch,property)
      end if
       jth=22               ! neccessary
      return
      end


      subroutine distribth(isubthe_n,ntheo,icase,iput,iget,nath)
      integer isubthe_n,ntheo,icase,iput,iget
      character nath*80
c      write(6,'(a,5i4)') 'distribth isubthe_n,ntheo,icase=',
c     &                              isubthe_n,ntheo,icase
      if(ntheo.eq.1) then
       call th_22index(isubthe_n,icase,iput,iget)
       nath='th_22index'
      else if(ntheo.eq.2) then 
       call th_hdeq(isubthe_n,icase,iput,iget)
       nath='th_hdeq'
      else if(ntheo.eq.3) then
       call th_timewindows(isubthe_n,icase,iput,iget)      !
       nath='th_timewindows'
      else if(ntheo.eq.4) then
       call th_sampleorient(isubthe_n,icase,iput,iget)     !
       nath='th_sampleorient'
      else if(ntheo.eq.5) then
       call th_lines126(isubthe_n,icase,iput,iget)
       nath='th_lines126'
      else if(ntheo.eq.6) then
       call th_22indexsad(isubthe_n,icase,iput,iget)
       nath='th_22indexsad'
      else if(ntheo.eq.7) then
       call th_11indexsad(isubthe_n,icase,iput,iget)
       nath='th_11indexsad'
      else if(ntheo.eq.8) then
       call th_hdeqmiscellaneous(isubthe_n,icase,iput,iget)
       nath='th_hdeqmiscellaneous'
      else if(ntheo.eq.9) then
       call th_relaxglobalsad(isubthe_n,icase,iput,iget)
       nath='th_relaxglobalsad'
      else if(ntheo.eq.10) then
       call th_relaxspinhalfsad(isubthe_n,icase,iput,iget)
       nath='th_relaxspinhalfsad'
      else if(ntheo.eq.11) then
       call th_hdeqf(isubthe_n,icase,iput,iget)
       nath='th_hdeqf'
      else if(ntheo.eq.12) then
       call th_22indexfsad(isubthe_n,icase,iput,iget)
       nath='th_22indexfsad'
      else if(ntheo.eq.13) then
       call th_11index(isubthe_n,icase,iput,iget)
       nath='th_11index'
      else
       isubthe_n=-isubthe_n 
      end if
      ntheo=13
      return
      end



