      subroutine thstr_22indexmoss(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22index  nameth_as=',nameth_as(:40)

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='2x2 refraction index (sad)'                                   !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=2x2_ref_index_static_sad   plrs,1  nc_v_a_the=3,4,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=1    ! <=(max_nth
      nameth(1)='2x2 refraction index (static,sad)'
      nameth(2)=' '
      if(b_return) return 
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=3     ! <=max_nth
       ntheory(1)='Mossbauer transmission_3'
       ntheory(2)='Mossbauer resonance reflection_3'
       ntheory(3)='Mossbauer reemission_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    1'
                 ! LG-convolution (1) , Voigt profile (0)
       j=j+2            
       strco(j+1)='#end#  2   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567      
       strtm(jm+1,1)='Intensity               ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2                  1     1  '
        
       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                2    1  '
        
       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                 3      1 0 '
       strth(jh+4,2)='L_width                 4      0 1 '
       jm=jm+3
       jh=jh+4
        
       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if
      return
      end


      subroutine thstr_22indexfmoss(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22indexft  nameth_as=',nameth_as(:40)

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='2x2 refraction index_f (sad)'                                 !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=2x2_ref_index_static_f_sad plrs,1  nc_v_a_the=3,4,t'
c       else if(l_jth.eq.2) then
c        property=
c     &  'prop=11_refraction_index_static_sad scal,1 nc_v_a_the=0,1,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=1    ! <=(max_nth
      nameth(1)='2x2 refraction index (static,f_anisotrop,sad)'
c      nameth(2)='scalar refraction index (static)'
      nameth(2)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=max_nth
       ntheory(1)='Mossbauer transmission_ext_3'
       ntheory(2)='Mossbauer reemission_ext_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if


      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    1'
                 ! LG-convolution (1) , Voigt profile (0)
       j=j+2            
       strco(j+1)='#end#  2   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
c                     123456789012345678901234567      
       strtm(jm+1,1)='Intensity               ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2                   1     1  '
        
       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                 2    1  '
        
       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                  3      1 0 '
       strth(jh+4,2)='L_width                  4      0 1 '
       jm=jm+3
       jh=jh+4
        
       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if


      return
      end


      subroutine thstr_22index(l_jth,cmch,property)

c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22index  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='2x2 refraction index'                                  !name

      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     &   'prop=2x2_refraction_index_static   plrs,1  nc_v_a_the=2,4,t'
       else
        property=' '
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=1    ! <=(maxnth
      nameth(1)='2x2 refraction index (static)'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=7     ! <=maxnth
       ntheory(1)='stroboscopic transmission spectrum_3'
       ntheory(2)='stroboscopic reflection spectrum_3'
       ntheory(3)='stroboscopic reflection spectrum_3'
       ntheory(4)='time differential transmission spectrum_3'
       ntheory(5)='time differential reflection spectrum_3'
       ntheory(6)='time integral - rocking curve(Fourier)_3'
       ntheory(7)='time integral - rocking curve_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       j=j+1            
       strco(j+1)='#end#  1   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567      
       strtm(jm+1,1)='Intensity               ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2                  1     1  '
        
       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                2    1  '

       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                 3      1 0 '
       strth(jh+4,2)='L_width                 4      0 1 '
       jm=jm+3
       jh=jh+4       

       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if

      return
      end

