      subroutine thstr_mossbauer(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y')write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_frmossbauer  nameth_as=',nameth_as(:40)
      
       b_return=cmch.eq.'name'
      if(b_return) 
     & property='Mossbauer radioactive source (distribute)'              !name
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=5    ! <=(max_nth
      nameth(1)  ='Mossbauer transmission'
      nameth(2)  ='Mossbauer reemission'
      nameth(3)  ='Mossbauer transmission_ext'
      nameth(4)  ='Mossbauer reemission_ext'
      nameth(5)  ='Mossbauer resonance reflection'
      nameth(6)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Mossbauer radioactive source'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      return
      end
